/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expattribut.cpp                         */
/************************************************/

#include "expattribut.h"
#include <expdefine.h>
#include "noyattribut.h"
#include <cstdio>

ExpAttribut::ExpAttribut ( string type, string a , int typeMultiplicite = MULT_AGREG ){
  setCommentaire("");
  setVisibilite("-");
  setNom(a);
  setType(type);
  _typeMultiplicite=typeMultiplicite;  
  _multiplicite= "";  
}

ExpAttribut::ExpAttribut ( string type, string a , int typeMultiplicite , string multiplicite){
  setCommentaire("");
  setVisibilite("-");
  setNom(a);
  setType(type);
  _typeMultiplicite=typeMultiplicite;  
  _multiplicite=multiplicite;  
}


ExpAttribut::ExpAttribut ( Attribut *a ){
  setCommentaire(a->getDescription());
  setVisibilite(a->getVisible());
  setNom(a->getNom());
  setType(a->getType());
  _typeMultiplicite=MULT_SIMPLE;
  _multiplicite="";
}

ExpAttribut::~ExpAttribut ( ){

}



string ExpAttribut::getCpp (  ){
  string s="";

  typeConvertisseur(_type,".","::");

  if (getCommentaire()!="") {
    s+= indent(8) + "/* " + getCommentaire() + " */\n";
  }

  switch(_typeMultiplicite) {  
  case MULT_SIMPLE :
    s += indent(8) + getType() + " " + getNom() + " ;";
    break;
  case MULT_AGREG :
    s += indent(8) + getType() + " *" + getNom() + " ;";
    break;
  case MULT_AGREG_MULT:
    s += indent(8) + "std::vector<" + getType() + "*>" + " " + getNom() + " ;";
    break;
  case MULT_ASSOC:
    s += indent(8) + getType() + " *" + getNom() + " ;";
    break;
  case MULT_ASSOC_MULT:
    s += indent(8) + "std::vector<" + getType() + "*>" + " " + getNom() + " ;";
    break;
  case MULT_AGREG_INT:
    s += indent(8) + getType() + " *" + getNom() + "[" ;
    s += _multiplicite;
    s +=  "] ;";
    break;
  case MULT_ASSOC_INT:
    s += indent(8) + getType() + " *" + getNom() + "[" ;
    s += _multiplicite;
    s +=  "] ;";
    break;
  }
  
  return s;
}

string ExpAttribut::getJava (  ){
  string s="";

  typeConvertisseur(_type,"::",".");

  if (getCommentaire()!="") {
    s+= indent(4) + "/* " + getCommentaire() + " */\n";
  }

  switch(_typeMultiplicite) {  
  case MULT_SIMPLE :
    if(getVisibilite()=="") {
      s += indent(4) + getType() + " " + getNom() + " ;";
    } else {
      s += indent(4) + getVisibilite() + " " + getType() + " " + getNom() + " ;";
    }
    break;
  case MULT_AGREG :
    if(getVisibilite()=="") {
      s += indent(4) + getType() + " " + getNom() + " ;";
    } else {
      s += indent(4) + getVisibilite() + " " + getType() + " le" + getNom() + " ;";
    }
    break;
  case MULT_AGREG_MULT:
    if(getVisibilite()=="") {
      s += indent(4) + "Vector " + getType()  + " " + getNom() + " = new Vector() ;";
    } else {
      s += indent(4) + getVisibilite() + " " + "Vector " + getNom() + " = new Vector() ;";
    }
    break;
  case MULT_ASSOC:
    if(getVisibilite()=="") {
      s += indent(4) +  getType() + "  " + getNom() + " ;";
    } else {
      s += indent(4) + getVisibilite() + " " + getType() + " " + getNom() + " ;";
    }
    break;
  case MULT_ASSOC_MULT:
    if(getVisibilite()=="") {
      s += indent(4) + "Vector " + getType()  + " " + getNom() + " = new Vector() ;";
    } else {
      s += indent(4) + getVisibilite() + " " + "Vector " + getNom() + " = new Vector() ;";
    }
    break;
  case MULT_AGREG_INT:
    if(getVisibilite()=="") {
      s += indent(4) + getType()  + "[] " + getNom() + " = new " + getType() + "[";
      s += _multiplicite;
      s += "];";
    } else {
      s += indent(4) + getVisibilite() + " " +getType() + "[] " + getNom() + " = new " + getType() + "["; 
      s += _multiplicite;
      s += "];";
    }
    break;    
  case MULT_ASSOC_INT:
    if(getVisibilite()=="") {
      s += indent(4) + getType()  + "[] " + getNom() + " = new " + getType() + "[";
      s += _multiplicite;
      s += "];";
    } else {
      s += indent(4) + getVisibilite() + " " +getType() + "[] " + getNom() + " = new " + getType() + "["; 
      s += _multiplicite;
      s += "];";
    }
    break;    
  }

  return s;
}

void ExpAttribut::setCommentaire ( string contenu ){
  _commentaire = contenu;
}

string ExpAttribut::getCommentaire (  ){
  return _commentaire;
}

void ExpAttribut::setVisibilite ( string contenu ){
  string visibilite = "";
  if (Minuscules(contenu) == "public") visibilite = "public";
  if (contenu == "+") visibilite = "public";
  if (Minuscules(contenu) == "protected") visibilite = "protected";
  if (contenu == "#") visibilite = "protected";
  if (Minuscules(contenu) == "private") visibilite = "private";
  if (contenu == "-") visibilite = "private";
  _visibilite=visibilite;
}

string ExpAttribut::getVisibilite (  ){
  return _visibilite;
}

void ExpAttribut::setType ( string contenu ){
  _type=contenu;
}

string ExpAttribut::getType (  ){
  return _type;
}



void ExpAttribut::setNom ( string contenu ){
  _nom = contenu;
}

string ExpAttribut::getNom (  ){
  return _nom;
}

string ExpAttribut::indent( int num ){
  string s="";
  for(int i=0;i<num;++i) {
    s+=" ";
  }
  return s;
}

string ExpAttribut::Minuscules (string chaine) {
  unsigned int i;
  string s = "";
  for( i = 0 ; i < chaine.length() ; ++i) {
    s += tolower(chaine.at(i));
  }
  return s;
}


void ExpAttribut::typeConvertisseur(string &s,string ancDelimiteur,string nouvDelimiteur){

  string::size_type pos = 0;

  pos = s.find(ancDelimiteur);
  while(pos!=string::npos) { 
    s.erase(pos,ancDelimiteur.length());
    s.insert(pos,nouvDelimiteur);
    pos+=nouvDelimiteur.length(); // pour viter de boucler sur le dlimiteur !!
    pos = s.find(ancDelimiteur,pos);
  }
};
