/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expattribut.h                            */
/************************************************/

#ifndef EXPATTRIBUT_H
#define EXPATTRIBUT_H

#include <string>
#include <expdefine.h>

#ifndef NOYATTRIBUT_H
class Attribut ;
#endif

/** Cette classe reprsente un attribut d'une classe
 * @author A.Pique
 */
class ExpAttribut {

 private:
  //! Commentaire li  l'attribut
  string _commentaire;
  //! Visibilit de l'attribut
  string _visibilite;
  //! Type de l'attribut
  string _type;
  //! Nom de l'attribut
  string _nom;
  /** Multiciplicit de l'attribut, utilise pour les attributs gnrs par des relations
   * d'agrgation ou d'association avec multiplicit
   */
  string _multiplicite;
  /** Type de multiciplicit de l'attribut, utilise pour les attributs gnrs par des relations
   * d'agrgation ou d'association avec multiplicit
   */
  int _typeMultiplicite;

 public:
  /**
   *Constructeur
   * \param string type : type de l'attribut
   * \param string a : nom de l'attribut
   * \param int multiplicite : multiplicit de l'attribut
   */
  ExpAttribut ( string type,string a , int typeMultiplicite = MULT_AGREG );
  ExpAttribut ( string type,string a , int typeMultiplicite , string multiplicite );
  /**
   * Constructeur
   * \param Attribut * a : attribut du noyau utilis pour initialiser l'objet
   */
  ExpAttribut ( Attribut * a );
  //!Destructeur
  ~ExpAttribut ();
  /**
   * Fonction renvoyant la dclaration de l'attribut dans le .h pour l'exportation en C++
   * \return dclaration de l'attribut
   */
  string getCpp (  );
  /**
   * Fonction renvoyant la dclaration de l'attribut dans le .java pour l'exportation en Java
   * \return dclaration de l'attribut
   */
  string getJava (  );
  /**
   * Modificateur de l'attribut _commentaire
   * \param string commentaire : nouvelle valeur de commentaire
   */   
  void setCommentaire ( string contenu );
  /** Accesseur de _commentaire
   * \return Le commentaire
   */    
  string getCommentaire (  );
  /**
   * Modificateur de l'attribut _visibilite
   * \param string visibilite : nouvelle valeur de visibilite
   */  
  void setVisibilite ( string contenu );
  /** Accesseur de _visibilite
   * \return La visibilite de la methode
   */  
  string getVisibilite (  );
  /**
   * Modificateur de l'attribut _type
   * \param string type : nouvelle valeur de type
   */ 
  void setType ( string contenu );
  /**
   * Fonction permettant de crer des chanes de "num" espaces
   * \param int num : nombre d'espaces
   * \return une chane de "num" blancs
   */
  string getType (  );
  /**
   * Modificateur de l'attribut _nom
   * \param string nom : nouvelle valeur de nom
   */  
  void setNom ( string contenu );
  /** Accesseur de _nom
   * \return Le nom
   */  
  string getNom ( );
  /**
   * Fonction permettant de crer des chanes de "num" espaces
   * \param int num : nombre d'espaces
   * \return une chane de "num" blancs
   */  
  string indent( int num );
  /**
   * Fonction permettant de convertir une chane en minuscules
   * \param string chaine : chaine  convertir
   * \return la chane convertie
   */
  string Minuscules (string chaine);

  

  /**
   * Fonction permettant d'enlever l'ancien dlimiteur d'une chane et de les remplacer 
   * par un autre dlimiteur
   * \param string &s : la chane  convertir
   * \param string ancDelimiteur : l'ancien dlimiteur
   * \param string nouvDelimiteur : le nouveau dlimiteur
   */
  void typeConvertisseur(string& s,string ancDelimiteur, string nouvDelimiteur);



};

#endif

