/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:41 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expclasse.cpp                           */
/************************************************/

#include "expclasse.h"
#include "expdefine.h"
#include "noyclasse.h"
#include "noyvisiteurnoeud.h"
#include "noyrelation.h"
#include "noyutilisation.h"
#include "noyagregation.h"
#include "noyheritage.h"
#include "noyassociation.h"
#include "expinclude.h"
#include "exppaquetage.h"
#include "expexport.h"
#include "exprelation.h"
#include "exputilisation.h"
#include "expagregation.h"
#include "expheritage.h"
#include "expassociation.h"
#include "expmethode.h"
#include "expentetearg.h"
#include "expattribut.h"
#include "expparametre.h"
ExpClasse::ExpClasse ( ExpObjetFichier * pere ){
  _pere = pere;
}

ExpClasse::~ExpClasse ( ){
  _listeAttribut.clear();
  _listeEnteteArg.clear();
  _listeMethode.clear();
  _listeInclude.clear();
}

void ExpClasse::setClasse ( Classe * classe ){
  _classe = classe;
  setNom(classe->getNom());
  _paquetages = _pere->getPaquetage();
  setPepe();
  setInterface(!(classe->getTypeDeClasse())); 
  setCommentaire(classe->getDescription());
  setCartouche(classe->getNom());
  setVisibilite(classe->getVisibilite());

  _relPath = getRelPath("");


  traiterLesAttributs(classe->getVctAttribut());
  traiterLesMethodes(classe->getVctMethode());

  ajouterDestructeur();
  ajouterConstructeur();


}

int ExpClasse::getCpp (  ){

  std::vector<ExpAttribut>::iterator atIt;
  std::vector<ExpMethode>::iterator meIt;
  std::vector<ExpEnteteArg>::iterator enIt;
  std::vector<ExpInclude>::iterator inIt;

  string sHeader = (Minuscules(_nom) + ".h");
  string sCpp = (Minuscules(_nom) + ".cpp");

  /* On traite les relations ici */
  _classe->visiterFils((VisiteurNoeud *)this);
  
  
  // Cration du fichier .h
  ofstream sortieH(sHeader.c_str(),ios::out);
  if(sortieH.is_open()) {
    sortieH << getCartouche() << "\n";
    sortieH << "#ifndef " << getIfndef() << "_H" << "\n";
    sortieH << "#define " << getIfndef() << "_H" << "\n";
    sortieH <<  "\n";
    
    
    // Cration de classes "vides" redfinies plus loin dans le .cpp
    inIt=_listeInclude.begin();
    while(inIt!=_listeInclude.end()){
      if((*inIt).getHeritage() == false && (*inIt).getType()!=INC_VECTEUR) {
	sortieH << "class " <<  (*inIt).getNom() << ";" << "\n";
      } 
      if((*inIt).getType()==INC_VECTEUR) {
	sortieH <<  "#include <vector>\n";
      }
      ++inIt;
    }
    
    // Ajout des includes ncessaires  un hritage
    inIt=_listeInclude.begin();
    while(inIt!=_listeInclude.end() ){
      if((*inIt).getHeritage() == true && (*inIt).getType()!=INC_VECTEUR) {
	sortieH <<  "#include \"" << Minuscules((*inIt).getRelPath()) << ".h\"" << "\n";
      } 
      ++inIt;
    }
    
    sortieH <<  "\n";
    
    sortieH << "class " << _nom ;
    
    enIt=_listeEnteteArg.begin();
    if(enIt!=_listeEnteteArg.end() ){
      sortieH << ": public " << (*enIt).getClasse(this,"::") ;
      ++enIt;
    }
    while(enIt!=_listeEnteteArg.end() ){
      sortieH << ", public " << (*enIt).getClasse(this,"::") ;
      ++enIt;
    }
    sortieH << " { \n";
    
    for (int i=0; i<4 ; ++i) {
      string s = "";
      switch(i) {
      case 0 : 
	s = "";
	break; 
      case 1 : 
	s = "public"; 
	break;
      case 2 : 
	s = "protected"; 
	break;
      case 3 : 
	s = "private"; 
	break;
      }
      if (s!="")
	sortieH << "\n" << indent(4) << s << ":\n\n";
      
      atIt=_listeAttribut.begin();
      while(atIt!=_listeAttribut.end() ){
	if((*atIt).getVisibilite() == s )
	  sortieH << (*atIt).getCpp() << "\n";
	++atIt;
      } 
      meIt=_listeMethode.begin();
      while(meIt!=_listeMethode.end() ){
	if((*meIt).getVisibilite() == s ) {
	  sortieH << (*meIt).getEnteteCpp(getInterface());	
	}
	++meIt;
      }
    }
    sortieH <<  "};\n";
    sortieH <<  "#endif\n";
    sortieH.close();
  }
  
  // Cration du fichier .cpp
  if(!getInterface()) {
    ofstream sortieCpp(sCpp.c_str(),ios::out);

    if(sortieCpp.is_open()) {

      sortieCpp << "#include \"" << Minuscules(_nom) << ".h\"" << "\n";
      
      // Ajout des includes des classes "vides" cres dans le .h
      inIt=_listeInclude.begin();
      while(inIt!=_listeInclude.end() ){
	if((*inIt).getHeritage() == false && (*inIt).getType()!=INC_VECTEUR) {
	  sortieCpp <<  "#include \"" << Minuscules((*inIt).getRelPath()) << ".h\"" << "\n";
	}
	++inIt;
      }
      
      meIt=_listeMethode.begin();
      while(meIt!=_listeMethode.end() ){
	sortieCpp << (*meIt).getCpp(_nom) ;
	++meIt;
      }
      sortieCpp.close();
    } 
  }
  return 0;
}

int ExpClasse::getJava (  ){
  
  std::vector<ExpAttribut>::iterator atIt;
  std::vector<ExpMethode>::iterator meIt;

  std::vector<ExpInclude>::iterator inIt;

  string sJava = (_nom + ".java");


  /* On traite les relations ici */
  _classe->visiterFils((VisiteurNoeud *)this);
  
  
  // Cration du fichier .h
  ofstream sortie(sJava.c_str(),ios::out);
  if(sortie.is_open()) {  
    sortie << getCartouche() << "\n";
    
    if( getPaquetagePath(".") != "") {                          // getPaquetage()
      sortie << "package " << getPaquetagePath(".") << ";\n"; // getPaquetage()
      sortie <<  "\n";
    }
    
    
    // Ajout des includes ncessaires  un hritage
    inIt=_listeInclude.begin();
    while(inIt!=_listeInclude.end() ){
      if((*inIt).getType()!=INC_VECTEUR && (*inIt).getType()!=INC_GENERE && (*inIt).getRelPath()!=getRelPath()) {
	sortie <<  "import " << (*inIt).getPointPath() << ";\n"; 
      }
      if((*inIt).getType()==INC_VECTEUR) {
	sortie <<  "import java.util.vector;\n"; 
      }
      ++inIt;
    }
    
    sortie <<  "\n";
    
    if(_interface == false) {
      sortie <<  _visibilite << "class " << _nom << " ";
    } else {
      sortie <<  _visibilite << "interface " << _nom << " ";
    }

    sortie << getJavaEnteteArg();
    
    sortie << " { \n";
    
    atIt=_listeAttribut.begin();
    while(atIt!=_listeAttribut.end() ){
      sortie << (*atIt).getJava() << "\n";
      ++atIt;
    } 
    
    meIt=_listeMethode.begin();
    while(meIt!=_listeMethode.end() ){
      sortie << (*meIt).getJava(_interface);	
      ++meIt;
    }
    
    sortie <<  "}\n";
    sortie.close();
  }
  return 0;
}

void ExpClasse::setCommentaire ( string commentaire ){
  string s = "";
  string::size_type posComment = 0;
  string::size_type posCommentOld = 0;
    
  posComment = commentaire.find("\n",posComment);
  while(posComment != string::npos) {
    while( (posComment - posCommentOld) > 64 ) {
      s+="/* ";
      s+=commentaire.substr(posCommentOld,64);
      posCommentOld+= 64;
      s+=" */\n";
    }
    s+="/* ";
    s+=commentaire.substr(posCommentOld,posComment-posCommentOld);
    s+=indent(67 - 3 - (posComment-posCommentOld));
    posCommentOld+= posComment-posCommentOld;
    s+=" */\n";
    posCommentOld = ++posComment;
    posComment = commentaire.find("\n",posComment);
  }
  s+="/* ";
  s+=commentaire.substr(posCommentOld,posComment);
  s+=indent(67 - 3 - (commentaire.length() - posCommentOld));
  posCommentOld+= posComment-posCommentOld;
  s+=" */";
  _commentaire = s;

}

string ExpClasse::getCommentaire (  ){

  return _commentaire;
}

void ExpClasse::setCartouche ( string fichier ){
  string::size_type pos = 0;
  _cartouche = getPepe()->getCartouche();
  pos=_cartouche.find("@F");
  _cartouche.replace(pos,_nom.length(),_nom);
  pos= _cartouche.find("@C");
  _cartouche.erase(pos,2);
  _cartouche.insert(pos,getCommentaire());

}

string ExpClasse::getCartouche (  ){
  return _cartouche;
}

void ExpClasse::setNom ( string nom ){
  _nom = nom;
}

string ExpClasse::getNom (  ){
  return _nom;
}


void ExpClasse::setVisibilite ( string visibilite ){

  if (Minuscules(visibilite) == "public") visibilite = "public";
  if (visibilite == "+") visibilite = "public";
  if (Minuscules(visibilite) == "protected") visibilite = "protected";
  if (visibilite == "#") visibilite = "#";
  if (Minuscules(visibilite) == "private") visibilite = "private";
  if (visibilite == "-") visibilite = "private";

  if (visibilite!="") {
    _visibilite = visibilite + " ";
  } else {
    _visibilite="";
  }
}

string ExpClasse::getVisibilite (  ){
  return _visibilite;
}

void ExpClasse::setInterface(bool interface){
  _interface = interface;
}
bool ExpClasse::getInterface(){
  return _interface;
}

void ExpClasse::ajouterConstructeur(){
  std::vector<ExpMethode>::iterator meIt;
  ExpMethode c(this);
  
  meIt=_listeMethode.begin();
  while(meIt!=_listeMethode.end() && (*meIt).getNom()!=_nom){
    ++meIt;
  }
  if(meIt == _listeMethode.end()){
    c.setMethode(_nom);
    _listeMethode.insert( _listeMethode.begin() , c );
  }
}
void ExpClasse::ajouterDestructeur(){
  std::vector<ExpMethode>::iterator meIt;
  string s = "~";
  ExpMethode c(this);
  s += _nom;
  meIt=_listeMethode.begin();
  while(meIt!=_listeMethode.end() && (*meIt).getNom()!=s){
    ++meIt;
  }
  if(meIt == _listeMethode.end()){
    c.setMethode(s);
    _listeMethode.insert( _listeMethode.begin() , c );
  }
}

void ExpClasse::traiterLesMethodes (vector<Methode*> vctMethode ){
  string nom;
  std::vector<Methode*>::iterator itMethode;
  std::vector<ExpMethode>::iterator itExpMethode;
  itMethode = vctMethode.begin();
  while(itMethode != vctMethode.end()) {
    nom = (*itMethode)->getNom();
    itExpMethode=_listeMethode.begin();
    while((itExpMethode != _listeMethode.end())){
      ++itExpMethode;	
    }
    if(itExpMethode==_listeMethode.end()) {
      ExpMethode c(this);
      c.setMethode(*itMethode);
      _listeMethode.push_back(c);
    }
    ++itMethode;	
  }
}

void ExpClasse::traiterLesAttributs (vector<Attribut*> vctAttribut  ){
  string nom;
  std::vector<Attribut*>::iterator itAttribut;
  std::vector<ExpAttribut>::iterator itExpAttribut;
  itAttribut = vctAttribut.begin();
  while(itAttribut != vctAttribut.end()) {
    nom = (*itAttribut)->getNom();
    itExpAttribut=_listeAttribut.begin();
    while((itExpAttribut != _listeAttribut.end()) && nom.compare((*itExpAttribut).getNom())){
      ++itExpAttribut;	
    }
    if(itExpAttribut==_listeAttribut.end()) {
      ExpAttribut c(*itAttribut);
      _listeAttribut.push_back(c);
    }
    ++itAttribut;	
  }
}

void ExpClasse::traiterAgregation ( Agregation *a ){
  ExpAgregation expagregation(a,this,(ExpExport *)this->getPepe());

}

void ExpClasse::traiterUtilisation ( Utilisation *u ){
  ExpUtilisation exputilisation(u,this,(ExpExport *)this->getPepe());
}

void ExpClasse::traiterHeritage ( Heritage *h ){
  ExpHeritage expheritage(h,this,(ExpExport *)this->getPepe());

}

void ExpClasse::traiterAssociation ( Association *a ){

  ExpAssociation expassociation(a,this,(ExpExport *)this->getPepe());
}


string ExpClasse::indent(int num ){
  string s="";
  for(int i=0;i<num;++i) {
    s+=" ";
  }
  return s;
}

void ExpClasse::ajouterInclude (ExpClasse * classeSource, ExpClasse * classeDest, bool heritage, int typeInclude){
  std::vector<ExpInclude>::iterator it;
  string::size_type pos = 0;
  ExpInclude * expinclude;
  string relPathDest,nomDest;

  if(typeInclude == INC_VECTEUR) {
    it=_listeInclude.begin();
    while(it!=_listeInclude.end() && ("vecteur"!=(*it).getRelPath()) ){
      ++it;
    }
    if(it == _listeInclude.end()){
      expinclude = new ExpInclude ("vecteur","",heritage,typeInclude);
      it = _listeInclude.begin();
      _listeInclude.insert(it,*expinclude);
    }
  } else {

    /* insertion de l'include */
    it=_listeInclude.begin();
    while(it!=_listeInclude.end() && (((ExpClasse *)classeDest)->getRelPath()!=(*it).getRelPath()) ){
      ++it;
    }
    if(it == _listeInclude.end()){
      expinclude = new ExpInclude(classeSource, classeDest, heritage);
      _listeInclude.push_back(*expinclude);
   
      
      if(heritage==true){
	/* insertion de tous les namespaces ncessaires  cet include dans le cas d'un hritage*/
	relPathDest = expinclude->getRelPath();
	nomDest = expinclude->getNom();
	
	
	pos = relPathDest.rfind("/");
	while(pos!=string::npos){
	  relPathDest = relPathDest.substr(0,pos);
	  
	  pos = relPathDest.rfind("/");
	  if(pos!=string::npos)
	    nomDest = relPathDest.substr(pos+1,relPathDest.length());
	  else
	    nomDest = relPathDest.substr(0,relPathDest.length());
	  if(nomDest!=".."){
	    it=_listeInclude.begin();
	    while(it!=_listeInclude.end() && (relPathDest!=(*it).getRelPath()) ){
	      ++it;
	    }
	    if(it == _listeInclude.end()){
	      expinclude = new ExpInclude (relPathDest,nomDest,heritage,INC_GENERE);
	      it = _listeInclude.begin();
	      _listeInclude.insert(it,*expinclude);
	    }
	  }
	}
      }
    }
  }
}


void ExpClasse::ajouterEnteteArg (bool type, ExpClasse * classe){
  ExpEnteteArg enteteArg(type,classe);
  _listeEnteteArg.push_back(enteteArg);
}

string ExpClasse::Majuscules (string chaine) {
  unsigned int i;
  string s = "";
  for( i = 0 ; i < chaine.length() ; ++i) {
    s += toupper(chaine.at(i));
  }
  return s;
}

string ExpClasse::Minuscules (string chaine) {
  unsigned int i;
  string s = "";
  for( i = 0 ; i < chaine.length() ; ++i) {
    s += tolower(chaine.at(i));
  }
  return s;
}

string ExpClasse::getIfndef () {
  string s = "";
  string::size_type pos = 0;
  s += _classe->getNomComplet();
  pos = s.find(":");
  while (pos != string::npos) {
    s.replace(pos,1,"_");
    pos = s.find(":");
  }

  s = Majuscules(s);

  return s;
}


string ExpClasse::getPaquetage() {
  return _paquetages;
}

Classe * ExpClasse::getClasse(){
  return _classe;
}

void ExpClasse::setPepe(){
  _pepe = _pere->getPepe();
}

ExpObjetFichier * ExpClasse::getPepe(){
  return _pepe;
}

string ExpClasse::getRelPath (){
  return _relPath;
}
string ExpClasse::getRelPath (string path){
  string s = "";
  s += (_pere)->getRelPath("");
  s += _nom;
  return s;
}

string ExpClasse::getRelatifPath (string pathCourant){
  string s = "";
  string::size_type pos = 0;

  pos = pathCourant.find("/",pos);
  while(pos!=string::npos){
    s+="../";
    pos = pathCourant.find("/",pos+1);
  }
  s += _relPath;
  return s;
}



void ExpClasse::ajouterAttribut(ExpAttribut attribut) {
  std::vector<ExpAttribut>::iterator it;
  it=_listeAttribut.begin();
  while(it!=_listeAttribut.end() && (attribut.getNom()!=(*it).getNom()) ){
    ++it;
  }
  if(it == _listeAttribut.end()){
    _listeAttribut.push_back(attribut);
  }
}

string ExpClasse::getPaquetagePath(string delimiteur){
  string s;
  string::size_type pos = 0;
  s = _paquetages;
  pos = s.find("::");
  while(pos!=string::npos) { 
    s.erase(pos,2);
    s.insert(pos,delimiteur);
    pos+=delimiteur.length(); // pour viter de boucler sur le :: !!
    pos = s.find("::",pos);
  }
  return s;
};

ExpPaquetage * ExpClasse::getPaquetage(string paquetage){};//inutile
ExpClasse * ExpClasse::getClasse(string classe){};//inutile

string ExpClasse::getJavaEnteteArg(){
  string sortie = "";
  vector<ExpEnteteArg>::iterator enIt;
  bool testImplements = false;

  if(_interface==false) {
    // Classe
    enIt=_listeEnteteArg.begin();
    while(enIt!=_listeEnteteArg.end() ){
      if((*enIt).getType()==false){
	sortie += "extends " + (*enIt).getClasse(this,".") + " ";
	enIt=_listeEnteteArg.end();
      };
      if(enIt!=_listeEnteteArg.end()){
	++enIt;
      }
    };
    
    enIt=_listeEnteteArg.begin();
    while(enIt!=_listeEnteteArg.end() && testImplements == false){
      if((*enIt).getType()==true){
	sortie += "implements " + (*enIt).getClasse(this,".") ;
	testImplements = true;
      }
      ++enIt;
    }
    while(enIt!=_listeEnteteArg.end() ){
      if((*enIt).getType()==true){
	sortie += ", " + (*enIt).getClasse(this,".") ;
      }
      ++enIt;
    }
  } else {
    // Interface
    // On a une interface qui hrite d'une interface
    // Il faut utiliser le mot cl "extends" et pas "implements"
    enIt=_listeEnteteArg.begin();
    while(enIt!=_listeEnteteArg.end() && testImplements == false){
      if((*enIt).getType()==true){
	sortie += "extends " + (*enIt).getClasse(this,".") ;
	testImplements = true;
      }
      ++enIt;
    }
    while(enIt!=_listeEnteteArg.end() ){
      if((*enIt).getType()==true){
	sortie += ", " + (*enIt).getClasse(this,".") ;
      }
      ++enIt;
    }
  }
  return sortie;
}
