/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:42 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:42 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expentetearg.h                          */
/************************************************/

#ifndef EXPENTETEARG_H
#define EXPENTETEARG_H

#include <string>
#ifndef EXPCLASSE_H
class ExpClasse;  
#endif

/**
 * Classe dfinissant une classe qui doit tre ajoute comme hrite
 * @author A.Pique
 */
class ExpEnteteArg {

  private:
 /**
   * Dfinit le type de l'hritage:
   * hritage d'une interface (implements en Java)
   * hritage d'une classe (extends en Java)
   */
    bool _type;
    /**
     * Classe dont notre classe hritera
     */
    ExpClasse * _classe;

  public:
  /**
   *Constructeur
   * \param bool type : type de l'hritage
   * \param ExpClasse * classe : classe dont notre classe hritera
   */
    ExpEnteteArg ( bool type, ExpClasse * classe );
    //! Destructeur
    ~ExpEnteteArg ( );
    /**
     * Modificateur de l'attribut _type
     * \param string type : nouvelle valeur de type
     */    
    void setType ( bool type );
    /** Accesseur de _type
     * \return Le type
     */
    bool getType (  );
   /**
     * Modificateur de l'attribut _classe
     * \param ExpClasse * classe : nouvelle valeur de _classe
     */    
    void setClasse ( ExpClasse * classe );

    /**
     * Fonction permettant d'obtenir le nom de la classe hrite au format long
     * en fonction du dlimiteur fournit 
     * ex : A::B::C en C++ ou A.B.C en Java
     * \param ExpClasse * pere : pointeur sur la classe qui hrite
     * \param string delimiteur : "::" pour le Cpp ou "." pour le Java
     */
    string getClasse(ExpClasse * pere, string delimiteur);


};

#endif
