/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:42 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:42 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expexport.cpp                           */
/************************************************/

#include <time.h>
#include "expexport.h"
#include "exppaquetage.h"
#include "expclasse.h"
#include "expinclude.h"
#include "exprelation.h"
#include "exputilisation.h"
#include "expagregation.h"
#include "expheritage.h"
#include "expassociation.h"
#include "expmethode.h"
#include "expentetearg.h"
#include "expattribut.h"
#include "expparametre.h"

#include "noyvisiteurnoeud.h"
#include "noypaquetage.h"
#include "noyclasse.h"
#include "noydiagrammestatique.h"


ExpExport::ExpExport ( DiagrammeStatique * diagramme,  string path){
  _diagramme = diagramme;
  _path = path;
}

ExpExport::~ExpExport ( ) {
  _listeClasse.clear();
  _listePaquetage.clear();
}


void ExpExport::remplir(){
   _diagramme->visiterObjetuml((VisiteurNoeud *)this);
}

void ExpExport::setDiagramme ( DiagrammeStatique * diagramme ){
  _diagramme=diagramme;

}

DiagrammeStatique * ExpExport::getDiagramme (  ){
  return _diagramme;
}

void ExpExport::traiterPaquetage ( Paquetage * pa ){
  string nom;
  std::vector<ExpPaquetage>::iterator itPaquetage;

  nom = pa->getNom();
  itPaquetage=_listePaquetage.begin();
  while((itPaquetage != _listePaquetage.end()) && nom.compare((*itPaquetage).getNom())){
    ++itPaquetage;	
  }
  if(itPaquetage==_listePaquetage.end()) {
    ExpPaquetage p((ExpObjetFichier *)this);
    p.setPaquetage(pa);
    _listePaquetage.push_back(p);
  }
}


void ExpExport::traiterClasse ( Classe * cl ){
  string nom;
  std::vector<ExpClasse>::iterator itClasse;
  nom = cl->getNom();
  itClasse=_listeClasse.begin();
  while((itClasse != _listeClasse.end()) && nom.compare((*itClasse).getNom())){
		++itClasse;	
	}
  if(itClasse==_listeClasse.end()) {
    ExpClasse c((ExpObjetFichier *)this);
    c.setClasse(cl);
    _listeClasse.push_back(c);
  }
}

void ExpExport::setCartouche ( string nomProjet, string nomCreateur ){

  string s = "";
  string temp = "";
  string::size_type pos = 0;
  char * sc;
  time_t temps;
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Nom du projet :                                                 */\n";
  s+="/*  @P                                                              */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Elment :                                                       */\n";
  s+="/*  @F                                                              */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Auteur(s) :                                                     */\n";
  s+="/*  @N                                                              */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Relecteur(s) :                                                  */\n";
  s+="/*  @N                                                              */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Date de cration     : @D                                       */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Date de modification : @D                                       */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="/*  Numero de version et commentaire                                */\n";
  s+="/*        0.1     Creation                                          */\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  s+="@C\n";
  s+="/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/\n";
  /*  0123456789012345678901234567890123456789012345678901234567890123456789 */

  pos=s.find("@P");
  s.replace(pos,nomProjet.length(),nomProjet);  
  pos=s.find("@N");
  s.replace(pos,nomCreateur.length(),nomCreateur);
  pos=s.find("@N");
  s.replace(pos,nomCreateur.length(),nomCreateur);
  temps = time(NULL);
  sc = ctime(&temps);
  temp.insert(0,sc);
  pos=temp.find("\n");
  temp.erase(pos,1);
  pos=s.find("@D");
  s.replace(pos,temp.length(),temp);
  pos=s.find("@D");
  s.replace(pos,temp.length(),temp);
  _cartouche=s;

}

string ExpExport::getCartouche (  ){
   return _cartouche;
}

void ExpExport::setPath ( string path ){
  _path = path;
}

string ExpExport::getPath (  ){
  return _path;
}

string ExpExport::getRelPath (string path){
  return path;
}



string ExpExport::getPaquetage( ){
  return "";
}

ExpObjetFichier * ExpExport::getPepe(){
  return this;
}

string ExpExport::getNom(){return "";};
void ExpExport::setCartouche( string nomFichier){};
void ExpExport::getCpp() {
  char *old = new char[500];
  int resultRep;
  char *path = new char[_path.length() + 1];

  for(unsigned int i=0;i<_path.length();i++){
    path[i]=_path[i];
  }
  path[_path.length()]='\0';

  getcwd(old,500);
  resultRep = mkdir(path,0777) ;
  if(resultRep==0 | errno==EEXIST) {
    resultRep = chdir(path); // On se place dans le rpertoire du paquetage
    if(resultRep==0) {
      std::vector<ExpClasse>::iterator clIt;
      std::vector<ExpPaquetage>::iterator paIt;
      clIt=_listeClasse.begin();
      while(clIt!=_listeClasse.end() ){
	(*clIt).getCpp();
	++clIt;
      }
      paIt=_listePaquetage.begin();
      while(paIt!=_listePaquetage.end() ){
	(*paIt).getCpp();
	++paIt;
      }
      chdir(old); // On retourne dans le rpertoire parent
    }
  }
  delete [] old;
  delete [] path;
};

void ExpExport::getJava() {
  char *old = new char[500];
  int resultRep;
  char *path = new char[_path.length() + 1];

  for(unsigned int i=0;i<_path.length();i++){
    path[i]=_path[i];
  }
  path[_path.length()]='\0';

  getcwd(old,500);
  resultRep = mkdir(path,0777) ;
  if(resultRep==0 | errno==EEXIST) {
    resultRep = chdir(path); // On se place dans le rpertoire du paquetage
    if(resultRep==0) {
      std::vector<ExpClasse>::iterator clIt;
      std::vector<ExpPaquetage>::iterator paIt;
      clIt=_listeClasse.begin();
      while(clIt!=_listeClasse.end() ){
	(*clIt).getJava();
	++clIt;
      }
      paIt=_listePaquetage.begin();
      while(paIt!=_listePaquetage.end() ){
	(*paIt).getJava();
	++paIt;
      }
      chdir(old); // On retourne dans le rpertoire parent
    }
  }
  delete [] old;
  delete [] path;
};

ExpPaquetage * ExpExport::getPaquetage (string paquetage){
  std::vector<ExpPaquetage>::iterator paIt;
  paIt=_listePaquetage.begin();
  while(paIt!=_listePaquetage.end() && (*paIt).getNom()!=paquetage ){
    ++paIt;
  }
  if(paIt==_listePaquetage.end()){
    return NULL;
  } else {
    return (ExpPaquetage *)paIt;
  }
}

ExpClasse * ExpExport::getClasse (string classe){
  std::vector<ExpClasse>::iterator clIt;
  clIt=_listeClasse.begin();
  while(clIt!=_listeClasse.end() && (*clIt).getNom()!=classe ){
    ++clIt;
  }
  if(clIt==_listeClasse.end()){
    return NULL;
  } else {
    return clIt;
  }
}
