/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expinclude.h                            */
/************************************************/

#ifndef EXPINCLUDE_H
#define EXPINCLUDE_H

#include <string>
#include "expdefine.h"

#ifndef ExpCLASSE_H
class ExpClasse;
#endif
#ifndef EXPOBJETFICHIER_H
class ExpObjetFichier;
#endif


/**
 * Classe reprsentant une classe  inclure dans un fichier
 * Correspond au "#include" en C++ et au "import" en Java
 * @author A.Pique
 */
class ExpInclude {

 private:
  /** Variable permettant de savoir si cette inclusion est ncessaire
   *  cause d'un hritage ou non
   */
  bool _heritage;
  //! Nom de la classe  inclure 
  string _nom;
  /**
   * Chemin de la classe  inclure sous la forme C++
   * ex : A::B::C sera la classe C inclue dans le paquetage B lui-mme inclu dans le paquetage A
   */
  string _relPath;
  /**
   * Dfinit le type de l'inclusion :
   * Obligatoire
   * Gnr (paquetages pres d'une classe appele)
   * Vecteur (permet d'inclure le paquetage Vector) 
   */
  int _type;
  public:
  /**
   *Constructeur
   * \param ExpClasse * classeSource : classe dans laquelle l'inclusion sera ajoute
   * \param ExpClasse * classeDest : classe ajoute
   * \param bool heritage : vrai si l'inclusion a t gnre du fait d'un hritage
   */
    ExpInclude ( ExpClasse * classeSource, ExpClasse * classeDest, bool heritage);

    /**
     *Constructeur
     * \param const string relPathDest : chemin relatif vers la classe ajoute
     * \param const string nomDest : nom de la classe ajoute
     * \param bool heritage : vrai si l'inclusion a t gnre du fait d'un hritage
     * \param int type : type de l'inclusion
     */
    ExpInclude ( const string relPathDest, const string nomDest, bool heritage ,int type );

    //! Destructeur
    ~ExpInclude ( );
    /**
     * Modificateur de l'attribut _nom
     * \param string nom : nouvelle valeur de nom
     */
    void setNom ( string nom );
    /** Accesseur de _nom
     * \return Le nom
     */
    string getNom (  );
    /**
     * Modificateur de l'attribut _heritage
     * \param string heritage : nouvelle valeur de heritage
     */
    void setHeritage ( bool heritage );
    /** Accesseur de _heritage
     * \return L'hritage
     */
    bool getHeritage (  );

   /**
     * Modificateur de l'attribut _relPath
     * \param string relPath : nouvelle valeur de relPath
     */
    void setRelPath ( string relPath );
    /** Accesseur de _relPath
     * \return Le chemin complet
     */
    string getRelPath (  );
    /**
     * Modificateur de l'attribut _type
     * \param string type : nouvelle valeur de type
     */
    void setType ( int _type );
    /** Accesseur de _type
     * \return Le type
     */
    int getType (  );
    /** Methode renvoyant le chemin au format Java, c'est  dire avec des "." au lieu de "/"
     * \return Le chemin complet typ Java
     */
    string getPointPath (  );
};

#endif
