/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:43 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:43 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expmethode.cpp                          */
/************************************************/

#include "expmethode.h"
#include "expexport.h"
#include "expparametre.h"
#include "expobjetfichier.h"
#include "noyparametre.h"
#include "noymethode.h"
ExpMethode::ExpMethode ( ExpObjetFichier * pere ){
  _pere = pere;
}

ExpMethode::~ExpMethode ( ){
  _listeParametre.clear();
}

void ExpMethode::setMethode ( string methode){
  setNom(methode);
  setType("");
  setVisibilite("+");
  setCommentaire("");
  setCode("");
}

void ExpMethode::setMethode ( Methode * methode ){
  std::vector<Parametre*> v;
  std::vector<Parametre*>::iterator itParametre;
  setNom(methode->getNom());
  setType(methode->getTypeRetour());
  setVisibilite(methode->getVisible());
  setCommentaire(methode->getDescription());
  setCode(methode->getCode());
  methode->cloneVctParametre( v ); 
  itParametre = v.begin();
  while (itParametre != v.end()){
    ExpParametre p (*itParametre);
    _listeParametre.push_back(p);
    ++itParametre;
  }
}

string ExpMethode::getCpp (string classe ){
  string s = "";
  std::vector<ExpParametre>::iterator paIt;

  typeConvertisseur(_type,".","::");

  if(getType() != "") {
    s += getType();
    s += " ";
  }
  
  s += classe;
  s += "::"; 

  s += _nom ;
  s += "(" ; 

  paIt=_listeParametre.begin();
  if(paIt!=_listeParametre.end() ){
    s+= " ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  while(paIt!=_listeParametre.end() ){
    s+= ", ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  s +=" ) {\n";
  s+= getCode(4);
  s+="\n}\n";
  return s;

}
string ExpMethode::getEntete (){
  string s = "";
  std::vector<ExpParametre>::iterator paIt;
  s += _nom ;
  s += "(" ; 

  paIt=_listeParametre.begin();
  if(paIt!=_listeParametre.end() ){
    s+= " ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  while(paIt!=_listeParametre.end() ){
    s+= ", ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  s +=" )";
 return s;
}

string ExpMethode::getEnteteCpp(bool typeInterface) {
  string s = "";

  typeConvertisseur(_type,".","::");

  if (getCommentaire() != "")
    s += indent(8) + "/* " + getCommentaire() + " */\n";
  
  s += indent(8);

  if(typeInterface && getType() != "") {
    s += "virtual " ;
  }

  if (getType() != "") {
    s += getType();
    s += " ";
  }

  s += getEntete();

  if(typeInterface && getType() != "") {
    s += " = 0" ;
  } else {
    if(typeInterface && getType()=="") {
      s += "{}";
    }
  }
  s += ";\n";
  return s;
}

string ExpMethode::getJava (bool typeInterface ){
  string s = "";
  std::vector<ExpParametre>::iterator paIt;

  typeConvertisseur(_type,"::",".");

  if (getCommentaire() != "")
    s += indent(4) + "/* " + getCommentaire() + " */\n";

  s += indent(4);
  if(getVisibilite() != "") {
    s += getVisibilite();
    s += " ";
  }

  if(getType() != "") {
    s += getType();
    s += " ";
  }

  s += _nom ;
  s += "(" ; 

  paIt=_listeParametre.begin();
  if(paIt!=_listeParametre.end() ){
    s+= " ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  while(paIt!=_listeParametre.end() ){
    s+= ", ";
    s+= (*paIt).getType();
    s+= " ";
    s+= (*paIt).getNom();
    ++paIt;
  }
  s +=" )";

  if(!typeInterface) {
    s+="{\n";
    s+= getCode(8);
    s+="\n";
    s+= indent(4);
    s+="}";
  } else {
    s+=";";
  }
  s+="\n";

  if(getNom()[0]=='~') {
    return "";
  }

  if(typeInterface && getType()=="") {
    return "";
  }
  
  return s;



 return s;
}

/*
string ExpMethode::getEnteteJava(bool typeInterface) {
  string s = "";
  return s;
}
*/
void ExpMethode::setCommentaire ( string commentaire ){
  _commentaire = commentaire;
}

string ExpMethode::getCommentaire (  ){
  string s=_commentaire;
  string::size_type pos = s.find("\n");
  while (pos != string::npos) {
    ++pos;
    s.insert(pos,indent(8));
    pos = s.find_first_of("\n", pos);
  }
  return s;

}

void ExpMethode::setCode ( string code ){
  _code = code;
  /*
  char *cpath ;
  ifstream entree;
  string s = "";
  ExpExport * pepe = (ExpExport *)getPepe();
  if(path[0]!='/') {    
    s += path;
  } else {
    s += pepe->getPath();
    s += "/";
    s += path;
  }
  cpath = new char(s.length() + 1);
  for(unsigned int i=0;i<s.length();i++){
    cpath[i]=s[i];
  }
  cpath[s.length()]='\0';
  entree.open(cpath,ios::in);
  //delete cpath;
  entree >> _code ;
  entree.close();
  */
}

string ExpMethode::getCode (int indentation){
  string s=_code;
  string::size_type pos = 0 ;
  s.insert(pos,indent(indentation));
  pos = s.find("\n");
  while (pos != string::npos) {
    ++pos;
    s.insert(pos,indent(indentation));
    pos = s.find_first_of("\n", pos);
  }
  return s;
}

void ExpMethode::setVisibilite ( string contenu ){
  string visibilite = "";
  if (Minuscules(contenu) == "public") visibilite = "public";
  if (contenu == "+") visibilite = "public";
  if (Minuscules(contenu) == "protected") visibilite = "protected";
  if (contenu == "#") visibilite = "protected";
  if (Minuscules(contenu) == "private") visibilite = "private";
  if (contenu == "-") visibilite = "private";
  _visibilite = visibilite;
}

string ExpMethode::getVisibilite (  ){
  return _visibilite;
}

void ExpMethode::setNom ( string nom ){
  _nom = nom;
}

string ExpMethode::getNom (  ){
  return _nom;
}

void ExpMethode::setType ( string type ){
  _type = type;
}

string ExpMethode::getType (  ){
  return _type;
}

string ExpMethode::indent( int num ){
  string s="";
  for(int i=0;i<num;++i) {
    s+=" ";
  }
  return s;
}

ExpObjetFichier * ExpMethode::getPepe(){
  return _pere;
}

string ExpMethode::Minuscules (string chaine) {
  unsigned int i;
  string s = "";
  for( i = 0 ; i < chaine.length() ; ++i) {
    s += tolower(chaine.at(i));
  }
  return s;
}


void ExpMethode::typeConvertisseur(string &s,string ancDelimiteur,string nouvDelimiteur){

  string::size_type pos = 0;

  pos = s.find(ancDelimiteur);
  while(pos!=string::npos) { 
    s.erase(pos,ancDelimiteur.length());
    s.insert(pos,nouvDelimiteur);
    pos+=nouvDelimiteur.length(); // pour viter de boucler sur le dlimiteur !!
    pos = s.find(ancDelimiteur,pos);
  }
};
