/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expmethode.h                            */
/************************************************/

#ifndef EXPMETHODE_H
#define EXPMETHODE_H

#include <vector>
#include <cctype>
#include <string>
#include <iostream>
#include <fstream>



#ifndef NOYMETHODE_H
class Methode ;
#endif
#ifndef NOYPARAMETRE_H
class Parametre ;
#endif
#ifndef EXPPARAMETRE_H
class ExpParametre ;
#endif
#ifndef EXPOBJETFICHIER_H
class ExpObjetFichier ;
#endif

/**
 * Classe reprsentant une mthode
 * @author A.Pique
 */
class ExpMethode {

 private:
  //! Commentaire li  la mthode
  string _commentaire;
  //! Portion de code lie  la mthode
  string _code;
  //! Visibilit de la mthode
  string _visibilite;
  //! Nom de la mthode
  string _nom;
  //! Type de la mthode
  string _type;
  //! Classe contenant cette mthode
  ExpObjetFichier * _pere;
  //! Vecteur de paramtres de la mthode
  std::vector<ExpParametre > _listeParametre;

  protected:
   

  public:
  /**
   *Constructeur
   * \param ExpObjetFichier * pere : classe contenant cette mthode
   */
  ExpMethode ( ExpObjetFichier * pere );
  //!Destructeur
  ~ExpMethode ( );
  /**
   * Fonction initialisant la mthode  partir de son nom
   * \param string methode : nom de la mthode
   */
  void setMethode ( string methode );
  /**
   * Fonction initialisant une mthode issue du noyau
   * \param Methode *methode : mthode issue du noyau
   */
  void setMethode ( Methode *methode );
  /**
   * Fonction renvoyant la dclaration de la mthode dans le .cpp avec son corps
   * \param nom de la classe mere
   * \return dclaration de la mthode
   */
  string getCpp ( string classe );
  /**
   * Fonction renvoyant la dclaration de la mthode dans le .java avec son corps
   * \param nom de la classe mere
   * \return dclaration de la mthode
   */
  string getJava (bool typeInterface);
  /**
   * Retourne la partie commune aux deux langages de l'entte de la mthode
   * \return entte de la mthode
   */
  string getEntete (  );
  /**
   * Retourne l'entte de la mthode au format C++ pour l'inclure dans le .h
   * \return entte de la mthode C++
   */
  string getEnteteCpp(bool typeInterface);
    /**
   * Modificateur de l'attribut _commentaire
   * \param string commentaire : nouvelle valeur de commentaire
   */   
  void setCommentaire ( string commentaire );
  /** Accesseur de _commentaire
   * \return Le commentaire
   */    
  string getCommentaire (  );
    /**
   * Modificateur de l'attribut _code
   * \param string code : nouvelle valeur de code
   */  
  void setCode ( string code );
  /** Accesseur de _code
   * \param int indentation : indentation du bloc de code
   * \return Le code de la mthode
   */  
  string getCode ( int indentation );
    /**
   * Modificateur de l'attribut _visibilite
   * \param string visibilite : nouvelle valeur de visibilite
   */  
  void setVisibilite ( string contenu );
  /** Accesseur de _visibilite
   * \return La visibilite de la methode
   */  
  string getVisibilite (  );
  /**
   * Modificateur de l'attribut _nom
   * \param string nom : nouvelle valeur de nom
   */  
  void setNom ( string nom );
  /** Accesseur de _nom
   * \return Le nom
   */  
  string getNom (  );
  /**
   * Modificateur de l'attribut _type
   * \param string type : nouvelle valeur de type
   */ 
  void setType ( string type );
  /** Accesseur de _type
   * \return Le type
   */  
  string getType (  );
  /**
   * Fonction permettant de crer des chanes de "num" espaces
   * \param int num : nombre d'espaces
   * \return une chane de "num" blancs
   */
  string indent( int num );
  /**Fonction retournant un pointeur sur la classe mre de l'export
   * \return ExpObjetFichier * : pointeur sur la classe mre
   */
  ExpObjetFichier * getPepe();
   /**
   * Fonction permettant de convertir une chane en minuscules
   * \param string chaine : chaine  convertir
   * \return la chane convertie
   */
  string Minuscules (string chaine);

  /**
   * Fonction permettant d'enlever l'ancien dlimiteur d'une chane et de les remplacer 
   * par un autre dlimiteur
   * \param string &s : la chane  convertir
   * \param string ancDelimiteur : l'ancien dlimiteur
   * \param string nouvDelimiteur : le nouveau dlimiteur
   */
  void typeConvertisseur(string& s,string ancDelimiteur, string nouvDelimiteur);


};

#endif
