/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expobjetfichier.h                            */
/************************************************/

#ifndef EXPOBJETFICHIER_H
#define EXPOBJETFICHIER_H
#include "noyvisiteurnoeud.h"

class ExpObjetFichier;

//#ifndef EXPPAQUETAGE_H
class ExpPaquetage;
//#endif
//#ifndef EXPCLASSE_H
class ExpClasse;
//#endif

/**Cette interface est implmente par ExpExport, ExpPaquetage et ExpClasse,
 * les 3 seules classes pouvant crer des fichiers ou rpertoires.
 * @author A.Pique
 */
class ExpObjetFichier : public VisiteurNoeud {


  public :
    //!  Constructeur de ExpObjetFichier
    ExpObjetFichier(){};
  //! Destructeur de ExpObjetFichier
  virtual ~ExpObjetFichier(){};
  /** Fonction rcuprant le nom d'un objet
   * \return string : le nom
   */
  virtual string getNom()=0;
  /** Fonction rcuprant le cartouche  insrer
   * \return string : le cartouche   
   */
  virtual string getCartouche () = 0;
  /** Fonction permettant de modifier le cartouche d'une classe
   * \param string cartouche : chane contenant le cartouche  insrer
   */
  virtual void setCartouche ( string cartouche ) = 0;
  /** Fonction permettant de rcuprer le chemin relatif d'une classe
   * \param string path : chane de caractre
   * \return string : chemin relatif de la classe
   */
  virtual string getRelPath (string path) = 0;


  /**Fonction permettant d'obtenir le nom complet d'un paquetage (avec tous ces pres)
   * \return string : le nom complet du paquetage
   */
  virtual string getPaquetage() = 0;

  /**Fonction retournant un pointeur sur la classe mre de l'export
   * \return ExpObjetFichier * : pointeur sur la classe mre
   */
  virtual ExpObjetFichier * getPepe() = 0;
  /**Fonction retournant un pointeur sur un ExpPaquetage s'il appartient  un vecteur de ExpPaquetage de l'objet
   * \param string paquetage : nom du paquetage
   * \return ExpPaquetage * : pointeur sur le paquetage ou null s'il n'existe pas
   */
  virtual ExpPaquetage * getPaquetage(string paquetage) = 0;
  /**Fonction retournant un pointeur sur un ExpClasse s'il appartient  un vecteur de ExpClasse de l'objet
   * \param string classe : nom de la classe
   * \return ExpClasse * : pointeur sur la classe ou null si elle n'existe pas
   */
  virtual ExpClasse * getClasse(string classe) = 0;
};

#endif
