/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:44 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      exppaquetage.cpp                        */
/************************************************/
#include "exppaquetage.h"
#include "expexport.h"
#include "noyvisiteurnoeud.h"
#include "noypaquetage.h"
#include "noyclasse.h"
#include "expclasse.h"
#include "expinclude.h"
#include "exprelation.h"
#include "exputilisation.h"
#include "expagregation.h"
#include "expheritage.h"
#include "expassociation.h"
#include "expmethode.h"
#include "expentetearg.h"
#include "expattribut.h"
#include "expparametre.h"

ExpPaquetage::ExpPaquetage (ExpObjetFichier * pere){
  _pere = pere;
}
ExpPaquetage::~ExpPaquetage (){
  _listeClasse.clear();
  _listePaquetage.clear();
  _listeInclude.clear();
}

void ExpPaquetage::setPaquetage ( Paquetage * paquetage ){

  _paquetage = paquetage;
  setNom(paquetage->getNom());
  _paquetages = _pere->getPaquetage();
  setPepe();
  setCommentaire(paquetage->getDescription());
  setCartouche(paquetage->getNom());
  paquetage->visiterObjetuml((VisiteurNoeud *)this);  //visite les sous-paquetages et sous-classes

}

string ExpPaquetage::getPaquetage () {
  string s = "";
  s+=_paquetages; //pere->getPaquetage();
  if (s != ""){
    s += "::";
    s += _nom;
  } else {
    s += _nom;
  }
  return s;
} 

ExpPaquetage * ExpPaquetage::getPaquetage (string paquetage){
  std::vector<ExpPaquetage>::iterator paIt;
  paIt=_listePaquetage.begin();
  while(paIt!=_listePaquetage.end() && (*paIt).getNom()!=paquetage ){
    ++paIt;
  }
  if(paIt==_listePaquetage.end()){
    return NULL;
  } else {
    return paIt;
  }
}

ExpClasse * ExpPaquetage::getClasse (string classe){
  std::vector<ExpClasse>::iterator clIt;
  clIt=_listeClasse.begin();
  while(clIt!=_listeClasse.end() && (*clIt).getNom()!=classe ){
    ++clIt;
  }
  if(clIt==_listeClasse.end()){
    return NULL;
  } else {
    return clIt;
  }
}

void ExpPaquetage::getCpp (  ){
  std::vector<string>::iterator it;
  int resultRep;
  string s = (Minuscules(_nom) + ".h");
  string minus = Minuscules(_nom);
  char *sc = new char[s.length() + 1];
  for(unsigned int i=0;i<s.length();i++){
    sc[i]=s[i];
  }
  sc[s.length()]='\0';
  
  //Cre un fichier Minuscules(_nom) + ".h"
  ofstream sortie(sc,ios::out);

  if(sortie.is_open()) {
    /* contenu de ce fichier : */
    
    sortie << getCartouche() << "\n";
    sortie << "#ifndef " << getIfndef()  << "_H" << "\n";
    sortie << "#define " << getIfndef()  << "_H" << "\n";
    sortie <<  "\n";
    sortie << "namespace " <<  _nom << " {\n";
    it=_listeInclude.begin();
    while(it!=_listeInclude.end() ){
      sortie << indent(4) << "#include \"" << Minuscules(_nom)<< "/"<< *it << "\"\n";
      ++it;
    }
    sortie << "};\n";
    sortie <<  "#endif\n";
    sortie.close(); 
    
 
    
    delete [] sc;
  }
  
  //Cre un rpertoire _nom
  
  sc = new char[minus.length() + 1];
  for(unsigned int i=0;i<minus.length();i++){
    sc[i]=minus[i];
  }
  sc[minus.length()]='\0';

  resultRep = mkdir(sc,0777) ;
  if(resultRep==0 | errno==EEXIST) {
    resultRep = chdir(sc); // On se place dans le rpertoire du paquetage
    if(resultRep==0) {
      std::vector<ExpClasse>::iterator clIt;
      std::vector<ExpPaquetage>::iterator paIt;
      clIt=_listeClasse.begin();
      while(clIt!=_listeClasse.end() ){
	(*clIt).getCpp();
	++clIt;
      }
      paIt=_listePaquetage.begin();
      while(paIt!=_listePaquetage.end() ){
	(*paIt).getCpp();
	++paIt;
      }
      chdir(".."); // On retourne dans le rpertoire parent
    }
  }
  delete [] sc;
}

void ExpPaquetage::getJava (  ){
  //Cre un rpertoire _nom
  //Parcours le vecteur _listePaquetage et pour chaque paquetage : paquetage.getJava()
  //Parcours le vecteur _listeClasse et pour chaque classe : classe.getJava()
  string s = (Minuscules(_nom) + ".java");
  int resultRep;
  // string minus = Minuscules(_nom);
  char *sc = new char[s.length() + 1];
  
  sc = new char[_nom.length() + 1];
  for(unsigned int i=0;i<_nom.length();i++){
    sc[i]=_nom[i];
  }
  sc[_nom.length()]='\0';

  resultRep = mkdir(sc,0777) ;
  if(resultRep==0 | errno==EEXIST) {
    resultRep = chdir(sc); // On se place dans le rpertoire du paquetage
    if(resultRep==0) {
      std::vector<ExpClasse>::iterator clIt;
      std::vector<ExpPaquetage>::iterator paIt;
      clIt=_listeClasse.begin();
      while(clIt!=_listeClasse.end() ){
	(*clIt).getJava();
	++clIt;
      }
      paIt=_listePaquetage.begin();
      while(paIt!=_listePaquetage.end() ){
	(*paIt).getJava();
	++paIt;
      }
      chdir(".."); // On retourne dans le rpertoire parent
    }
  }
  delete [] sc;


}


void ExpPaquetage::setCartouche ( string fichier ){
  string::size_type pos = 0;

  _cartouche = getPepe()->getCartouche();
  pos=_cartouche.find("@F");
  _cartouche.replace(pos,_nom.length(),_nom);
  pos= _cartouche.find("@C");
  _cartouche.erase(pos,2);
  _cartouche.insert(pos,getCommentaire());

}

string ExpPaquetage::getCartouche (  ){
  return _cartouche;
}

void ExpPaquetage::setCommentaire ( string commentaire ){
  string s = "";
  string::size_type posComment = 0;
  string::size_type posCommentOld = 0;
    
  posComment = commentaire.find("\n",posComment);
  while(posComment != string::npos) {
    while( (posComment - posCommentOld) > 64 ) {
      s+="/* ";
      s+=commentaire.substr(posCommentOld,64);
      posCommentOld+= 64;
      s+=" */\n";
    }
    s+="/* ";
    s+=commentaire.substr(posCommentOld,posComment-posCommentOld);
    s+=indent(67 - 3 - (posComment-posCommentOld));
    posCommentOld+= posComment-posCommentOld;
    s+=" */\n";
    posCommentOld = ++posComment;
    posComment = commentaire.find("\n",posComment);
  }
  s+="/* ";
  s+=commentaire.substr(posCommentOld,posComment);
  s+=indent(67 - 3 - (commentaire.length() - posCommentOld));
  posCommentOld+= posComment-posCommentOld;
  s+=" */";
  _commentaire = s;
}

string ExpPaquetage::getCommentaire (  ){
  return _commentaire;
}

void ExpPaquetage::setNom ( string nom ){
  _nom = nom;
}

string ExpPaquetage::getNom (  ){
  return _nom;
}

string ExpPaquetage::getRelPath (string path){

  string s = path;
  
  string temp = getNom() + "/" ;
 
  s.insert(0 , temp);
  
  temp =  _pere->getRelPath(s);

  return temp;
}



void ExpPaquetage::traiterPaquetage ( Paquetage * pa ){
  string nom;
  std::vector<ExpPaquetage>::iterator itPaquetage;

  nom = pa->getNom();
  itPaquetage=_listePaquetage.begin();

  while((itPaquetage != _listePaquetage.end()) && nom.compare((*itPaquetage).getNom())){
    ++itPaquetage;	
  }
  if(itPaquetage==_listePaquetage.end()) {
    ExpPaquetage p((ExpObjetFichier *)this);
    p.setPaquetage(pa);
    _listePaquetage.push_back(p);
    ajouterInclude(p.getNom());
  }
}

void ExpPaquetage::traiterClasse ( Classe * cl ){
  string nom;
  std::vector<ExpClasse>::iterator itClasse;
  nom = cl->getNom();
  itClasse=_listeClasse.begin();
  while((itClasse != _listeClasse.end()) && nom.compare((*itClasse).getNom())){
		++itClasse;	
	}
  if(itClasse==_listeClasse.end()) {
    ExpClasse c((ExpObjetFichier *)this);
    c.setClasse(cl);
    _listeClasse.push_back(c);
    ajouterInclude(c.getNom());
  }
}

string ExpPaquetage::indent( int num ){
  string s="";
  for(int i=0;i<num;++i) {
    s+=" ";
  }
  return s;
}



string ExpPaquetage::Majuscules (string chaine) {
  string s = "";
  unsigned int i;
  for(i = 0 ; i < chaine.length() ; ++i) {
    s += toupper(chaine.at(i));
  } 
  return s;
}

string ExpPaquetage::Minuscules (string chaine) {
  string s = "";
  unsigned int i;
  for(i = 0 ; i < chaine.length() ; ++i) {
    s += tolower(chaine.at(i));
  }
  return s;
}

string ExpPaquetage::getIfndef () {
  string s = "";
  string::size_type pos = 0;
  s+=_paquetage->getNomComplet();

  pos = s.find(":");
  while (pos != string::npos) {
    s.replace(pos,1,"_");
    pos = s.find(":");
  }

  s = Majuscules(s);
  return s;
}

void ExpPaquetage::ajouterInclude (string nom){
  string s = "";
  std::vector<string>::iterator it;
  s += Minuscules(nom) + ".h";
  it=_listeInclude.begin();
  while(it!=_listeInclude.end() && (s != *it) ){
    ++it;
  }
  if(it == _listeInclude.end()){
    _listeInclude.push_back(s);
  }

}

void ExpPaquetage::setPepe(){
  _pepe = _pere->getPepe();
}

ExpObjetFichier * ExpPaquetage::getPepe(){
  return _pepe;
}
