/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      exprelation.h                           */
/************************************************/

#ifndef EXPRELATION_H
#define EXPRELATION_H


#include <string>


#ifndef EXPINCLUDE_H
class ExpInclude ;
#endif
#ifndef NOYCLASSE_H
class Classe;
#endif
#ifndef NOYCOMMUN_H
class Commun;
#endif
#ifndef NOYRELATION_H
class Relation;
#endif
#ifndef EXPEXPORT_H
class ExpExport;
#endif
#ifndef EXPCLASSE_H
class ExpClasse;
#endif

/**Cette classe fait les modifications dans la structure pour coder une relation
 * Elle gnralise les 4 types de relations gres
 * @author A.Pique
 */
class ExpRelation {
  
 protected:
  //! Relation attache  la source (true) ou  la destination (false)
  bool _type; 
  
 public:
  //! Constructeur
  ExpRelation();
  
  /**Contructeur d'une ExpRelation
   * \param Relation * r : Relation rcupre du noyau
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param ExpObjetFichier * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  ExpRelation(Relation * r, ExpClasse *c, ExpExport * racine);
  
  /**Fonction permettant de rcuprer l'autre classe li  la relation
   * \param ExpClasse * c
   * \param Relation * r
   * \param ExpObjetFichier * racine
   */
  ExpClasse * getClasseDest(ExpClasse * c, Relation * r, ExpExport * racine);
  
  /**
   * Fonction testant si la chane fournie en argument est un identificateur C++ ou Java
   * \param string chaine : chane  tester
   * \return true si c'est un identificateur, false sinon
   */
  bool isIdentifier ( string chaine ); 

  /**
   * Fonction testant si la chane fournie en argument est un caractre de l'alphabet
   * \param string s : chane  tester
   * \return true si c'est un caractre de l'alphabet , false sinon
   */
  bool isAlpha(string s);

  /**
   * Fonction testant si la chane fournie en argument est un chiffre
   * \param string s : chane  tester
   * \return true si c'est un chiffre, false sinon
   */
  bool isDigit(string s);

  /**
   * Fonction testant si la chane fournie en argument est un nombre positif diffrent de 0
   * \param string chaine : chane  tester
   * \return true si c'est un nombre, false sinon
   */
  bool isNumber ( string chaine );

};
#endif
