/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:46 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:46 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      exputilisation.h                        */
/************************************************/

#ifndef EXPUTILISATION_H
#define EXPUTILISATION_H
#include <string>
#include "exprelation.h"
#ifndef NOYCLASSE_H
class Classe;
#endif
#ifndef NOYCOMMUN_H
class Commun;
#endif
#ifndef EXPOBJETFICHIER_H
class ExpObjetFichier;
#endif
#ifndef EXPCLASSE_H
class ExpClasse;
#endif
#ifndef NOYUTILISATION_H
class Utilisation;
#endif
#ifndef NOYAGREGATION_H
class Agregation;
#endif
#ifndef NOYHERITAGE_H
class Heritage;
#endif
#ifndef NOYASSOCIATION_H
class Association;
#endif
#ifndef EXPDEFINE_H
class ExpDefine;
#endif


/**Cette classe fait les modifications dans la structure pour coder une utilisation
 * @author A.Pique
 */
class ExpUtilisation:public ExpRelation  {
    
 public:
  /**Contructeur d'une ExpUtilisation
   * \param Utilisation * u : Utilisation rcupre du noyau
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param ExpExport * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  ExpUtilisation(Utilisation * u, ExpClasse *c, ExpExport * racine);

  /**Fonction permettant de traiter les changements  faire dans la classe source
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param Relation * r : Relation rcupre du noyau
   * \param ExpExport * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  void traiterSource(ExpClasse * c, Relation * r, ExpExport * racine);
  /**Fonction permettant de traiter les changements  faire dans la classe destination
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param Relation * r : Relation rcupre du noyau
   * \param ExpExport * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  void traiterDestination(ExpClasse * c, Relation * r, ExpExport * racine);
  
};


#endif

