#include <ihmarbre.h>
#include <ihmvisiteuritem.h>
#include <ihmfenetreprincipale.h>
#include <ihmpetitefenetre.h>
#include <ihmeditercode.h>

Arbre::Arbre(Noyau *n, QWidget *parent=0, const char *name=0)
	: QListView(parent,name), Observateur()
{
	this->addColumn("Arbre");

	this->setSelectionMode(Single);

	noyau = n;
	noyau->abonner(this);

	itemCourant = NULL;

	v = new VisiteurArbre(noyau, this);

//	if (itemASelectionner != NULL)
//		itemASelectionner->setSelected(TRUE);

	connect(this, SIGNAL(rightButtonPressed(QListViewItem *, const QPoint &, int)), this, SLOT(cliqueDroit(QListViewItem *)));
	connect(this, SIGNAL(selectionChanged(QListViewItem *)), this, SLOT(selectionChangee(QListViewItem *)));
}

void Arbre::setItemCourant(MonListViewItem *item)
{
	itemCourant = item;
}

MonListViewItem *Arbre::getItemCourant()
{
	return itemCourant;
}

void Arbre::avertir()
{
	Projet *p = noyau->getProjet();

	delete this->firstChild();
	if (p != NULL) {
		p->accepter(v);
	}	
}

Noyau * Arbre::getNoyau()
{
	return noyau;
}

void Arbre::cliqueDroit(QListViewItem *item)
{
	if (item != NULL)
	{
		VisiteurItem *visiteurItem = new VisiteurItem((FenetrePrincipale *)topLevelWidget());
		(((MonListViewItem *)item)->getNoeud())->accepter(visiteurItem);
	}
}

void Arbre::selectionChangee(QListViewItem *item)
{
	((FenetrePrincipale *)topLevelWidget())->setNoeudCourant(((MonListViewItem *)item)->getNoeud());
	((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu()->avertir();
	((FenetrePrincipale *)topLevelWidget())->getBarreOutilsProjet()->avertir();
	((FenetrePrincipale *)topLevelWidget())->getBarreOutilsAjouter()->avertir();
	((FenetrePrincipale *)topLevelWidget())->getBarreOutilsEdition()->avertir();
	((FenetrePrincipale *)topLevelWidget())->getWidgetCentral()->getFenetreDeDessin()->avertir();
}

void Arbre::paquetageVersVue()
{
	FenetreComboPaquetage *fenetreComboPaquetage = new FenetreComboPaquetage((FenetrePrincipale *)topLevelWidget(), NULL, "fenetreComboPaquetage");
	fenetreComboPaquetage->show();
}

void Arbre::classeVersVue()
{
	FenetreComboClasse *fenetreComboClasse = new FenetreComboClasse((FenetrePrincipale *)topLevelWidget(), NULL, "fenetreComboClasse");
	fenetreComboClasse->show();
}

void Arbre::relationVersVue()
{
	FenetreComboRelation *fenetreComboRelation = new FenetreComboRelation((FenetrePrincipale *)topLevelWidget(), NULL, "fenetreComboRelation");
	fenetreComboRelation->show();
}

void Arbre::editionCode()
{
	Noeud * noeud = ((FenetrePrincipale *)topLevelWidget())->getNoeudCourant();
	cout << "Editer Code " + noeud->getNom() << endl;
	EditerCode * fenCode = new EditerCode((FenetrePrincipale *)topLevelWidget(),(Methode *) noeud, NULL, "EditerCode");
	fenCode->show();
}
