#include <qtooltip.h>
#include <qtoolbutton.h>
#include <qpixmap.h>

#include <ihmbarreoutilsajouter.h>
#include <ihmfenetreprincipale.h>
#include <noyprojet.h>

BarreOutilsAjouter::BarreOutilsAjouter(Noyau * n, QMainWindow *parent, const char *name)
	: QToolBar(parent,name), Observateur()
{
	noyau = n;
	noyau->abonner(this);

	boutonVue = new QToolButton(this);
	boutonVue->setPixmap(QPixmap("xpms/Vue.xpm"));
	QToolTip::add(boutonVue, "Ajouter une vue");

	addSeparator();

	boutonPaquetage = new QToolButton(this);
	boutonPaquetage->setPixmap(QPixmap("xpms/Paquetage.xpm"));
	QToolTip::add(boutonPaquetage, "Ajouter un paquetage");

	boutonCommentaire = new QToolButton(this);
	boutonCommentaire->setPixmap(QPixmap("xpms/Commentaire.xpm"));
	QToolTip::add(boutonCommentaire, "Ajouter un commentaire");

	boutonClasse = new QToolButton(this);
	boutonClasse->setPixmap(QPixmap("xpms/Classe.xpm"));
	QToolTip::add(boutonClasse, "Ajouter une classe");

	boutonMethode = new QToolButton(this);
	boutonMethode->setPixmap(QPixmap("xpms/Methode.xpm"));
	QToolTip::add(boutonMethode, "Ajouter un methode");

	boutonAttribut = new QToolButton(this);
	boutonAttribut->setPixmap(QPixmap("xpms/Attribut.xpm"));
	QToolTip::add(boutonAttribut, "Ajouter un attribut");

	boutonRelation = new QToolButton(this);
	boutonRelation->setPixmap(QPixmap("xpms/Relation.xpm"));
	QToolTip::add(boutonRelation, "Ajouter un relation");

	addSeparator();

	boutonExportCpp = new QToolButton(this);
	boutonExportCpp->setPixmap(QPixmap("xpms/ExporterC.xpm"));
	QToolTip::add(boutonExportCpp, "Exporter ce projet en C++");

	boutonExportJava = new QToolButton(this);
	boutonExportJava->setPixmap(QPixmap("xpms/ExporterJava.xpm"));
	QToolTip::add(boutonExportJava, "Exporter ce projet en Java");

	boutonImportCpp = new QToolButton(this);
	boutonImportCpp->setPixmap(QPixmap("xpms/ImporterC.xpm"));
	QToolTip::add(boutonImportCpp, "Importer des sources C++");

	boutonImportJava = new QToolButton(this);
	boutonImportJava->setPixmap(QPixmap("xpms/ImporterJava.xpm"));
	QToolTip::add(boutonImportJava, "Importer des soources Java");

	addSeparator();

	connect(boutonVue, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(vue()));
	connect(boutonPaquetage, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(paquetage()));
	connect(boutonCommentaire, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(commentaire()));
	connect(boutonClasse, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(classe()));
	connect(boutonMethode, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(methode()));
	connect(boutonAttribut, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(attribut()));
	connect(boutonRelation, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(relation()));
	connect(boutonExportCpp, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(exportCpp()));
	connect(boutonExportJava, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(exportJava()));
	connect(boutonImportCpp, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(importCpp()));
	connect(boutonImportJava, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(importJava()));
}

void BarreOutilsAjouter::avertir() {
	Projet * p = noyau->getProjet();
	bool ajouter;
	if (p == NULL)
		ajouter = false;
	else	ajouter = p->getAjouter();
	if ( ajouter == false )
		this->hide();
	else this->show();
}

