#include <qtooltip.h>
#include <qtoolbutton.h>
#include <qpixmap.h>

#include <ihmfenetreprincipale.h>
#include <ihmbarreoutilsedition.h>

BarreOutilsEdition::BarreOutilsEdition(Noyau * n, QMainWindow *parent, const char *name)
	: QToolBar(parent,name), Observateur()
{
	noyau = n;
	noyau->abonner(this);

	boutonCouper = new QToolButton(this);
	boutonCouper->setPixmap(QPixmap("xpms/Couper.xpm"));
	QToolTip::add(boutonCouper, "Couper");
	boutonCouper->setEnabled(FALSE);

	boutonCopier = new QToolButton(this);
	boutonCopier->setPixmap(QPixmap("xpms/Copier.xpm"));
	QToolTip::add(boutonCopier, "Copier");
	boutonCopier->setEnabled(FALSE);

	boutonColler = new QToolButton(this);
	boutonColler->setPixmap(QPixmap("xpms/Coller.xpm"));
	QToolTip::add(boutonColler, "Coller");
	boutonColler->setEnabled(FALSE);

	boutonSupprimer = new QToolButton(this);
	boutonSupprimer->setPixmap(QPixmap("xpms/Supprimer.xpm"));
	QToolTip::add(boutonSupprimer, "Supprimer");
	boutonSupprimer->setEnabled(FALSE);

	addSeparator();

	connect(boutonCouper, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(couper()));
	connect(boutonCopier, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(copier()));
	connect(boutonColler, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(coller()));
	connect(boutonSupprimer, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(supprimer()));
}

void BarreOutilsEdition::avertir() {
	Projet * p = noyau->getProjet();
	bool edition;
	FenetrePrincipale * fen = (FenetrePrincipale *)topLevelWidget();

	if ( fen->getNoeudCourant() != NULL ) {
		boutonCouper->setEnabled(TRUE);
		boutonCopier->setEnabled(TRUE);
		boutonColler->setEnabled(TRUE);
		boutonSupprimer->setEnabled(TRUE);
	} else {
		boutonCouper->setEnabled(FALSE);
		boutonCopier->setEnabled(FALSE);
		boutonColler->setEnabled(FALSE);
		boutonSupprimer->setEnabled(FALSE);
	}

	if ( p == NULL ) edition = false;
	else edition = p->getEdition();
	if ( edition == false ) 
		this->hide();
	else this->show();
}

