#include <iostream.h>
#include <qtooltip.h>
#include <qpixmap.h>
#include <qtoolbutton.h>

#include <ihmbarreoutilsprojet.h>
#include <ihmfenetreprincipale.h>

BarreOutilsProjet::BarreOutilsProjet(Noyau * n, QMainWindow *parent, const char *name)
	: QToolBar(parent,name), Observateur()
{
	noyau = n;
	noyau->abonner(this);

	boutonOuvrir = new QToolButton(this);
	boutonOuvrir->setPixmap(QPixmap("xpms/fileopen.xpm"));
	QToolTip::add(boutonOuvrir, "Ouvrir un projet existant");

	boutonNouveau = new QToolButton(this);
	boutonNouveau->setPixmap(QPixmap("xpms/filenew.xpm"));
	QToolTip::add(boutonNouveau, "Creer un nouveau projet");

	boutonEnregistrer = new QToolButton(this);
	boutonEnregistrer->setPixmap(QPixmap("xpms/filesave.xpm"));
	QToolTip::add(boutonEnregistrer, "Enregistrer le projet en cours");

	boutonInformations = new QToolButton(this);
	boutonInformations->setPixmap(QPixmap("xpms/info.xpm"));
	QToolTip::add(boutonInformations, "Informations sur le projet");	

	addSeparator();

	connect(boutonOuvrir, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(ouvrir()));
	connect(boutonNouveau, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(nouveau()));
	connect(boutonEnregistrer, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(enregistrer()));
	connect(boutonInformations, SIGNAL(clicked()), ((FenetrePrincipale *)topLevelWidget())->getBarreDeMenu(), SLOT(informations()));
}

void BarreOutilsProjet::avertir() {
	Projet * p = noyau->getProjet();
	bool projet;
	if ( p == NULL ) {
		projet = true;
		// CONDITIONS INITIALES
		boutonNouveau->setEnabled(TRUE);
		boutonOuvrir->setEnabled(TRUE);
		boutonEnregistrer->setEnabled(FALSE);
		boutonInformations->setEnabled(FALSE);
	} else {
		projet = p->getPro();
		boutonNouveau->setEnabled(FALSE);
		boutonOuvrir->setEnabled(FALSE);
		boutonEnregistrer->setEnabled(TRUE);
		boutonInformations->setEnabled(TRUE);
	}

	if ( projet == false )
		this->hide();
	else this->show();

}

