#ifndef FENETREEDITERCODE_H
#define FENETREEDITERCODE_H

#include <qwidget.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>
#include <noymethode.h>

/** Cette classe represente la fentre d'ajout/modification de code d'une mthode
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class EditerCode : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale * fen : Reference sur la fentre principale.
		 * \param commentaire * c : Rfrence du commentaire pour initialiser les champs de la fentre (Par defaut 0). Si ce parametre est 0, alors les champs sont initialiss pour un cration. Sinon pour une modification d'un commentaire dj existante.
		 * \param QWidget *parent : Ce parametre represente le widget parent de cette fentre.
		 * \param const char *name : Ce parametre represente le nom que l'on veut donner  cette fentre.
		 */
		EditerCode(FenetrePrincipale * fen, Methode * m,
				QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~EditerCode() {};

		QMultiLineEdit *editCode;

		FenetrePrincipale * fenetre;
		Methode * methode;
	public slots:
		//! Ce slot ferme la fentre sans ajouter le code  la mthode.
		void annuler();
		//! Ce slot ajoute/modifie le code. Si c'tait un ajout, ce slot ferme galement la fentre.
		void ok();
};

#endif

