#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qmessagebox.h>

#include <ihmfenetreattribut.h>
#include <noyparametre.h>

FenetreAttribut::FenetreAttribut(FenetrePrincipale * fen, Attribut * a, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen;
	attribut = a;

	setCaption("Ajouter un attribut");

	/* Classe Mre */
	QGroupBox *groupClasse = new QGroupBox(1, Vertical, "Classe Mre", this, "groupClasse" );
	if ( attribut == NULL ) 
		if (fen->estClasse(fen->getNoeudCourant())) comboClasse = new MonComboClasse ((Classe *)fen->getNoeudCourant(), fenetre, groupClasse, "comboClasse" );
		else comboClasse = new MonComboClasse (NULL, fenetre, groupClasse, "comboClasse" );
	else comboClasse = new MonComboClasse ((Classe *)attribut->getPere(), fenetre, groupClasse, "comboClasse" );

	/* Zone de visibilit */
	QGroupBox *groupVisibilite = new QGroupBox (1, Vertical,"Visibilit", this, "groupVisibilite");
	comboVisibilite = new QComboBox (groupVisibilite, "comboVisibilite");
	comboVisibilite->insertItem ( "public", 0 );
	comboVisibilite->insertItem ( "protected", 1 );
	comboVisibilite->insertItem ( "private", 2 );

	/* Zone de type */
	QGroupBox *groupType = new QGroupBox (2, Horizontal,"Type", this, "groupType");
	comboType = new ComboType(groupType, "comboType");
	connect( comboType, SIGNAL(activated(int)),SLOT(autre(int)));
	editType = new QLineEdit(groupType, "editType");
	editType->setEnabled ( false );

	/* Zone d'entre de nom */	
	QGroupBox *groupNom = new QGroupBox (1, Vertical,"Nom", this, "groupNom" );
	editNom = new QLineEdit (groupNom, "editNom"); 

	/* Description */
	QGroupBox *groupDescription = new QGroupBox (1, Vertical,"Desciption", this, "groupDescription" );
	editDescription = new QMultiLineEdit(groupDescription , "editDescription");

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 12, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupClasse, 1, 0);
	grille->addWidget(groupVisibilite, 3, 0);
	grille->addWidget(groupType, 5, 0);
	grille->addWidget(groupNom, 7, 0);
	grille->addWidget(groupDescription, 9, 0);
	grille->addLayout(bouton, 11, 0);

	/* boutons */
	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	bouton->addWidget(ok, 0, 1);

	if ( attribut == NULL ) {
		setGeometry(100,100,400,300);
		QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");
		connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
		bouton->addWidget(annuler, 0, 2);
	} else {
		setMinimumSize( parent->size() );
		adjustSize();

		comboClasse->setEnabled(FALSE);

		if ( QString(a->getVisible().c_str()).compare("public") == 0 ) comboVisibilite->setCurrentItem(0);
		else if ( QString(a->getVisible().c_str()).compare("protected") == 0 ) comboVisibilite->setCurrentItem(1);
		else comboVisibilite->setCurrentItem(2);

		comboType->setCurrentItem(0);
		editType->setEnabled(TRUE);
		editType->setText( a->getType().c_str() );

		editNom->setText( a->getNom().c_str() );

		editDescription->setText( a->getDescription().c_str() );
	}

}
void FenetreAttribut::autre(int index)
{
	if( index == 10 )
		editType->setEnabled ( true );
	else
		editType->setEnabled ( false );
}
void FenetreAttribut::ok()
{
	Classe *classe;
	QString nom = editNom->text().replace(QRegExp(" "),"");

	if ( nom == "" ) {
		QMessageBox::information(0, "Attribut d'un attribut", "Un attribut ne peut pas avoir un nom vide");
		return ;
	}

	QString type = comboType->currentText().replace(QRegExp(" "),"");

	if ( type == "autres" ) type = editType->text().replace(QRegExp(" "),"");
	if ( type == "" ) {
		QMessageBox::information(0, "Ajouter un attribut", "Un attribut ne peut pas avoir un type vide");
		return ;
	}

	QString visibilite = comboVisibilite->currentText();

	if ( attribut == NULL ) {
		//Classe * classe ;

		std::vector<Classe*>::iterator it = fenetre->vctClasse.begin();
		int i = 0;
		while( i<comboClasse->currentItem() ) {
			++it;
			++i;
		}
		classe = *it ;

		if ( classe->ajouterAttribut( string(type) , string(nom) , string(visibilite) ) == FALSE ) {
				QMessageBox::information(0, "Ajouter un attribut", "Impossible d'ajouter un attribut ici");
				return ;
		}
		
		/* recuperation du nouvel attribut */
		attribut = classe->verifierExistenceAttribut( string(nom), 
				string(visibilite), string(type));

		cout << "AJOUT (attribut) " << attribut << "  " << classe << endl;
		if ( attribut != NULL ) attribut->setDescription( string(editDescription->text()) );

		Projet *p = fenetre->getNoyau()->getProjet();
		if (p->getAccesseur() == true){
			attribut->setVisible("private");
			std::vector<Parametre *> vp;
			classe->ajouterMethode("get"+string(nom),string(type),"public",vp);
			Parametre *nouvp;
			nouvp = new Parametre();
			nouvp->setNom(string(nom));
			nouvp->setType(string(type));
			vp.push_back(nouvp);
		
			classe->ajouterMethode("set"+string(nom),"void","public",vp);
		
		}		
		fenetre->getNoyau()->notifier();
		delete(this);

	} else {

		attribut->setVisible( string(comboVisibilite->currentText()) );
		attribut->setDescription( string(editDescription->text()) );
		attribut->setType( string(type) );
		attribut->setNom( string(nom) );		
		fenetre->getNoyau()->notifier();
	}	
}

void FenetreAttribut::annuler()
{
	delete(this);
}


