/************************************************/
/*	Frederic Duchaussoy			*/
/************************************************/
/*	29/01/02				*/
/************************************************/
/*	30/01/02 				*/
/************************************************/
/*	0.1	cration			*/
/************************************************/
/*	Fenetre de creation d'une classe	*/
/************************************************/

#ifndef FENETRECLASSE_H
#define FENETRECLASSE_H

#include <qwidget.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qcheckbox.h>

#include <ihmfenetreprincipale.h>
#include <ihmmoncombopaquetage.h>
#include <noyclasse.h>

/** Cette classe represente la fentre d'ajout/modification d'une classe.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetreClasse : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale * fen : Reference sur la fentre principale.
		 * \param Classe * c : Rfrence de la classe pour initialiser les champs de la fenetre (Par defaut 0). Si ce parametre est 0, alors les champs sont initialiss pour un cration. Sinon pour une modification d'une classe dj existante.
		 * \param QWidget *parent : Represente le widget parent de cette fentre (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner  notre fentre.
		 */
		FenetreClasse(FenetrePrincipale * fen, Classe * c=0,
				QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreClasse() {};

		QLineEdit *editNom;
		MonComboPaquetage *comboPaquetage;
		QComboBox *comboVisibilite;
		QMultiLineEdit * editDescription ;
		QCheckBox *checkInterface;

		FenetrePrincipale * fenetre;
		Classe * classe;
	public slots:
		//! Ce slot ferme la fentre sans ajouter la classe.
		void annuler();

		//! Ce slot ajoute/modifie la classe en fonction des champs de la fentre. Ce slot ferme galement la fentre si c'tait un ajout.
		void ok();
};

#endif

