#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qmultilineedit.h> 
#include <qmessagebox.h>

#include <ihmfenetrecommentaire.h>

FenetreCommentaire::FenetreCommentaire(FenetrePrincipale * fen, Commentaire * c,
	QWidget *parent, const char *name) : QWidget(parent,name)
{
	fenetre = fen;
	commentaire = c;

	setCaption("Ajouter un commentaire");
	
	/* Zone de nom */
	QGroupBox *groupNom = new QGroupBox (1, Vertical,"Nom", this, "groupNom");
	editNom = new QLineEdit(groupNom,"editNom");  

	/* Zone de texte */
	QGroupBox *groupCommentaire = new QGroupBox (1, Vertical,"Commentaires", this, "groupCommentaire");
	editCommentaire = new QMultiLineEdit(groupCommentaire,"editCommentaire");  

	/* combo de vue */
	QGroupBox *groupVue = new QGroupBox (1, Vertical, "Vue", this, "groupVue");
	comboVue = new MonComboVue(fenetre->getNoyau()->getProjet()->getDiagrammeStatique() , groupVue, "comboVue" );

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 7, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupVue, 1, 0);
	grille->addWidget(groupNom, 3, 0);
	grille->addWidget(groupCommentaire, 5, 0);
	grille->addLayout(bouton, 7, 0);

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	bouton->addWidget(ok, 0, 1);

	if ( commentaire == NULL ) {
		setGeometry(100,100,400,300);
		QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");
		bouton->addWidget(annuler, 0, 2);
		connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
	} else {
		if ( parentWidget() == NULL ) setMinimumSize( 400 , 300 );
		else setMinimumSize(parentWidget()->size());
		
		adjustSize();

		comboVue->setEnabled(FALSE);
		editNom->setText( QString(commentaire->getNom().c_str()) );
		editCommentaire->insertLine( QString(commentaire->getCommentaire().c_str()) );
	}
}
void FenetreCommentaire::ok()
{
	
	if ( commentaire == NULL ) {
		DiagrammeStatique * dg = fenetre->getNoyau()->getProjet()->getDiagrammeStatique();

		std::vector<Vue*> vctVue = dg->getVctVue();
		std::vector<Vue*>::iterator it = vctVue.begin();

		int vueID = comboVue->currentItem();
		for ( int i=0 ; i<vueID ; ++i ) ++it;
		Vue * vue = (*it);

		if (editNom->text() == ""){
			QMessageBox::warning(0,"Fenetre Commentaire","Un commentaire doit avoir un nom");
			return;
		}
		
		commentaire = new Commentaire( string(editCommentaire->text()) );
		commentaire->setNom( string(editNom->text()) );
		if ( vue->ajouterElementDeModelisation ( commentaire , 200 , 200 , 100 , 100 , true ) == FALSE )
			QMessageBox::information(0,"Ajout d'un commentaire","impossible d'ajouter un commentaire dans cette vue");
		else {
			cout << "AJOUT (commentaire) " << commentaire << " dans la vue " << vue << endl;
			commentaire->setPere(vue);
			fenetre->setNoeudCourant(commentaire);
			delete(this);
		}
	} else {
		commentaire->setNom( string(editNom->text()) );
		commentaire->setCommentaire( string(editCommentaire->text()) );
		if ( parentWidget() == NULL ) delete(this);
	}
	fenetre->getNoyau()->notifier();
}

void FenetreCommentaire::annuler()
{
	delete(this);
}


