/************************************************/
/*	Frederic Duchaussoy			*/
/************************************************/
/*	29/01/02				*/
/************************************************/
/*	30/01/02 				*/
/************************************************/
/*	0.1	cration			*/
/************************************************/
/*	Fenetre de creation d'un commentaire	*/
/************************************************/

#ifndef FENETRECOMMENTAIRE_H
#define FENETRECOMMENTAIRE_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>
#include <noycommentaire.h>
#include <ihmmoncombovue.h>

/** Cette classe represente la fentre d'ajout/modification de commentaire
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetreCommentaire : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale * fen : Reference sur la fentre principale.
		 * \param commentaire * c : Rfrence du commentaire pour initialiser les champs de la fentre (Par defaut 0). Si ce parametre est 0, alors les champs sont initialiss pour un cration. Sinon pour une modification d'un commentaire dj existante.
		 * \param QWidget *parent : Ce parametre represente le widget parent de cette fentre.
		 * \param const char *name : Ce parametre represente le nom que l'on veut donner  cette fentre.
		 */
		FenetreCommentaire(FenetrePrincipale * fen, Commentaire * c=0,
				QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreCommentaire() {};

		QLineEdit *editNom;
		QMultiLineEdit *editCommentaire;
		MonComboVue * comboVue;

		FenetrePrincipale * fenetre;
		Commentaire * commentaire;
	public slots:
		//! Ce slot ferme la fentre sans ajouter le commentaire.
		void annuler();
		//! Ce slot ajoute/modifie le commentaire en fonction des champs de la fentre. Si c'tait un ajout, ce slot ferme galement la fentre.
		void ok();
};

#endif

