#include <qwidget.h>
#include <qapplication.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qmessagebox.h>

#include <ihmfenetrecreerprojet.h>
#include <noyprojet.h>

FenetreCreerProjet::FenetreCreerProjet(FenetrePrincipale * fen, QWidget *parent, const char *name) 
	: QWidget(parent,name)
{
	fenetre = fen;

	Noyau * n = fenetre->getNoyau() ;
	Projet * p = n->getProjet();

	setCaption("Crer un nouveau projet");

	QGridLayout *grille = new QGridLayout( this, 4, 2, 10 );
	QGridLayout *bouton = new QGridLayout( 0, 1, 3);

	QPushButton *Ok = new QPushButton( "&Ok", this, "Ok" );
	connect( Ok, SIGNAL(clicked()), this, SLOT(ok()) );

	QLabel *LabelNomProjet = new QLabel( "Nom du Projet", this, "LabelNomProjet");
	QLabel *LabelNomAuteur = new QLabel( "Noms des Auteurs", this, "LabelNomAuteur"); 
	QLabel *LabelVersion = new QLabel( "Numro de Version", this, "LabelVersion");  
	QLabel *LabelCommentaire = new QLabel( "Commentaires", this, "LabelCommentaire");

	grille->addWidget(LabelNomProjet, 0, 0);
	grille->addWidget(LabelNomAuteur, 1, 0);
	grille->addWidget(LabelVersion, 2, 0);
	grille->addWidget(LabelCommentaire, 3, 0);
	grille->addLayout(bouton, 4, 1);

	bouton->addWidget(Ok, 1, 1);

	if ( p == NULL ) {
		setGeometry(100,100,600,400);
		EditNomProjet = new QLineEdit("Nom du Projet", this, "EditNomProjet"); 
		EditNomAuteur = new QLineEdit("Noms des Auteurs", this, "EditNomAuteur");
		EditVersion = new QLineEdit("Version", this, "EditVersion");
		EditDescription = new QMultiLineEdit( this, "EditDescription");

		QPushButton *Annuler = new QPushButton( "&Annuler", this, "Annuler");
		connect( Annuler, SIGNAL(clicked()), this, SLOT(annuler()));
		bouton->addWidget(Annuler, 1, 2);
	} else {
		setMinimumSize( parentWidget()->width() , parentWidget()->height() );
		adjustSize();
		EditNomProjet = new QLineEdit( QString(p->getNom().c_str()) , this );
		EditNomAuteur = new QLineEdit( QString(p->getAuteur().c_str()) , this );
		EditVersion = new QLineEdit( QString(p->getVersion().c_str()) , this );
		EditDescription = new QMultiLineEdit( this );
		EditDescription->setText( QString(p->getCommentaire().c_str()) );
	}

	grille->addWidget(EditNomProjet, 0, 1);
	grille->addWidget(EditNomAuteur, 1, 1);
	grille->addWidget(EditVersion, 2, 1);
	grille->addWidget(EditDescription, 3, 1);
}

FenetreCreerProjet::~FenetreCreerProjet()
{
	delete(EditNomProjet);
	delete(EditNomAuteur);
	delete(EditVersion);
	delete(EditDescription);
}

void FenetreCreerProjet::ok()
{
	Noyau * n = fenetre->getNoyau() ;
	Projet * p = n->getProjet();

	if ( p == NULL ) {
		if ( EditNomProjet->text() == "" )
				QMessageBox::information(0,"Crer un nouveau projet", "Le nom du projet ne doit pas tre vide");
		else{
			n->creerProjet( string(EditNomProjet->text()) , 
							string(EditNomAuteur->text()), 
							string(EditVersion->text()), 
							string(EditDescription->text()) );
			fenetre->setNoeudCourant(n->getProjet());
			delete(this);
		}
	} else {
		if ( EditNomProjet->text() == "" )
				QMessageBox::information(0,"Visualiser un projet", "Le nom du projet ne doit pas tre vide");
		else{
			p->setNom( string(EditNomProjet->text()) );
			p->setAuteur( string(EditNomAuteur->text()) );
			p->setVersion( string(EditVersion->text()) );
			p->setCommentaire( string(EditDescription->text()) );
		}
	}
	n->notifier();
}

void FenetreCreerProjet::annuler()
{
	delete(this);
}


