#ifndef FENETRECREERPROJET_H
#define FENETRECREERPROJET_H

#include <iostream.h>
#include <qwidget.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>

#include <ihmfenetreprincipale.h>

/** Cette classe represente une fentre de cration/modification d'un projet.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetreCreerProjet : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale * fen : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent de cette fentre (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner  cette fentre (Par defaut 0).
		 */
		FenetreCreerProjet(FenetrePrincipale * fen,
					QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreCreerProjet();

		QLineEdit *EditNomProjet, *EditNomAuteur, *EditVersion ;
		QMultiLineEdit *EditDescription ;

	private:
		FenetrePrincipale * fenetre ;
	public slots:
		//! Ce slot ferme la fentre en prenant en compte les changements.
		void ok();
		//! Ce slot ferme la fentre sans prendre en compte les changements.
		void annuler();
};

#endif

