#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qlineedit.h> 
#include <iostream.h>
#include <qlabel.h>
#include <qfiledialog.h>
#include <noynoyau.h>
#include <noyprojet.h>

#include <ihmfenetreexport.h>
FenetreExport::FenetreExport(FenetrePrincipale *fen, int t, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	type = t;
	n=fen->getNoyau();
	Projet * p=n->getProjet();
	setGeometry(100,100,400,300);
	setCaption("Exportation");

	QString stringNom = QString(p->getNom().c_str());
	QString stringAuteur = QString(p->getAuteur().c_str());

	/* Boutons */
	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");

	/* Zone informations du projet */
	QGroupBox *groupInfo = new QGroupBox (2, Horizontal,"Informations sur le projet", this, "groupInfo");
	QLabel *labelNom;
	labelNom = new QLabel("Nom du Projet",groupInfo,"labelNom");
	editNom = new QLineEdit(groupInfo,"editNom");
	editNom->setText(stringNom);
	editNom->setEnabled ( false );

	QLabel *labelAuteur;
	labelAuteur = new QLabel("Auteur",groupInfo,"labelAuteur");
	editAuteur = new QLineEdit(groupInfo,"editAuteur");
	editAuteur->setText(stringAuteur);
	editAuteur->setEnabled( false ); 	

	/* Zone de chemin */
	QGroupBox *groupChemin = new QGroupBox (2, Horizontal,"rpertoire d'exportation", this, "groupChemin");
	editChemin = new QLineEdit(groupChemin,"editChemin");  
	QPushButton *chercher = new QPushButton ( "Chercher", groupChemin, "chercher");


	/* Connection des boutons */
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( chercher, SIGNAL(clicked()), this, SLOT(chercher()));

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 5, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupInfo, 1, 0);
	grille->addWidget(groupChemin, 3, 0);
	grille->addLayout(bouton, 5, 0);
	bouton->addWidget(ok, 0, 1);
	bouton->addWidget(annuler, 0, 2);
}
void FenetreExport::ok()
{
	string nom = string(editNom->text());
	string auteur = string(editAuteur->text());
	string chemin = string(editChemin->text());
	n->exporter(type, nom, auteur, chemin); 
	delete(this);
}
void FenetreExport::annuler()
{
	delete(this);
}
void FenetreExport::chercher()
{
	QString cheminExportation = QFileDialog::getExistingDirectory ( "", this, "repertoire importation" );
	editChemin->setText(cheminExportation);	 
}
