#ifndef FENETREEXPORT_H
#define FENETREEXPORT_H

#include <qwidget.h>
#include <qlineedit.h>
#include <ihmfenetreprincipale.h>

/** Cette classe represente la fentre de lancement de l'exportation.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetreExport : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale *fen : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent de la fentre.
		 * \param int t : Represente le type d'export ( EXP_CPP pour export C++, EXP_JAVA pour export en JAVA)
		 * \param const char *name : Represente le nom que l'on veut donner  la fentre.
		 */
		FenetreExport(FenetrePrincipale *fen, int t, QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreExport() {};
		QLineEdit *editChemin,*editNom,*editAuteur;

	private:
		int type;
		Noyau * n;
 
	public slots:
		//! Ce slot ferme la fentre sans lancer l'export ni prendre en compte ls changements. 
		void annuler();

		//! Ce slot ferme la fentre et lance l'export en fonction des informations recueillies dans les champs de la fentre.
		void ok();
	
		//! Ce slot
		void chercher();
};

#endif
