#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qstring.h>
#include <qmessagebox.h>

#include <ihmfenetremethode.h>

FenetreMethode::FenetreMethode(FenetrePrincipale * fen, Methode * m,
	QWidget *parent, const char *name) : QWidget(parent,name)
{
	fenetre= fen;
	methode = m;
	setCaption("Ajouter une mthode");

	/* Zone d'appartenance  une classe */
	QGroupBox *groupClasse = new QGroupBox (1, Vertical,"Classe Mre", this, "groupClasse");
	if ( methode == NULL ) 
		if (fen->estClasse(fen->getNoeudCourant())) comboClasse = new MonComboClasse ((Classe *)fen->getNoeudCourant(), fenetre, groupClasse, "comboClasse" );
		else comboClasse = new MonComboClasse (NULL, fenetre, groupClasse, "comboClasse" );
	else comboClasse = new MonComboClasse ((Classe *)methode->getPere(), fenetre, groupClasse, "comboClasse" );

	/* Zone de visibilit */
	QGroupBox *groupVisibilite = new QGroupBox (1, Vertical,"Visibilit", this, "groupVisibilite");
	comboVisibilite = new QComboBox (groupVisibilite, "comboVisibilite");
	comboVisibilite->insertItem ( "public", 0 );
	comboVisibilite->insertItem ( "protected", 1 );
	comboVisibilite->insertItem ( "private", 2 );

	/* Zone de type de retour */
	QGroupBox *groupType = new QGroupBox (1, Vertical,"Type de retour", this, "groupType" );
	comboType = new ComboType (groupType , "comboType");
	connect( comboType, SIGNAL(activated(int)),SLOT(autreType(int)));
	editType = new QLineEdit (groupType, "editNom");
	editType->setEnabled( false ); 

	/* Zone d'entre de nom */	
	QGroupBox *groupNom = new QGroupBox (1, Vertical,"Nom", this, "groupNom" );
	editNom = new QLineEdit (groupNom, "editNom"); 
	
	/* Zone de choix de paramtres */
	QGroupBox *groupParam = new QGroupBox(3, Vertical,"Paramtres", this, "groupParam");
	comboTypeParam = new ComboType(groupParam, "comboTypeParam");
	editTypeParam = new QLineEdit(groupParam, " editTypeParam");
	editTypeParam->setEnabled( false );
	editParam = new QLineEdit(groupParam, "editParam");
	comboParam= new QListBox(this,"comboParam", 0);

	connect( comboTypeParam, SIGNAL(activated(int)),SLOT(autre(int)));
	QPushButton *ajouter = new QPushButton( "&Ajouter", groupParam, "ajouter");
	connect( ajouter, SIGNAL(clicked()), this, SLOT(ajouter()));
	QPushButton *supprimer = new QPushButton( "&Supprimer", groupParam, "supprimer"); 
	connect( supprimer, SIGNAL(clicked()), this, SLOT(supprimer()));
	
	/* Description */
	QGroupBox *groupDescription = new QGroupBox (1, Vertical,"Description", this, "groupDescription" );
	editDescription = new QMultiLineEdit(groupDescription , "editDescription");

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 13, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
	QGridLayout *param = new QGridLayout(1, 2, 1);
 
	/* placement des lments */
	grille->addWidget(groupClasse, 1, 0);
	grille->addWidget(groupVisibilite, 3, 0);
	grille->addWidget(groupType, 5, 0);
	grille->addWidget(groupNom, 7, 0);
	grille->addWidget(groupDescription, 9, 0);
	grille->addLayout(param, 11, 0);
	grille->addLayout(bouton, 13, 0);
	param->addWidget(groupParam, 0, 0);
	param->addWidget(comboParam, 0, 1);

	/* Connection des boutons */
	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	bouton->addWidget(ok, 0, 1);

	if ( methode == NULL ) {
		setGeometry(100,100,400,300);

		QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");
		connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
		bouton->addWidget(annuler, 0, 2);

	} else {

		setMinimumSize ( parent->size() );
		adjustSize();

		comboClasse->setEnabled(FALSE);

		if ( methode->getVisible().compare("public") == 0 ) comboVisibilite->setCurrentItem(0);
		else if ( methode->getVisible().compare("protected") == 0 ) comboVisibilite->setCurrentItem(1);
		else comboVisibilite->setCurrentItem(2);

		comboType->setCurrentItem(10);

		QString t = QString(methode->getTypeRetour().c_str());
		editType->setText( t );

		editNom->setText( QString(methode->getNom().c_str()) );
	
		if (!t.compare("") ){
			comboType->setEnabled(false);
			editNom->setEnabled(false);
			editType->setEnabled(false);
			comboVisibilite->setEnabled(false);
		}
		

		methode->cloneVctParametre( vctParametre );
		std::vector<Parametre*>::iterator it = vctParametre.begin() ;
		QString parametre ;
		while ( it != vctParametre.end() ) {
				parametre = QString(string((*it)->getType() + " " +  (*it)->getNom()).c_str()) ;
				comboParam->insertItem(parametre);
				++it;
		}

		editDescription->setText( m->getDescription().c_str() );

		std::vector <Attribut *> vctAttribut;
		std::vector<Attribut *>::iterator it2; 
		vctAttribut = ((Classe*)m->getPere())->getVctAttribut();

		it2=vctAttribut.begin();
		while( it2 != vctAttribut.end())
		{
			if (((string((editNom->text())).find((*it2)->getNom()))) != string::npos )
				if (((string((editNom->text())).find("set"))) || ((string((editNom->text())).find("get"))))
					if(((string(editNom->text()).size())) == (*it2)->getNom().size()+3){	
						comboType->setEnabled(false);
						editNom->setEnabled(false);
						editType->setEnabled(false);
						comboVisibilite->setEnabled(false);
						comboParam->setEnabled(false);
						comboTypeParam->setEnabled(false);
						editTypeParam->setEnabled(false);
						editParam->setEnabled(false);
						ajouter->setEnabled(false);
						supprimer->setEnabled(false);
					}
			++it2;
		}
	}
}

void FenetreMethode::ajouter()
{
	QString nom = editParam->text().replace(QRegExp(" "),"");
	if ( nom == "" ) {
		QMessageBox::warning(0,"Ajouter un parametre","un paramtre ne doit pas avoir un nom vide");
		return;
	}

	QString type=comboTypeParam->currentText ();
	if( type == "autres" )
		type=editTypeParam->text().replace(QRegExp(" "),"");
	if( type == "" ) {
		QMessageBox::warning(0,"Ajouter un parametre","un paramtre ne doit pas avoir un type vide");
		return;
	}

	Parametre * p = new Parametre();
	p->setNom( string(nom) );
	p->setType( string(type) );
	vctParametre.push_back(p);

	QString final=type+" "+nom;
	comboParam->insertItem(final);
}

void FenetreMethode::supprimer()
{
	int i ;
	int choix = comboParam->currentItem ();
	std::vector<Parametre*>::iterator it;

	it=vctParametre.begin();
	for( i=0 ; i<choix ; i++ ) ++it;
	vctParametre.erase(it);
	comboParam->removeItem(choix);
}

void FenetreMethode::autre(int index)
{
	if( index == 10 )
		editTypeParam->setEnabled ( true );
	else
		editTypeParam->setEnabled ( false );
}

void FenetreMethode::autreType(int index)
{
		if( index == 10 )
		editType->setEnabled ( true );
	else
		editType->setEnabled ( false );
	
	/*if( comboType->currentText().compare("autres") == 0 )
		editType->setEnabled ( true );
	else
		editType->setEnabled ( false );*/
}

void FenetreMethode::ok()
{
	QString visibilite = comboVisibilite->currentText();

	QString nom = editNom->text().replace(QRegExp(" "),"");
	if ( nom == "" ) {
		QMessageBox::warning(0, "Nom d'une mthode", "Une mthode ne peut pas avoir un nom vide");
		return ;
	}

	QString type = comboType->currentText().replace(QRegExp(" "),"");

	if ( type == "autres" ) type = editType->text().replace(QRegExp(" "),"");
	/*if ( type == "" ) {
			QMessageBox::information(0, "Ajouter une mthode", "Une mthode doit avoir un type de retour");
			return ;
	}*/

	if ( methode == NULL ) {
		Classe * classe ;

		std::vector<Classe*>::iterator it = fenetre->vctClasse.begin();
		int i = 0;
		while( i<comboClasse->currentItem() ) {
			++it;
			++i;
		}
		classe = *it ;

		if (type == ""){
			if (string(nom) != classe->getNom()){
				QMessageBox::warning(0, "Ajouter une mthode", "Une mthode doit :\n\tavoir un type de retour\n\tou avoir le mme nom que la classe (constructeur)");
				return ;
			}
			else {
				if (visibilite != "public"){
					QMessageBox::warning(0,"Ajouter une mthode","il est prfrable que la visibilit soit 'public' ");
					visibilite = "public";
				}
			}
		}
		else {
			if (string(nom) == classe->getNom()){
				QMessageBox::warning(0, "Ajouter une mthode", "Un constructeur ne peut avoir un type de retour");
				return ;
			}
		}

		if ( classe->ajouterMethode( string(nom) , string(type) , string(visibilite), vctParametre ) == FALSE ) {
				QMessageBox::warning(0, "Ajouter une mthode", "Impossible d'ajouter une mthode ici");
				return ;
		}
		
		/* recuperation du nouvel attribut */
		methode = classe->verifierExistenceMethode( string(nom), string(visibilite), string(type), vctParametre );
		cout << "AJOUT (methode) " << methode << "  " << classe << endl;
		if (methode != NULL ) methode->setDescription( string(editDescription->text()) );		

		delete(this);

	} else {
		methode->setDescription( string(editDescription->text()));
		methode->setVisible( string(visibilite) );
		methode->setTypeRetour( string(type) );
		methode->setNom( string(nom) );

		std::vector<Parametre*> vctTemp ;
		std::vector<Parametre*>::iterator it ;
		methode->cloneVctParametre( vctTemp );

		it = vctTemp.begin();
		while ( it != vctTemp.end() )
		{
		methode->supprimerParametre( *it );
		++it;
		}
		it = vctParametre.begin();
		while ( it != vctParametre.end() )
		{
		methode->ajouterParametre( *it );
		++it;
		}

	}
	fenetre->getNoyau()->notifier();
}
void FenetreMethode::annuler()
{
	delete(this);
}

