#ifndef FENETREPAQUETAGE_H
#define FENETREPAQUETAGE_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>
#include <ihmmoncombopaquetage.h>
#include <noypaquetage.h>

/** Cette classe represente la fentre de cration/modification d'un paquetage.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetrePaquetage : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale * fen : Reference sur la fentre principale de l'application.
		 * \param Paquetage * p : Rfrence du paquetage pour initialiser les champs de la fenetre (Par defaut 0). Si ce parametre est 0, alors les champs sont initialiss pour un cration. Sinon, pour une modification d'un paquetage dj existant.
		 * \param QWidget *parent : Represente le widget parent de la fentre.
		 * \param const char *name : Represente le nom que l'on veut donner  la fentre.
		 */
		FenetrePaquetage(FenetrePrincipale * fen, Paquetage * p=0,
				QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetrePaquetage() {};

		QLineEdit *editNom;
		MonComboPaquetage *comboPaquetage; 
		QMultiLineEdit * editDescription;
	private:
		Paquetage * paquetage;
		FenetrePrincipale * fenetre;
	public slots:
		//! Cette methode ferme la fentre sans ajouter le paquetage.
		void annuler();

		//! Ce slot ajoute/modifie le paquetage en fonction des champs de la fentre. Ce slot ferme galement la fentre si c'tait un ajout.
		void ok();
};

#endif

