#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qlineedit.h> 
#include <iostream.h>
#include <qlabel.h>
#include <qfiledialog.h>
#include <noynoyau.h>
#include <noyprojet.h>

#include <ihmfenetreparseurcpp.h>
FenetreParseurCpp::FenetreParseurCpp(FenetrePrincipale *fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen ;
	noyau=fen->getNoyau();

	setGeometry(100,100,400,500);
	setCaption("Importation C++");
	/* Boutons */
	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");

	/* Zone liste de fichiers */
	QGroupBox *groupFichier = new QGroupBox (2, Vertical,"Fichier  inclure", this, "groupFichier");
	listFichier = new QListBox(groupFichier,"listFichier");
	QGroupBox *groupBoutonFic = new QGroupBox (2, Horizontal,"", groupFichier, "groupBoutonFic");
	QPushButton *ajouterFic = new QPushButton ( "Ajouter", groupBoutonFic, "ajouterFic");
	QPushButton *supprimerFic = new QPushButton ( "Supprimer", groupBoutonFic, "supprimerFic");	

	/* Zone liste parametre compilation */
	QGroupBox *groupParam = new QGroupBox (3, Vertical,"Paramtres de compilation", this, "groupParam");
	listParam = new QListBox(groupParam,"listParam");
	editParam = new QLineEdit(groupParam,"editParam");
	listParam->insertItem("-I.",-1);
	listParam->insertItem("-I/usr/include",-1);
	QGroupBox *groupBoutonParam = new QGroupBox (3, Horizontal,"", groupParam, "groupBoutonParam");
	QPushButton *ajouterParam = new QPushButton ( "Ajouter", groupBoutonParam, "ajouterParam");
	QPushButton *modifierParam = new QPushButton ( "Modifier", groupBoutonParam, "modifierParam");
	QPushButton *supprimerParam = new QPushButton ( "Supprimer", groupBoutonParam, "supprimerCass");	

	/* Connection des boutons */
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( ajouterFic, SIGNAL(clicked()), this, SLOT(ajouterfic()));
	connect( supprimerFic, SIGNAL(clicked()), this, SLOT(supprimerfic()));
	connect( ajouterParam, SIGNAL(clicked()), this, SLOT(ajouterparam()));
	connect( modifierParam, SIGNAL(clicked()), this, SLOT(modifierparam()));
	connect( supprimerParam, SIGNAL(clicked()), this, SLOT(supprimerparam()));

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 5, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupFichier, 1, 0);
	grille->addWidget(groupParam, 3, 0);
	grille->addLayout(bouton, 5, 0);
	bouton->addWidget(ok, 0, 1);
	bouton->addWidget(annuler, 0, 2);
}
void FenetreParseurCpp::ok()
{
	std::vector<string> fichier;
	std::vector<string> parametre;
	int nombre,index;
	string temp;

	// Rcupration des fichiers cpp  parser
	nombre = listFichier->count();
	for(int i=0;i<nombre;i++){
		index = listFichier->topItem();
		temp = string(listFichier->text(index));
		fichier.push_back(temp);
		listFichier->removeItem(index);
	}

	// Rcupration des options de compilation
	nombre = listParam->count();
	for(int i=0;i<nombre;i++){
		index = listParam->topItem();
		temp = string(listParam->text(index));
		parametre.push_back(temp);
		listParam->removeItem(index);
	}

	std::vector<string>:: iterator it;
	it=fichier.begin();
	while(it != fichier.end()){
		cout << (*it) << endl;
		++it;
	}
	it=parametre.begin();
	while(it != parametre.end()){
		cout << (*it) << endl;
		++it;
	}	
	/*
		APPEL AU NOYAU
	*/

	noyau->importerCpp(fichier);

	fenetre->mettreAJourVecteurs();
	delete(this);
}
void FenetreParseurCpp::annuler()
{
	delete(this);
}

void FenetreParseurCpp::ajouterfic()
{
	QStringList fichierCpp = QFileDialog::getOpenFileNames ("*.cpp *.C *.cxx","",this,"", "Fichiers Cpp  inclure" );
	listFichier->insertStringList ( fichierCpp, -1 );
}

void FenetreParseurCpp::supprimerfic()
{
	int choix = listFichier->currentItem ();
	listFichier->removeItem(choix);
}

void FenetreParseurCpp::ajouterparam()
{
	if((editParam->text()) != ""){	
		listParam->insertItem(editParam->text(),-1);;
		editParam->clear();
	}
}

void FenetreParseurCpp::modifierparam()
{
	if((editParam->text()) != ""){	
		int place = listParam->currentItem();
		listParam->removeItem(place);
		listParam->insertItem(editParam->text(),place);;
		editParam->clear();
	}
}

void FenetreParseurCpp::supprimerparam()
{
	int choix = listParam->currentItem ();
	listParam->removeItem(choix);
}
