#ifndef FENETREPARSEURCPP_H
#define FENETREPARSEURCPP_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <ihmfenetreprincipale.h>

/** Cette classe represente la fentre de lancement du parsing C++.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class FenetreParseurCpp : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale *fen : Reference sur la fentre principale
		 * \param QWidget *parent : Represente le widget parent de cette fentre.
		 * \param const char *name : Represente le nom que l'on veut donner  cette fentre.
		 */
		FenetreParseurCpp(FenetrePrincipale *fen, QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreParseurCpp() {};
		QListBox *listFichier;
		QListBox *listParam;
		QLineEdit *editParam;


		/** Permet de recuperer une reference sur le noyau associ  cette fentre.
		 * \return Une reference sur le noyau associ  cette fentre.
		 */
		Noyau * getNoyau() { return noyau ; }

		/** Positionne le noyau associ  cette fentre.
		 * \param Noyau *n : Reference du noyau  associer  cette fentre.
		 */
		void setNoyau( Noyau * n ) { noyau=n; }

	public slots:
		//! Ce slot ferme la fentre sans lancer le parsing ni prendre en compte les changements.
		void annuler();

		//! Ce slot ferme la fentre an lancant le parsing C++ en fonction des informations recueillies dans les champs de la fentre.
		void ok();

		//! Ce slot ajoute un fichier  la liste des fichiers  parser.
		void ajouterfic();

		//! Ce slot supprime le fichier selctionn de la liste des fichiers  parser.
		void supprimerfic();

		// Ce slot ajoute un parametre  la liste des parametres.
		void ajouterparam();

		//! Ce slot modifie un parametre de la liste des parametres.
		void modifierparam();

		//! Ce slot supprime le parametre selectionn de la liste des parametres.
		void supprimerparam();
	private:
		FenetrePrincipale * fenetre;
		Noyau *noyau;
};

#endif
