#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qlineedit.h> 
#include <iostream.h>
#include <qlabel.h>
#include <qfiledialog.h>
#include <noynoyau.h>
#include <noyprojet.h>

#include <ihmfenetreparseurjava.h>
FenetreParseurJava::FenetreParseurJava(FenetrePrincipale *fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen ;
	noyau=fen->getNoyau();
	setGeometry(100,100,400,500);
	setCaption("Importation Java");

	/* Boutons */
	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");

	/* Zone liste de fichiers */
	QGroupBox *groupFichier = new QGroupBox (2, Vertical,"Fichier  inclure", this, "groupFichier");
	listFichier = new QListBox(groupFichier,"listFichier");
	QGroupBox *groupBoutonFic = new QGroupBox (2, Horizontal,"", groupFichier, "groupBoutonFic");
	QPushButton *ajouterFic = new QPushButton ( "Ajouter", groupBoutonFic, "ajouterFic");
	QPushButton *supprimerFic = new QPushButton ( "Supprimer", groupBoutonFic, "supprimerFic");	

	/* Zone liste du CLASSPATH */
	QGroupBox *groupClassPath = new QGroupBox (2, Vertical,"Fichier du CLASSPATH", this, "groupClassPath");
	listClassPath = new QListBox(groupClassPath,"listClassPath");
	listClassPath->insertItem("./",-1);
	QGroupBox *groupBoutonClass = new QGroupBox (2, Horizontal,"", groupClassPath, "groupBoutonClass");
	QPushButton *ajouterClass = new QPushButton ( "Ajouter", groupBoutonClass, "ajouterClass");
	QPushButton *supprimerClass = new QPushButton ( "Supprimer", groupBoutonClass, "supprimerCass");	

	/* Connection des boutons */
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( ajouterFic, SIGNAL(clicked()), this, SLOT(ajouterfic()));
	connect( supprimerFic, SIGNAL(clicked()), this, SLOT(supprimerfic()));
	connect( ajouterClass, SIGNAL(clicked()), this, SLOT(ajouterclasspath()));
	connect( supprimerClass, SIGNAL(clicked()), this, SLOT(supprimerclasspath()));

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 5, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupFichier, 1, 0);
	grille->addWidget(groupClassPath, 3, 0);
	grille->addLayout(bouton, 5, 0);
	bouton->addWidget(ok, 0, 1);
	bouton->addWidget(annuler, 0, 2);
}
void FenetreParseurJava::ok()
{
	std::vector<string> fichier;
	std::vector<string> classpath;
	int nombre,index;
	string temp;

	// Rcupration des fichiers java  parser
 	nombre = listFichier->count();
	for(int i=0;i<nombre;i++){
		index = listFichier->topItem();
		temp = string(listFichier->text(index));
		fichier.push_back(temp);
		listFichier->removeItem(index);
	}
	// Rcupration du CLASSPATH
	nombre = listClassPath->count();
	for(int i=0;i<nombre;i++){
		index = listClassPath->topItem();
		temp = string(listClassPath->text(index));
		classpath.push_back(temp);
		listClassPath->removeItem(index);
	}

	std::vector<string>:: iterator it;
	it=fichier.begin();
	while(it != fichier.end()){
		cout << (*it) << endl;
		++it;
	}
	it=classpath.begin();
	while(it != classpath.end()){
		cout << (*it) << endl;
		++it;
	}	
	/*
		APPEL AU NOYAU
	*/
	noyau->importerJava(fichier,classpath);

	fenetre->mettreAJourVecteurs();
	delete(this);
}
void FenetreParseurJava::annuler()
{
	delete(this);
}

void FenetreParseurJava::ajouterfic()
{
	QStringList fichierJava = QFileDialog::getOpenFileNames ("*.java","",this,"", "Fichiers Java  inclure" );
	listFichier->insertStringList ( fichierJava, -1 );
}

void FenetreParseurJava::supprimerfic()
{
	int choix = listFichier->currentItem ();
	listFichier->removeItem(choix);
}

void FenetreParseurJava::ajouterclasspath()
{
	QString cheminClassPath = QFileDialog::getExistingDirectory ( "", this, "CLASSPATH" );
	listClassPath->insertItem(cheminClassPath,-1);	 
}

void FenetreParseurJava::supprimerclasspath()
{
	int choix = listClassPath->currentItem ();
	listClassPath->removeItem(choix);
}
