#ifndef FENETREPARSEURJAVA_H
#define FENETREPARSEURJAVA_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <ihmfenetreprincipale.h>

/** Cette classe represente la fentre de lancement du parsing Java
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */ 
class FenetreParseurJava : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale *fen : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent=0 : Represente le widget parent de cette fentre (Par defaut 0).
		 * \param const char *name=0 : Represente le nom que l'on veut donner  cette fentre (Par defaut 0).
		 */
		FenetreParseurJava(FenetrePrincipale *fen, QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreParseurJava() {};


		QListBox *listFichier;
		QListBox *listClassPath;

		/** Permet de recuperer un reference sur le noyau associ  cette fentre.
		 * \return Une reference sur le noyau associ  cette fentre.
		 */
		
		Noyau * getNoyau() { return noyau ; }

		//! Permet de positionner le noyau associ  cette fentre.
		void setNoyau( Noyau * n ) { noyau=n; }

	public slots:

		//! Ce slot permet de fermer la fentre sans lancer le parsing et sans prendre en compte les changements.
		void annuler();

		//! Ce slot appelle le noyau pour qu'il parse en fonction des informations receuillies dans les champs de la fentre.
		void ok();

		//! Ce slot ajoute un fichier dans la liste des fichiers  parser.
		void ajouterfic();

		//! Ce slot supprime le fichier selectionn de la liste des fichiers  parser.
		void supprimerfic();

		//! Ce slot ajoute un repertoire dans CLASSPATH.
		void ajouterclasspath();

		//! Ce slot supprime le repertoire selectionn de CLASSPATH.
		void supprimerclasspath();
	private:
		FenetrePrincipale * fenetre;
		Noyau * noyau;
};

#endif
