#include <qpushbutton.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qgroupbox.h>
#include <qfiledialog.h>

#include <ihmfenetrepreference.h>
#include <ihmfenetreprincipale.h>

FenetrePreference::FenetrePreference(Noyau * n, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	noyau = n;
	projet = n->getProjet();
	setGeometry(100,100,400,300);
	setCaption("Prfrences");

	QPushButton *ok = new QPushButton( "&Ok", this, "ok" );
	QPushButton *annuler = new QPushButton( "&Annuler", this, "annuler");

	QButtonGroup *groupRadio = new QButtonGroup (1, Vertical,"Langage", this, "groupRadio" );
	radioCpp = new QRadioButton ("C++", groupRadio, "radioCpp" ); 
	radioJava = new QRadioButton ("Java", groupRadio, "radioJava" ); 

	QButtonGroup *groupCheck = new QButtonGroup (1, Vertical,"Barres d'outils", this, "groupCheck");
	checkAjouter = new QCheckBox ( "Ajouter", groupCheck, "checkAjouter" ); 
	checkEdition = new QCheckBox ( "Edition", groupCheck, "checkEdition" ); 
	checkProjet = new QCheckBox ( "Projet", groupCheck, "checkProjet" ); 


	QButtonGroup *groupOption = new QButtonGroup(2, Vertical,"Options", this, "groupOption");
	checkNom = new QCheckBox ( "Utiliser les noms longs" , groupOption , "checkNom");
	checkAccesseur = new QCheckBox ( "Gnrer automatiquement les accesseurs" , groupOption , "checkAccesseur"); 

	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));

	QGridLayout *grille = new QGridLayout( this, 7, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);

	grille->addWidget(groupRadio, 1, 0);
	grille->addWidget(groupCheck, 3, 0);
	grille->addWidget(groupOption , 5 , 0); 
	grille->addLayout(bouton, 7, 0);

	checkAjouter->setChecked (projet->getAjouter());
	checkEdition->setChecked (projet->getEdition());
	checkProjet->setChecked (projet->getPro());
	checkNom->setChecked(projet->getNomLong());
	radioCpp->setChecked(projet->getLangage());
	radioJava->setChecked(!projet->getLangage());
	checkAccesseur->setChecked(projet->getAccesseur());

	bouton->addWidget(ok, 0, 1);
	bouton->addWidget(annuler, 0, 2);
}

void FenetrePreference::ok()
{
	projet->setAjouter(checkAjouter->isChecked());
	projet->setEdition(checkEdition->isChecked());
	projet->setPro(checkProjet->isChecked());
	projet->setNomLong(checkNom->isChecked());
	projet->setAccesseur(checkAccesseur->isChecked());
	projet->setLangage(radioCpp->isChecked());
	noyau->notifier();
	delete(this);
}

void FenetrePreference::annuler()
{
	delete(this);
}
