#ifndef FENETREPREFERENCE_H
#define FENETREPREFERENCE_H

#include <iostream.h>
#include <qwidget.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qcheckbox.h>

#include <noynoyau.h>

/** Cette classe represente la fentre de preference.
 * @author F.Duchaussoy N.Longuet, G.Prevot
 */
class FenetrePreference : public QWidget
{
	Q_OBJECT
	private:
		Noyau * noyau;
		Projet * projet;
	public:
		/** Constructer
		 * \param Noyau * n : Afin de prendre en compte les preferences, il y a un appel  notifier
		 * \param QWidget *parent : Represente le widget parent de cette fentre (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner  cette fentre.
		 */
		FenetrePreference(Noyau * n, QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetrePreference() {}

		QRadioButton *radioCpp, *radioJava;
		QCheckBox *checkAjouter, *checkEdition, *checkProjet, *checkNom , *checkAccesseur;
		bool check1;
	public slots:

		//! Ce slot ferme la fentre sans prendre en compte les changements.
		void annuler();

		//! Ce slot ferme la fentre en prenant en compte les changements.
		void ok();
};

#endif

