#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qmessagebox.h>

#include <ihmfenetrevue.h>

#include <noydiagrammestatique.h>
#include <noyvue.h>

FenetreVue::FenetreVue(FenetrePrincipale * fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen;

	setGeometry(100,100,400,300);
	setCaption("Ajouter une vue");
	
	/* Zone de texte */
	QGroupBox *groupNom = new QGroupBox (1, Vertical,"Nom de la vue", this, "groupNom");
	editNom = new QLineEdit(groupNom,"editNom");  

	/* Description */
	QGroupBox *groupDescription = new QGroupBox (1, Vertical,"Desciption", this, "groupDescription" );
	editDescription = new QMultiLineEdit(groupDescription , "editDescription");

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 5, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupNom, 1, 0);
	grille->addWidget(groupDescription, 3, 0);
	grille->addLayout(bouton, 5, 0);

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	bouton->addWidget(ok, 0, 1);

	QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");
	bouton->addWidget(annuler, 0, 2);
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));
}

FenetreVue::~FenetreVue ( )
{
}

void FenetreVue::ok()
{
	DiagrammeStatique * dg = fenetre->getNoyau()->getProjet()->getDiagrammeStatique();
		
	if (string(editNom->text().replace(QRegExp(" "),"")) == ""){
		QMessageBox::warning(0,"Ajouter une vue","Une vue doit avoir un nom");
		return;
	}
	
	Vue * v = new Vue ( (Noeud *)dg , string(editNom->text()) );

	if ( dg->ajouterVue(v) == FALSE ) {
		QMessageBox::information(0,"Ajouter une vue","Impossible d'ajouter une vue ici");
	} else {
		cout << "AJOUT (vue) " << v << " dans " << dg << endl;
		fenetre->setNoeudCourant(v);
	}
	delete(this);
	fenetre->getNoyau()->notifier();
}

void FenetreVue::annuler()
{
	delete(this);
}

