#ifndef FENETREVUE_H
#define FENETREVUE_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>

/** Cette classe represente une fentre d'ajout/modification d'une vue.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class FenetreVue : public QWidget
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param FenetrePrincipale *fen : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent de cette fentre (Par defaut 0).
		 * \param const char *nom : Represente le nom que l'on veut donner  cette fentre (Par defaut 0).
		 */
		FenetreVue(FenetrePrincipale * fen, QWidget *parent=0, const char *name=0);

		//! Destructeur
		virtual ~FenetreVue();

		QLineEdit *editNom;
		QMultiLineEdit *editDescription;
		FenetrePrincipale * fenetre;

	public slots:
		//! Ce slot ferme la fentre sans ajouter la vue.
		void annuler();
		//! Ce slot ajoute/modifie la vue en fonction des champs de la fentre. Ce slot ferme galement la fentre si c'tait un ajout.
		void ok();
};

#endif

