#ifndef IHMMONCOMBOCLASSE_H
#define IHMMONCOMBOCLASSE_H

#include <qwidget.h>
#include <qcombobox.h>

#include <ihmfenetreprincipale.h>

/** Cette classe represente un combobox contenant les noms des classes du projet.
 * Ce combobox peut tre positionn sur une classe particulire  la cration.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class MonComboClasse : public QComboBox
{
	public:
		/** Constructeur
		 * \param Classe *c : Classe sur laquelle le MonComboClasse doit tre positionn  la cration.
		 * \param FenetrePrincipale *f : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent du MonComboClasse (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner au MonComboClasse.
		 */
		MonComboClasse( Classe * c , FenetrePrincipale * f , QWidget * parent=0 , const char *name=0 );

		//! Destructeur.
		virtual ~MonComboClasse( );
};

#endif

