#ifndef IHMMONCOMBOPAQUETAGE_H
#define IHMMONCOMBOPAQUETAGE_H

#include <qwidget.h>
#include <qcombobox.h>

#include <ihmfenetreprincipale.h>

/** Cette classe represente un combobox contenant les noms des paquetages du projet.
 * Ce combobox peut tre positionn sur un paquetage particulier  la cration.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class MonComboPaquetage : public QComboBox
{
	public:

		/** Constructeur
		 * \param Paquetage *p : Paquetage sur lequelle le MonComboPaquetage doit tre positionn  la cration.
		 * \param FenetrePrincipale *f : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent du MonComboPaquetage (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner au MonComboPaquetage.
		 */
		MonComboPaquetage( Paquetage * p , FenetrePrincipale * f , QWidget * parent=0 , const char *name=0 );

		//! Destructeur
		virtual ~MonComboPaquetage( );
};

#endif

