#ifndef IHMMONLISTVIEWITEM_H
#define IHMMONLISTVIEWITEM_H

#include <qlistview.h>
#include <noynoeud.h>

class Arbre;

/** Cette classe represente les objets que l'on va inserer dans l'arbre.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class MonListViewItem : public QListViewItem
{
	private:
		Noeud *noeud;

	public:

		/** Constructeur
		 * \param Noeud *n : Reference sur le noeud que represente ce MonListViewItem dans l'arbre.
		 * \param MonListViewItem *parent : Reference sur le MonListViewItem parent de celui-ci.
		 * \param constQString &nom : Represente le text affich dans ce MonListViewItem.
		 */
		MonListViewItem(Noeud *n, MonListViewItem *parent, const QString &nom);

		/** Constructeur
		 * \param Noeud *n : Reference sur le noeud que represente ce MonListViewItem dans l'arbre.
		 * \param Arbre *parent : Reference sur l'arbre parent de ce MonListViewItem.
		 * \param constQString &nom : Represente le text affich dans ce MonListViewItem.
		 */
		MonListViewItem(Noeud *n, Arbre *parent, const QString &nom);

		//! Destructeur
		virtual ~MonListViewItem() {}

		/** Positionne le noeud associ  ce MonListViewItem.
		 * \param Noeud *n : Reference du nouveau Noeud associ  ce MonListViwItem.
		 */
		void setNoeud(Noeud *n);

		/** Permet de recuperer un reference sur le Noeud associ  ce MonListViewItem.
		 * \return Une reference sur le Noeud associ  ce MonListViewItem.
		 */
		Noeud *getNoeud();
};

#endif

