#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>

#include <ihmpetitefenetre.h>

FenetreComboPaquetage::FenetreComboPaquetage(FenetrePrincipale * fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen;

	setGeometry( 200, 200, 100, 100 );
	setCaption("Choix du paquetage");

	comboPaquetage = new MonComboPaquetage (NULL, fenetre, this, "comboPaquetage" );

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Fermer", this, "annuler");	

	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));

	QGridLayout *grille = new QGridLayout( this, 2, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 2, 1);

	grille->addWidget(comboPaquetage, 0, 0);
	grille->addLayout(bouton, 1, 0);
	bouton->addWidget(ok, 0, 0);
	bouton->addWidget(annuler, 0, 1);

	comboPaquetage->removeItem(0);
	comboPaquetage->setCurrentItem(1);
}
void FenetreComboPaquetage::ok()
{
	std::vector<Paquetage*>::iterator it = fenetre->vctPaquetage.begin();
	int i = 0;
	while( i<comboPaquetage->currentItem() ) {
		++it;
		++i;
	}
	((Vue*)fenetre->getNoeudCourant())->ajouterElementDeModelisation((ElementDeModelisation*)*it, 20 , 20 , 20 , 20 , true);
	fenetre->getNoyau()->notifier();
}

void FenetreComboPaquetage::annuler()
{
	delete(this);
}


/*******************************************************************************************************/


FenetreComboClasse::FenetreComboClasse(FenetrePrincipale * fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen;

	setGeometry( 200, 200, 100, 100 );
	setCaption("Choix de la classe");

	comboClasse = new MonComboClasse (NULL, fenetre, this, "comboPaquetage" );

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Fermer", this, "annuler");	

	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));

	QGridLayout *grille = new QGridLayout( this, 2, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 2, 1);

	grille->addWidget(comboClasse, 0, 0);
	grille->addLayout(bouton, 1, 0);
	bouton->addWidget(ok, 0, 0);
	bouton->addWidget(annuler, 0, 1);

}

void FenetreComboClasse::ok()
{
	std::vector<Classe*>::iterator it = fenetre->vctClasse.begin();
	int i = 0;
	while( i<comboClasse->currentItem() ) {
		++it;
		++i;
	}
	((Vue*)fenetre->getNoeudCourant())->ajouterElementDeModelisation((ElementDeModelisation*)*it, 20 , 20 , 20 , 20 , true);
	fenetre->getNoyau()->notifier();
}

void FenetreComboClasse::annuler()
{
	delete(this);
}


/*******************************************************************************************************/


FenetreComboRelation::FenetreComboRelation(FenetrePrincipale * fen, QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	fenetre = fen;

	setGeometry( 200, 200, 100, 100 );
	setCaption("Choix de la classe");

	comboRelation = new MonComboRelation ( fenetre, this, "comboRelation" );

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Fermer", this, "annuler");	

	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));

	QGridLayout *grille = new QGridLayout( this, 2, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 2, 1);

	grille->addWidget(comboRelation, 0, 0);
	grille->addLayout(bouton, 1, 0);
	bouton->addWidget(ok, 0, 0);
	bouton->addWidget(annuler, 0, 1);
}

void FenetreComboRelation::ok()
{
	std::vector<Relation*>::iterator it = fenetre->vctRelation.begin();
	int i = 0;
	while( i<comboRelation->currentItem() ) {
		++it;
		++i;
	}
	((Vue*)fenetre->getNoeudCourant())->ajouterElementDeModelisation((ElementDeModelisation*)*it, 20 , 20 , 20 , 20 , true);
	fenetre->getNoyau()->notifier();
}

void FenetreComboRelation::annuler()
{
	delete(this);
}


