#include <vector.h>

#include <qstring.h>
#include <qpixmap.h>
#include <qmessagebox.h>

#include <ihmfenetreprincipale.h>
#include <ihmvisiteurajouter.h>
#include <noyrelationcommentaire.h>
#include <noyrelation.h>

VisiteurAjouter::VisiteurAjouter(FenetrePrincipale * fen)
{
	fenetre = fen ;
}

void VisiteurAjouter::traiterProjet(Projet *p)
{
}

void VisiteurAjouter::traiterUseCase(UseCase *u)
{
}

void VisiteurAjouter::traiterCollaboration(Collaboration *c)
{
}

void VisiteurAjouter::traiterDiagrammeStatique(DiagrammeStatique *d)
{
}

void VisiteurAjouter::traiterVue(Vue *v)
{
	DiagrammeStatique * dg = fenetre->getNoyau()->getProjet()->getDiagrammeStatique();

	if ( dg->ajouterVue(v) == FALSE ) {
		QMessageBox::information(0,"Ajouter une vue","Impossible d'ajouter une vue ici");
		return;
	} else {
		cout << "AJOUT (vue) " << v << " dans " << dg << endl;
		fenetre->setNoeudCourant(v);
		fenetre->getNoyau()->notifier();
	}

	fenetre->getBarreDeMenu()->setAjoutOK(true);
}

void VisiteurAjouter::traiterObjetAffichable(ObjetAffichable *o)
{/*
	Vue * v = (Vue *)o->getPere();
	string s = o->getedm()->getNom();

	if ( v->supprimerObjetAffichable(o) == FALSE )
		QMessageBox::information(0,"Erreur de suppression","Impossible de supprimer cet objet");
	else
		cout << "SUPPRESSION (ObjetAffichable) associ  " << s << endl;
*/}

void VisiteurAjouter::traiterClasse(Classe *c)
{
	Classe *cl = new Classe(fenetre->getNoeudCourant(), c->getNom(), c->getVisibilite(), c->getTypeDeClasse());
//	Classe *cl = new Classe(*c);
//cout <<"nouvelle classe :" << cl << endl;
//	cl->setNom(c->getNom());

	Noeud *buffer = fenetre->getNoeudCourant(); 

	fenetre->setNoeudCourant(cl);
	std::vector<Methode *> vm;
	std::vector<Methode *>::iterator itm;
	vm =c->getVctMethode();
	itm = vm.begin();
	while (itm != vm.end()){
		(*itm)->accepter(this);
		++itm;
	}

	fenetre->setNoeudCourant(cl);
	std::vector<Attribut *> va;
	std::vector<Attribut *>::iterator ita;
	va =c->getVctAttribut();
	ita = va.begin();
	while (ita != va.end()){
		(*ita)->accepter(this);
		++ita;
	}

	fenetre->setNoeudCourant(cl);
	std::vector<Relation *> vr;
	std::vector<Relation *>::iterator itr;
	vr =c->getVctRelation();
	itr = vr.begin();
	while (itr != vr.end()){
		(*itr)->accepter(this);
		++itr;
	}

	if (buffer == fenetre->getNoyau()->getProjet()->getDiagrammeStatique())
	{
		if (((DiagrammeStatique *)buffer)->ajouterObjetuml( (Objetuml *)cl ) == false) {
			QMessageBox::information(0,"Coller une classe","Impossible d'ajouter une classe ici");
			return;
		}
	}
	else if (fenetre->estPaquetage(buffer))
	{
		if (((Paquetage *)buffer)->ajouterObjetuml( (Objetuml *)cl ) == false) {
			QMessageBox::information(0,"Coller une classe","Impossible d'ajouter une clase ici");
			return;
		}
	}
	else return;

	fenetre->ajouterClasse(cl);

	fenetre->getBarreDeMenu()->setAjoutOK(true);
}

void VisiteurAjouter::traiterPaquetage(Paquetage *p)
{
	Paquetage *pa = new Paquetage(fenetre->getNoeudCourant(), p->getNom());

	Noeud *buffer = fenetre->getNoeudCourant();

	fenetre->setNoeudCourant(pa);
	std::vector<Objetuml *> vo;
	std::vector<Objetuml *>::iterator ito;
	vo = p->getVctObjetuml();
	ito = vo.begin();
	while (ito != vo.end()){
		(*ito)->accepter(this);
		++ito;
	}	

	if (buffer == fenetre->getNoyau()->getProjet()->getDiagrammeStatique())
	{
		if (((DiagrammeStatique *)buffer)->ajouterObjetuml( (Objetuml *)pa ) == false) {
			QMessageBox::information(0,"Coller un paquetage","Impossible d'ajouter un paquetage ici");
			return;
		}
	}
	else if (fenetre->estPaquetage(buffer))
	{
		if (((Paquetage *)buffer)->ajouterObjetuml( (Objetuml *)pa ) == false) {
			QMessageBox::information(0,"Coller un paquetage","Impossible d'ajouter un paquetage ici");
			return;
		}
	}
	else return;

	fenetre->ajouterPaquetage(pa);

	fenetre->getBarreDeMenu()->setAjoutOK(true);	
}

void VisiteurAjouter::traiterMethode(Methode *m)
{

	std::vector<Parametre *> vctParametre;
	m->cloneVctParametre(vctParametre);

	Noeud *buffer = fenetre->getNoeudCourant();

	if (fenetre->estClasse(buffer))
	{
		if (((Classe *)buffer)->ajouterMethode(m->getNom(), m->getTypeRetour(), m->getVisible(), vctParametre) == false)
		{
			QMessageBox::information(0, "Coller une mthode", "Impossible d'ajouter une mthode ici");
			return;
		}
		else fenetre->getBarreDeMenu()->setAjoutOK(true);
	}
}

void VisiteurAjouter::traiterAttribut(Attribut *attr)
{
	Noeud *buffer = fenetre->getNoeudCourant();

	if (fenetre->estClasse(buffer))
	{
		if (((Classe *)buffer)->ajouterAttribut(attr->getType(), attr->getNom(), attr->getVisible()) == false)
		{
			QMessageBox::information(0, "Coller une mthode", "Impossible d'ajouter une mthode ici");
			return;
		}
		else fenetre->getBarreDeMenu()->setAjoutOK(true);
	}
}

void VisiteurAjouter::traiterHeritage(Heritage *h)
{
	Relation *buffer;

	if (!(fenetre->estClasse(fenetre->getNoeudCourant()))) {
		QMessageBox::information(0, "Coller un heritage", "Impossible de coller un heritage autre part que dans une classe");
		return;
	}

	string nom = string("Heritage de la classe mre " + h->getClasseDestination()->getNomComplet());

	if ((buffer = ((Classe *)fenetre->getNoeudCourant())->ajouterRelation(nom, REL_HERITAGE,(Classe *)fenetre->getNoeudCourant(), h->getClasseDestination(), ((Relation *)h)->getMultipliciteSource(), ((Relation *)h)->getMultipliciteDestination())) == false) {
		QMessageBox::information(0, "Coller un heritage", "Impossible d'ajouter cet heritage ici");
		return;
	}

	fenetre->ajouterRelation(buffer);

	fenetre->getBarreDeMenu()->setAjoutOK(true);

	delete(buffer);
}

void VisiteurAjouter::traiterUtilisation(Utilisation *u)
{
	Relation *buffer;

	if (!(fenetre->estClasse(fenetre->getNoeudCourant()))) {
		QMessageBox::information(0, "Coller une utilisation", "Impossible de coller une utilisation autre part que dans une classe");
		return;
	}

	string nom = string("Utilisation de " +((Classe *) u->getClasseDestination())->getNomComplet() + " par " + ((Classe *)fenetre->getNoeudCourant())->getNomComplet());

	if ((buffer = ((Classe *)fenetre->getNoeudCourant())->ajouterRelation(nom, REL_UTILISATION,(Classe *)fenetre->getNoeudCourant(), u->getClasseDestination(), u->getMultipliciteSource(), u->getMultipliciteDestination())) == false) {
		QMessageBox::information(0, "Coller une utilisation", "Impossible d'ajouter cette utilisation ici");
		return;
	}

	fenetre->ajouterRelation(buffer);

	fenetre->getBarreDeMenu()->setAjoutOK(true);

	delete(buffer);
}

void VisiteurAjouter::traiterAssociation(Association *assoc)
{
	Relation *buffer;

	if (!(fenetre->estClasse(fenetre->getNoeudCourant()))) {
		QMessageBox::information(0, "Coller une association", "Impossible de coller une association autre part que dans une classe");
		return;
	}

	string nom = string("Association entre " + ((Classe *)fenetre->getNoeudCourant())->getNomComplet() + " et " + ((Classe *)assoc->getClasseDestination())->getNomComplet());

	if ((buffer = ((Classe *)fenetre->getNoeudCourant())->ajouterRelation(nom, REL_ASSOCIATION, (Classe *)fenetre->getNoeudCourant(), assoc->getClasseDestination(), assoc->getMultipliciteSource(), assoc->getMultipliciteDestination())) == false) {
		QMessageBox::information(0, "Coller une association", "Impossible de coller cette association ici");
		return;
	}

	fenetre->ajouterRelation(buffer);

	fenetre->getBarreDeMenu()->setAjoutOK(true);

	delete(buffer);
}

void VisiteurAjouter::traiterAgregation(Agregation *ag)
{
	Relation *buffer;

	if (!(fenetre->estClasse(fenetre->getNoeudCourant()))) {
		QMessageBox::information(0, "Coller une agregation", "Impossible de coller une agregation autre part que dans une classe");
		return;
	}		

	string nom = string("Agregation de " + ((Classe *)fenetre->getNoeudCourant())->getNomComplet() + " vers " + ag->getClasseDestination()->getNomComplet());
	
	if ((buffer = ((Classe *)fenetre->getNoeudCourant())->ajouterRelation(nom, REL_AGREGATION,(Classe *)fenetre->getNoeudCourant(), ag->getClasseDestination(), ag->getMultipliciteSource(), ag->getMultipliciteDestination())) == false) {
		QMessageBox::information(0, "Coller une agregation", "Impossible de coller cette agregation ici");
		return;
	}

	fenetre->ajouterRelation(buffer);

	fenetre->getBarreDeMenu()->setAjoutOK(true);

	delete(buffer);
}

void VisiteurAjouter::traiterRelationCommentaire(RelationCommentaire *rc)
{

}
