#include <qwidget.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qlayout.h>
#include <qwidget.h>
#include <qstring.h>

#include <ihmvisiteurdessin.h>
#include <ihmzonedessin.h>
#include <ihmfenetreprincipale.h>
#include <ihmfenetrededessin.h>

#include <ihmfenetrecreerprojet.h>
#include <ihmfenetreclasse.h>
#include <ihmfenetrepaquetage.h>
#include <ihmfenetreattribut.h>
#include <ihmfenetrerelation.h>
#include <ihmfenetremethode.h>
#include <ihmfenetrecommentaire.h>

#include <noyprojet.h>

VisiteurDessin::VisiteurDessin ( Noyau * n, FenetreDeDessin * dest ): VisiteurNoeud( ) 
{
	noyau = n ;
	destination = dest ;
}

void VisiteurDessin::traiterProjet(Projet *p) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreCreerProjet * fen = new FenetreCreerProjet( fenPrinc , destination );

	destination->setConteneur(fen);
	fen->show();
}

void VisiteurDessin::traiterUseCase(UseCase *u) {
	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());

	QPushButton *b= new QPushButton( destination );
	b->setText("Diagramme des cas d'utilisation");
	destination->setConteneur(b);

	b->show();
}

void VisiteurDessin::traiterCollaboration(Collaboration *c) {
	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());

	QPushButton *b= new QPushButton( destination );
	b->setText("Diagramme de collaboration");
	destination->setConteneur(b);

	b->show();
}

void VisiteurDessin::traiterDiagrammeStatique(DiagrammeStatique *d) {
	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());

	QPushButton *b= new QPushButton( destination );
	b->setText("Diagramme statique de classe");
	destination->setConteneur(b);

	b->show();
}

void VisiteurDessin::traiterVue(Vue *v) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	QScrollView *sv = new QScrollView(destination);
	ZoneDessin * zone = new ZoneDessin( fenPrinc, v, sv->viewport(), "zoneDessin");

	sv->addChild(zone);
	sv->setMinimumSize(destination->size());

	destination->setConteneur(sv);
	sv->repaint();

	sv->show();
}

void VisiteurDessin::traiterObjetAffichable(ObjetAffichable *oa) {
	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());

	QPushButton *b= new QPushButton( destination );
	b->setText("ObjetAffichable");
	destination->setConteneur(b);

	b->show();
}

void VisiteurDessin::traiterCommentaire(Commentaire *co) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreCommentaire * fen = new FenetreCommentaire( fenPrinc , co, destination );

	destination->setConteneur(fen);
	fen->show();
}

void VisiteurDessin::traiterRelationCommentaire(RelationCommentaire *rc)
{
	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());

	QPushButton *b= new QPushButton( destination );
	b->setText("RelationCommentaire");
	destination->setConteneur(b);

	b->show();
}

void VisiteurDessin::traiterClasse(Classe *cl) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreClasse * fen = new FenetreClasse( fenPrinc , cl, destination );

	destination->setConteneur(fen);
	fen->show();
}

void VisiteurDessin::traiterPaquetage(Paquetage *pa) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetrePaquetage * fen = new FenetrePaquetage( fenPrinc , pa, destination );

	destination->setConteneur(fen);
	fen->show();
}

void VisiteurDessin::traiterMethode(Methode *m) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreMethode * fen = new FenetreMethode( fenPrinc , m, destination );

	destination->setConteneur(fen);
	fen->show();
}

void VisiteurDessin::traiterAttribut(Attribut *a) {
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreAttribut * fen = new FenetreAttribut( fenPrinc , a, destination );

	destination->setConteneur(fen);
	fen->show();
}


void VisiteurDessin::traiterHeritage(Heritage *h )
{
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreRelation * fen = new FenetreRelation( fenPrinc , h, REL_HERITAGE, destination );

	destination->setConteneur(fen);
	fen->show();

}

void VisiteurDessin::traiterUtilisation(Utilisation *u)
{
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreRelation * fen = new FenetreRelation( fenPrinc , u, REL_UTILISATION, destination );

	destination->setConteneur(fen);
	fen->show();

}

void VisiteurDessin::traiterAssociation(Association *a)
{
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreRelation * fen = new FenetreRelation( fenPrinc , a, REL_ASSOCIATION, destination );

	destination->setConteneur(fen);
	fen->show();

}

void VisiteurDessin::traiterAgregation(Agregation *a)
{
	FenetrePrincipale * fenPrinc = (FenetrePrincipale *)(destination->topLevelWidget());

	if ( destination->getConteneur() != NULL ) delete(destination->getConteneur());
	FenetreRelation * fen = new FenetreRelation( fenPrinc , a, REL_AGREGATION, destination );

	destination->setConteneur(fen);
	fen->show();

}

