#ifndef IHMVISITEURITEM_H
#define IHMVISITEURITEM_H

#include <qpopupmenu.h>
#include <qcursor.h>

#include <ihmmonlistviewitem.h>
#include <noyvisiteurnoeud.h>
#include <ihmfenetreprincipale.h>

/** Cette classe permet de faire apparaitre un PopupMenu different selon le type de Noeud.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class VisiteurItem : public VisiteurNoeud
{
	private:
		FenetrePrincipale *f;
		QCursor *curseur;

	public:

		/** Constructeur
		 * \param FenetrePrincipale * : Reference sur la fenetre principale de l'application.
		 */
		VisiteurItem(FenetrePrincipale *);

		//! Destructeur
		virtual ~VisiteurItem() {}


		//! Cette mthode fait apparaitre un PopupMenu associ  un projet  l'endroit o se trouve le curseur.
		void traiterProjet(Projet *p);

		//! Cette mthode fait apparaitre un PopupMenu associ  un usecase  l'endroit o se trouve le curseur.
		void traiterUseCase(UseCase *u);

		//! Cette mthode fait apparaitre un PopupMenu associ  un diagramme de collaboration  l'endroit o se trouve le curseur.
		void traiterCollaboration(Collaboration *c);

		//! Cette mthode fait apparaitre un PopupMenu associ  un diagramme statique  l'endroit o se trouve le curseur.
		void traiterDiagrammeStatique(DiagrammeStatique *d);

		//! Cette mthode fait apparaitre un PopupMenu associ  une vue  l'endroit o se trouve le curseur.
		void traiterVue(Vue *v);

		//! Cette mthode fait apparaitre un PopupMenu associ  un objet affichable  l'endroit o se trouve le curseur.
		void traiterObjetAffichable(ObjetAffichable *oa);

		//! Cette mthode fait apparaitre un PopupMenu associ  un commentaire  l'endroit o se trouve le curseur.
		void traiterCommentaire(Commentaire *c);

		//! Cette mthode fait apparaitre un PopupMenu associ  une relation commentaire  l'endroit o se trouve le curseur.
		void traiterRelationCommentaire(RelationCommentaire *rc);

		//! Cette mthode fait apparaitre un PopupMenu associ  une classe  l'endroit o se trouve le curseur.
		void traiterClasse(Classe *cl);

		//! Cette mthode fait apparaitre un PopupMenu associ  un paquetage  l'endroit o se trouve le curseur.
		void traiterPaquetage(Paquetage *pa);

		//! Cette mthode fait apparaitre un PopupMenu associ  une mthode  l'endroit o se trouve le curseur.
		void traiterMethode(Methode *m);

		//! Cette mthode fait apparaitre un PopupMenu associ  un attribut  l'endroit o se trouve le curseur.
		void traiterAttribut(Attribut *a);

		//! Cette mthode fait apparaitre un PopupMenu associ  un heritage  l'endroit o se trouve le curseur.
		void traiterHeritage(Heritage *h);

		//! Cette mthode fait apparaitre un PopupMenu associ  une association  l'endroit o se trouve le curseur.
		void traiterAssociation(Association *assoc);

		//! Cette mthode fait apparaitre un PopupMenu associ  une utilisation  l'endroit o se trouve le curseur.
		void traiterUtilisation(Utilisation *u);

		//! Cette mthode fait apparaitre un PopupMenu associ  une agregation  l'endroit o se trouve le curseur.
		void traiterAgregation(Agregation *ag);
};

#endif

