#include <vector.h>
#include <ihmfenetreprincipale.h>
#include <ihmvisiteurvecteur.h>

VisiteurVecteur::VisiteurVecteur(FenetrePrincipale * fen)
{
	fenetre = fen ;
	nbAjout = 0 ;
}

void VisiteurVecteur::traiterDiagrammeStatique(DiagrammeStatique *dg)
{
	std::vector<Objetuml *> vct = dg->getVctObjetuml();
	std::vector<Objetuml *>::iterator it = vct.begin();
	while (it != vct.end()){
		(*it)->accepter(this);
		++it;
	}
}

void VisiteurVecteur::traiterPaquetage(Paquetage *p)
{
	fenetre->ajouterPaquetage(p);
	++nbAjout ;

	std::vector<Objetuml *> vct = p->getVctObjetuml();
	std::vector<Objetuml *>::iterator it = vct.begin();
	while (it != vct.end()){
		(*it)->accepter(this);
		++it;
	}
}

void VisiteurVecteur::traiterClasse(Classe *c)
{
	fenetre->ajouterClasse(c);
	++nbAjout ;

	std::vector<Relation *> vct = c->getVctRelation();
	std::vector<Relation *>::iterator it = vct.begin();
	while (it != vct.end()){
		if ( (*it)->getClasseSource() == c ) (*it)->accepter(this);
		++it;
	}
}

void VisiteurVecteur::traiterHeritage(Heritage *h)
{
	fenetre->ajouterRelation(h);
	++nbAjout ;
}

void VisiteurVecteur::traiterUtilisation(Utilisation *u)
{
	fenetre->ajouterRelation(u);
	++nbAjout ;
}

void VisiteurVecteur::traiterAssociation(Association *assoc)
{
	fenetre->ajouterRelation(assoc);
	++nbAjout ;
}

void VisiteurVecteur::traiterAgregation(Agregation *ag)
{
	fenetre->ajouterRelation(ag);
	++nbAjout ;
}

