#define SELECT_DEPLACEMENT					1
#define SELECT_AGRANDISSEMENT_HAUT			2
#define	SELECT_AGRANDISSEMENT_HAUT_DROITE	3
#define SELECT_AGRANDISSEMENT_DROITE		4
#define SELECT_AGRANDISSEMENT_BAS_DROITE	5
#define SELECT_AGRANDISSEMENT_BAS			6
#define SELECT_AGRANDISSEMENT_BAS_GAUCHE	7
#define SELECT_AGRANDISSEMENT_GAUCHE		8
#define	SELECT_AGRANDISSEMENT_HAUT_GAUCHE	9


#include <ihmzonedessin.h>

#include <qevent.h>
#include <qmessagebox.h>
#include <qscrollview.h>
#include <qfiledialog.h>
#include <math.h>
#include <vector.h>
#include <iostream.h>

#include <noyvue.h>
#include <noypaquetage.h>
#include <noyclasse.h>
#include <noycommentaire.h>
#include <noyattribut.h>
#include <noyrelation.h>
#include <noymethode.h>
#include <noyrelationcommentaire.h>

#include <ihmfenetreprincipale.h>
#include <ihmfenetreclasse.h>
#include <ihmfenetrepaquetage.h>
#include <ihmfenetrerelation.h>

ZoneDessin::ZoneDessin (FenetrePrincipale * fen, Vue * v, QWidget *parent , const char *name)
	: QWidget(parent,name), VisiteurNoeud()
{
	fenetre = fen;
	vue = v;

	setBackgroundColor(white);
	setPalette( QPalette( white ) );

	this->setMinimumSize(parentWidget()->size());

	pinceau = new QPainter(this);
	pinceau->end();
	objetSelectionne = NULL ;

	pinceau->begin(this);
	v->accepter(this);
	pinceau->end();
}

ZoneDessin::~ZoneDessin()
{
}

void ZoneDessin::paintEvent ( QPaintEvent * e )
{
	pinceau->begin(this);
	vue->accepter(this);
	pinceau->end();

	QSize tailleVue = getTaille();
	QSize tailleParent = parentWidget()->size();
	if ( tailleVue.width() > tailleParent.width() ) {
		if ( tailleVue.height() > tailleParent.height() ) 
			setMinimumSize( tailleVue.width() , tailleVue.height() );
		else
			setMinimumSize( tailleVue.width() , tailleParent.height() );
	} else {
		if ( tailleVue.height() > tailleParent.height() ) 
			setMinimumSize( tailleParent.width() , tailleVue.height() );
		else
			setMinimumSize( tailleParent.width() , tailleParent.height() );
	}
}

void ZoneDessin::mousePressEvent ( QMouseEvent * e )
{
	pinceau->begin(this);
	vue->accepter(this);

	objetSelectionne = NULL ;
	xTemp = e->x();
	yTemp = e->y();

	vct = vue->getvctObjetAffichable();
	it  = vct.begin();

	while( it != vct.end() ) {
		x0 = (*it)->getX();
		x1 = (*it)->getLargeur()+x0;
		y0 = (*it)->getY();
		y1 = (*it)->getHauteur()+y0;

		if ( (xTemp<x0) || (xTemp>x1) || (yTemp<y0) || (yTemp>y1) ) {}
		else {

			if ( (xTemp>x0) && (xTemp<x0+7) ) {

				if (yTemp<y0+10) typeSelection = SELECT_AGRANDISSEMENT_HAUT_GAUCHE ;
				else if (yTemp>y1-10) typeSelection = SELECT_AGRANDISSEMENT_BAS_GAUCHE ;
				else typeSelection = SELECT_AGRANDISSEMENT_GAUCHE ;

			}
			else if ( (xTemp>x0+7) && (xTemp<x1-7) ) {

				if (yTemp<y0+10) typeSelection = SELECT_AGRANDISSEMENT_HAUT ;
				else if (yTemp>y1-10) typeSelection = SELECT_AGRANDISSEMENT_BAS ;
				else typeSelection = SELECT_DEPLACEMENT ;

			}
			else if ( (xTemp>x1-7) && (xTemp<x1) ) {

				if (yTemp<y0+10) typeSelection = SELECT_AGRANDISSEMENT_HAUT_DROITE ;
				else if (yTemp>y1-10) typeSelection = SELECT_AGRANDISSEMENT_BAS_DROITE ;
				else typeSelection = SELECT_AGRANDISSEMENT_DROITE ;

			}

			objetSelectionne = *it;
			dessinerCadre(*it);
		}
		++it;
	}
	pinceau->end();
}

void ZoneDessin::mouseReleaseEvent ( QMouseEvent * e )
{
	std::vector<ObjetAffichable*> vctO = vue->getvctObjetAffichable();
	std::vector<ObjetAffichable*>::iterator itO = vctO.begin();
	int dx = e->x()-xTemp;
	int dy = e->y()-yTemp;

	if ( objetSelectionne != NULL ) {
		switch ( typeSelection ) {
		case SELECT_DEPLACEMENT :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX()+dx , 
													objetSelectionne->getY()+dy );
			break;
		case SELECT_AGRANDISSEMENT_HAUT :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX() , 
													objetSelectionne->getY()+dy );
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur() , 
													objetSelectionne->getHauteur()-dy );
			break;
		case SELECT_AGRANDISSEMENT_HAUT_DROITE :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX() , 
													objetSelectionne->getY()+dy );
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()+dx , 
													objetSelectionne->getHauteur()-dy );
			break;
		case SELECT_AGRANDISSEMENT_DROITE :
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()+dx , 
													objetSelectionne->getHauteur() );
			break;
		case SELECT_AGRANDISSEMENT_BAS_DROITE :
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()+dx , 
													objetSelectionne->getHauteur()+dy );
			break;
		case SELECT_AGRANDISSEMENT_BAS :
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur() , 
													objetSelectionne->getHauteur()+dy );
			break;
		case SELECT_AGRANDISSEMENT_BAS_GAUCHE :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX()+dx , 
													objetSelectionne->getY() );
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()-dx , 
													objetSelectionne->getHauteur()+dy );
			break;
		case SELECT_AGRANDISSEMENT_GAUCHE :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX()+dx , 
													objetSelectionne->getY() );
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()-dx , 
													objetSelectionne->getHauteur() );
			break;
		case SELECT_AGRANDISSEMENT_HAUT_GAUCHE :
			objetSelectionne->modifierCoordonnees( objetSelectionne->getX()+dx , 
													objetSelectionne->getY()+dy );
			objetSelectionne->modifierDimension( objetSelectionne->getLargeur()-dx , 
													objetSelectionne->getHauteur()-dy );
			break;
		}

		// dcalage  l'origine sur les x
		if ( objetSelectionne->getX() < 0 ) {
			// parcourir les objets affichables de "vue" et les dcaler (x=x-objetSelectionne->getX())
			while ( itO != vctO.end() ) {
				if (*itO != objetSelectionne)
					(*itO)->modifierCoordonnees ( (*itO)->getX()-objetSelectionne->getX() , (*itO)->getY() );
				++itO;
			}
			objetSelectionne->modifierCoordonnees ( 0 , objetSelectionne->getY() );
		} 

		itO = vctO.begin();
		// dcalage  l'origine sur les y
		if ( objetSelectionne->getY() < 0 ) {
			// parcourir les objets affichables de "vue" et les dcaler (y=y-objetSelectionne->getY())
			while ( itO != vctO.end() ) {
				if (*itO != objetSelectionne)
					(*itO)->modifierCoordonnees ( (*itO)->getX() , (*itO)->getY()-objetSelectionne->getY() );
				++itO;
			}
			objetSelectionne->modifierCoordonnees ( objetSelectionne->getX() , 0 );
		}
		fenetre->getWidgetCentral()->getFenetreDeDessin()->avertir();
	}
	
}

void ZoneDessin::mouseDoubleClickEvent ( QMouseEvent * e )
{
	int x = e->x();
	int y = e->y();

	vct = vue->getvctObjetAffichable();
	it  = vct.begin();

	while( it != vct.end() ) {
		if (((*it)->getX() < x) && 
			((*it)->getX()+(*it)->getLargeur() > x) &&
			((*it)->getY() < y) &&
			((*it)->getY()+(*it)->getHauteur() > y)) {
				ElementDeModelisation * edm = (*it)->getedm();
				if ( fenetre->estClasse(edm) == TRUE ){
						FenetreClasse * fen = new FenetreClasse(fenetre,(Classe*)edm,0);
						fen->show();
				}
				else if ( fenetre->estPaquetage(edm) == TRUE ) {
						FenetrePaquetage * fen = new FenetrePaquetage(fenetre,(Paquetage*)edm,0);
						fen->show();
				}
				else { 
						FenetreRelation * fen = new FenetreRelation(fenetre,(Relation*)edm,0);
						fen->show();
				}
		}
		++it;
	}

}

void ZoneDessin::traiterVue(Vue *v){
    	pinceau->setBrush( black );
    	pinceau->setPen( QPen( black , 2 ) );
	pinceau->eraseRect(0 , 0 , parentWidget()->width() , parentWidget()->height() );

	vct = v->getvctObjetAffichable();
	it  = vct.begin();

	while( it != vct.end() ) {
		x0 = (*it)->getX() ;
		y0 = (*it)->getY() ;
		x1 = (*it)->getLargeur() + x0 ;
		y1 = (*it)->getHauteur() + y0 ;

		(*it)->getedm()->accepter((VisiteurNoeud*)this);

		(*it)->modifierCoordonnees( x0 , y0 ) ;
		(*it)->modifierDimension( x1-x0 , y1-y0 ) ;

		++it;
	}
	if ( objetSelectionne != NULL ) dessinerCadre(objetSelectionne);
}

void ZoneDessin::traiterCommentaire(Commentaire *co )
{
	uint i ;
	string sTemp = "";
	string s = co->getCommentaire();

	yTemp = y0 + 20 ;
	xTemp = x0 + 14 ;

	for (i=0 ; i<s.length() ; ++i) {
		if ( s[i] == '\n' ) {
			pinceau->drawText( x0+7 , yTemp , QString(sTemp.c_str()) );
			if ( 7*sTemp.length() > xTemp-x0-14 ) xTemp = x0 + 14 + 7*sTemp.length() ;
			yTemp = yTemp + 13 ;
			sTemp = "";
		} else {
			sTemp += s[i];
		}
	}
	pinceau->drawText( x0+7 , yTemp , QString(sTemp.c_str()) );
	if ( 7*sTemp.length() > xTemp-x0-14 ) xTemp = x0 + 14 + 7*sTemp.length() ;

	if ( xTemp+20 > x1 ) x1 = xTemp + 20 ;
	if ( yTemp+10 > y1 ) y1 = yTemp + 10 ;

	pinceau->drawLine( x0 , y0 , x1-20 , y0 );
	pinceau->drawLine( x1-20 , y0 , x1 , y0+20 );
	pinceau->drawLine( x1 , y0+20 , x1 , y1 );
	pinceau->drawLine( x1 , y1 , x0 , y1 );
	pinceau->drawLine( x0 , y1 , x0 , y0 );

	pinceau->drawLine( x1-20 , y0 , x1-20 , y0+20 );
	pinceau->drawLine( x1-20 , y0+20 , x1 , y0+20 );

	// traitement des relations commentaires agrges par ce commentaire.
	std::vector<RelationCommentaire *> vctR = co->getvctRelCom();
	std::vector<RelationCommentaire *>::iterator itR = vctR.begin();
	QPoint vecteur[2];
	while ( itR != vctR.end() ) {	
		if ( getCoordonnees( (*itR)->getNoeud() , vecteur ) != FALSE ) {
				intersections(x0, y0, x1-x0, y1-y0,	vecteur[0].x(), vecteur[0].y(), 
							vecteur[1].x()-vecteur[0].x(), vecteur[1].y()-vecteur[0].y(), vecteur );
				pinceau->drawLine( vecteur[0].x() , vecteur[0].y() , vecteur[1].x() , vecteur[1].y() );
		}
		++itR;
	}

}

void ZoneDessin::traiterPaquetage(Paquetage *pa){
	QString s ;
	if ( fenetre->getNoyau()->getProjet()->getNomLong() )
		s = QString(pa->getNomComplet().c_str()) ;
	else
		s = QString(pa->getNom().c_str());

	xTemp = x0 + s.length()*7 + 14 ;
	yTemp = y0 + 80 ;
	if ( xTemp > x1 ) x1 = xTemp ;
	if ( yTemp > y1 ) y1 = yTemp ;

	pinceau->drawLine( x0 , y0 , x1-20 , y0 );
	pinceau->drawLine( x0 , y0+30 , x1 , y0+30 );
	pinceau->drawText( x0+7 , y0+60 , s );
	pinceau->drawLine( x0 , y1 , x1 , y1 );

	pinceau->drawLine( x0 , y0 , x0 , y1 );
	pinceau->drawLine( x1-20 , y0 , x1-20 , y0+30 );
	pinceau->drawLine( x1 , y0+30 , x1 , y1 );
}

void ZoneDessin::traiterClasse(Classe *cl){
	int yAttr ;
	QString s ;
	if ( fenetre->getNoyau()->getProjet()->getNomLong() )
		s = QString(cl->getNomComplet().c_str()) ;
	else
		s = QString(cl->getNom().c_str());

	xTemp = x0 + s.length()*7 + 14 ;
	yTemp = y0 + 45 ;

	std::vector<Attribut *> vctA = cl->getVctAttribut();
	std::vector<Attribut *>::iterator itA = vctA.begin();
	while ( itA != vctA.end() ) {
		(*itA)->accepter(this);
		yTemp += 15 ;
		++itA;
	}

	yAttr = yTemp ;
	yTemp += 15 ;

	std::vector<Methode *> vctM = cl->getVctMethode();
	std::vector<Methode *>::iterator itM = vctM.begin();
	while ( itM != vctM.end() ) {
		(*itM)->accepter(this);
		yTemp += 15 ;
		++itM;
	}

	y1 = yTemp ;
	x1 = xTemp ;

	pinceau->drawText( (x1+x0-s.length()*7)/2 , y0+15 , s );

	pinceau->drawLine( x0 , y0 , x1 , y0 );
	pinceau->drawLine( x0 , y0+30 , x1 , y0+30 );
	pinceau->drawLine( x0 , yAttr , x1 , yAttr );
	pinceau->drawLine( x0 , y1 , x1 , y1 );
	pinceau->drawLine( x0 , y0 , x0 , y1 );
	pinceau->drawLine( x1 , y0 , x1 , y1 );
}

void ZoneDessin::traiterMethode(Methode *m){
	QString sTemp ;
	if ( fenetre->getNoyau()->getProjet()->getNomLong() )
		sTemp = QString(m->grandeChaine().c_str()) ;
	else	     
		sTemp = QString(m->petiteChaine().c_str());

	pinceau->drawText( x0+7 , yTemp , sTemp );
	if ( x0 + sTemp.length()*7 + 14 > xTemp ) xTemp = x0 + sTemp.length()*7 + 14 ;
}

void ZoneDessin::traiterAttribut(Attribut *a){
	QString sTemp ;
	if ( fenetre->getNoyau()->getProjet()->getNomLong() )
		sTemp = QString(a->grandeChaine().c_str()) ;
	else
		sTemp = QString(a->petiteChaine().c_str());

	pinceau->drawText( x0+7 , yTemp , sTemp );
	if ( x0 + sTemp.length()*7 + 14 > xTemp ) xTemp = x0 + sTemp.length()*7 + 14 ;
}

void ZoneDessin::traiterHeritage(Heritage *h ){
	if ( positionnerRelation ( h ) == FALSE ) return ;

	float taille = (float )sqrt(((y1-y0)*(y1-y0))+((x1-x0)*(x1-x0)));
	float floatDep1 = ((x0-x1+y0-y1)*10*sqrt(2))/taille;
	float floatDep2 = ((-1)*(x0-x1-y0+y1)*10*sqrt(2))/taille;

	int dep1 = (int)floatDep1;
	int dep2 = (int)floatDep2;

	pinceau->drawLine( x0 , y0 , x1+((dep1-dep2)/2) , y1+((dep1+dep2)/2) );

	pinceau->drawLine( x1 , y1 , x1+dep1 , y1+dep2 );
	pinceau->drawLine( x1 , y1 , x1-dep2 , y1+dep1 );
	pinceau->drawLine( x1+dep1 , y1+dep2 , x1-dep2 , y1+dep1 );
}

void ZoneDessin::traiterUtilisation(Utilisation *u){
	if ( positionnerRelation ( u ) == FALSE ) return ;

	float taille = (float )sqrt(((y1-y0)*(y1-y0))+((x1-x0)*(x1-x0)));
	float dep1 = ((x0-x1+y0-y1)*10*sqrt(2))/taille;
	float dep2 = ((-1)*(x0-x1-y0+y1)*10*sqrt(2))/taille;

	pinceau->drawLine( x0 , y0 , x1 , y1 );

	pinceau->drawLine( x1 , y1 , x1+dep1 , y1+dep2 );
	pinceau->drawLine( x1 , y1 , x1-dep2 , y1+dep1 );
}

void ZoneDessin::traiterAssociation(Association *a){
	if ( positionnerRelation ( a ) == FALSE ) return ;
	pinceau->drawLine( x0 , y0 , x1 , y1 );
}

void ZoneDessin::traiterAgregation(Agregation *a){
	if ( positionnerRelation(a) == FALSE ) return;

	float taille = (float )sqrt(((y1-y0)*(y1-y0))+((x1-x0)*(x1-x0)));
	float dep1 = ((x1-x0+y1-y0)*10*sqrt(2))/taille;
	float dep2 = ((-1)*(x1-x0-y1+y0)*10*sqrt(2))/taille;

	pinceau->drawLine( x1 , y1 , x0+dep1-dep2 , y0+dep1+dep2 );

	pinceau->drawLine( x0 , y0 , x0+dep1 , y0+dep2);
	pinceau->drawLine( x0 , y0 , x0-dep2 , y0+dep1 );
	pinceau->drawLine( x0+dep1 , y0+dep2 , x0+dep1-dep2 , y0+dep1+dep2);
	pinceau->drawLine( x0-dep2 , y0+dep1 , x0+dep1-dep2 , y0+dep1+dep2 );
}

bool ZoneDessin::positionnerRelation( Relation * r )
{
	std::vector<ObjetAffichable*>vctTemp = vue->getvctObjetAffichable();
	std::vector<ObjetAffichable*>::iterator itTemp = vctTemp.begin();

	Classe * classeSource = r->getClasseSource();
	Classe * classeDestination = r->getClasseDestination();

	ObjetAffichable * objetSource = NULL ;
	ObjetAffichable * objetDestination = NULL ;

	while( itTemp != vctTemp.end() ) {
		if ( (*itTemp)->getedm() == classeSource ) objetSource = *itTemp ;
		if ( (*itTemp)->getedm() == classeDestination ) objetDestination = *itTemp ;
		++itTemp;
	}

	QPoint point[2] ;

	if (( objetSource == NULL ) && ( objetDestination == NULL )) {
		x0 = 0 ;
		x1 = 100 ;
		y0 = 0 ;
		y1 = 100 ;
		return false ;
	} else if (( objetSource == NULL ) && ( objetDestination != NULL )) {

		x0 = 0 ;
		x1 = objetDestination->getX()+objetDestination->getLargeur()/2;
		y0 = 0 ;
		y1 = objetDestination->getY()+objetDestination->getHauteur()/2;

		intersections( 0.0 , 0.0 , 100.0  , 100.0 ,
				(float)objetDestination->getX()  , (float)objetDestination->getY() ,
				(float)objetDestination->getLargeur()  , (float)objetDestination->getHauteur(), point );

	} else if (( objetSource != NULL ) && ( objetDestination == NULL )) {

		x0 = objetSource->getX()+objetSource->getLargeur()/2;
		x1 = 0 ;
		y0 = objetSource->getY()+objetSource->getHauteur()/2;
		y1 = 0 ;

		intersections( (float)objetSource->getX() , (float)objetSource->getY() ,
				(float)objetSource->getLargeur()  , (float)objetSource->getHauteur() ,
				0.0  , 0.0 , 100.0  , 100.0 , point );

	} else {

		x0 = objetSource->getX()+objetSource->getLargeur()/2;
		x1 = objetDestination->getX()+objetDestination->getLargeur()/2;
		y0 = objetSource->getY()+objetSource->getHauteur()/2;
		y1 = objetDestination->getY()+objetDestination->getHauteur()/2;

		intersections( (float)objetSource->getX() , (float)objetSource->getY() ,
				(float)objetSource->getLargeur()  , (float)objetSource->getHauteur() ,
				(float)objetDestination->getX()  , (float)objetDestination->getY() ,
				(float)objetDestination->getLargeur()  , (float)objetDestination->getHauteur(), point );
	}

	x0 = point[0].x() ;
	y0 = point[0].y() ;
	x1 = point[1].x() ;
	y1 = point[1].y() ;
	return TRUE;
}


void ZoneDessin::intersections(float abs0, float ord0, float l0, float h0,
					float abs1, float ord1, float l1, float h1, QPoint buffer[2] )
{
	if (abs0+l0/2 == abs1+l1/2)
	{
		buffer[0].setX(abs0+l0/2);
		buffer[1].setX(abs1+l1/2);

		if (ord0+h0 < ord1)
		{
			buffer[0].setY(ord0+h0);
			buffer[1].setY(ord1);
		}
		else
		{
			buffer[0].setY(ord0);
			buffer[1].setY(ord1+h1);
		}
	return;
	}

	// Equation de la droite directrice (y=ax+b)
	float a = ((ord1+(h1/2)-ord0-(h0/2))/(abs1+(l1/2)-abs0-(l0/2)));
	float b = ((ord0+(h0/2))-a*(abs0+(l0/2)));

cout << "on a la droite" << endl;

	if ((2*abs0+l0)/2 < (2*abs1+l1)/2)
	{
cout << "1 a gauche" << endl;
		// Determination du point du 1 objet si c'est le +  gauche.
		if ((a*(abs0+l0)+b >= ord0) && (a*(abs0+l0)+b <= ord0+h0))
		{ // Le point est sur l'axe x=abs0+l0
			buffer[0].setX(abs0+l0);
			buffer[0].setY(a*(abs0+l0)+b);
		}
		else if (a>0) // Coeff. directeur positif
		{
			buffer[0].setY(ord0+h0);
			buffer[0].setX(((ord0+h0)-b)/a);
		}
		else if (a<0) // Coeff. directeur negatif
		{
			buffer[0].setY(ord0);
			buffer[0].setX((ord0-b)/a);
		}
		else // Coeff.directeur nul
		{
			buffer[0].setY(ord0+(h0/2));
			buffer[0].setX(abs0+l0);
		}

		// Determination du point du 2 objet si c'est le +  droite.
		if ((a*abs1+b >= ord1) && (a*abs1+b <= ord1+h1))
		{
			buffer[1].setX(abs1);
			buffer[1].setY(a*abs1+b);
		}
		else if (a>0) // Coeff. directeur positif
		{
			buffer[1].setY(ord1);
			buffer[1].setX((ord1-b)/a);
		}
		else if (a<0) // Coeff. directeur negatif
		{
			buffer[1].setY(ord1+h1);
			buffer[1].setX((ord1+h1-b)/a);
		}
		else // Coeff. directeur nul
		{
			buffer[1].setX(abs1);
			buffer[1].setY(ord1+(h1/2));
		}
	}
	else
	{
cout << "2 a gauche" << endl;
		// Determination du point du 2 objet si c'est le +  gauche.
		if ((a*(abs1+l1)+b >= ord1) && (a*(abs1+l1)+b <= ord1+h1))
		{
cout << "dest. pour point sur la droite" << endl;
			buffer[1].setX(abs1+l1);
			buffer[1].setY(a*(abs1+l1)+b);
		}
		else if (a>0) // Coeff. directeur positif
		{
cout << "dest si a>0" << endl;
			buffer[1].setY(ord1+h1);
			buffer[1].setX(((ord1+h1)-b)/a);
		}
		else if (a<0) // Coeff. directeur negatif
		{
cout << "dest si a<0" << endl;
			buffer[1].setY(ord1);
			buffer[1].setX((ord1-b)/a);
		}
		else
		{
cout << "dest si a=0 :o(" << endl;
			buffer[1].setX(abs1+l1);
			buffer[1].setY(ord1+(h1/2));
		}

cout << "sinon c'est la" << endl;
		// Determination du point du 1 objet si c'est le +  droite.
		if ((a*abs0+b >= ord0) && (a*abs0+b <= ord0+h0))
		{
			buffer[0].setX(abs0);
			buffer[0].setY(a*abs0+b);
		}
		else if (a>0) // Coeff. directeur positif
		{
			buffer[0].setY(ord0);
			buffer[0].setX((ord0-b)/a);
		}
		else if (a<0)// Coeff. directeur negatif
		{
			buffer[0].setY(ord0+h0);
			buffer[0].setX(((ord0+h0)-b)/a);
cout << "x: " << buffer[0].x() << endl;
cout << "y: " << buffer[0].y() << endl;
		}
	}
cout << "on sort" << endl;
}

void ZoneDessin::dessinerCadre( ObjetAffichable * oa )
{
	int x = (*it)->getX();
	int w = (*it)->getLargeur();
	int y = (*it)->getY();
	int h = (*it)->getHauteur();

	pinceau->setBrush( red );
    	pinceau->setPen( QPen( red , 2 ) );

	pinceau->drawLine( x , y , x+w , y );
	pinceau->drawLine( x+w , y , x+w , y+h );
	pinceau->drawLine( x+w , y+h , x , y+h );
	pinceau->drawLine( x , y+h , x , y );

	pinceau->setBrush( black );
    	pinceau->setPen( QPen( black , 2 ) );

}

bool ZoneDessin::getCoordonnees( Noeud * noeud , QPoint vecteur[2] )
{
	bool trouve = FALSE ;
	std::vector<ObjetAffichable*> vctO = vue->getvctObjetAffichable() ;
	std::vector<ObjetAffichable*>::iterator itO = vctO.begin() ;
	

	while ( itO != vctO.end() ) {
		ElementDeModelisation * edm = (*itO)->getedm();
		if ( fenetre->estClasse(edm) ) {
				std::vector<Methode*> vctM = ((Classe*)(edm))->getVctMethode();
				std::vector<Methode*>::iterator itM = vctM.begin();
				while ( itM != vctM.end() ) {
					if ( *itM == noeud ) {
							trouve = TRUE;
							break;
					}
					++itM;
				}

				if ( !trouve ) {
					std::vector<Attribut*> vctA = ((Classe*)edm)->getVctAttribut();
					std::vector<Attribut*>::iterator itA = vctA.begin();
					while ( itA != vctA.end() ) {
						if ( *itA == noeud ) {
								trouve = TRUE ;
								break;
						}
						++itA;
					}
				}
		}
		if ( (edm == noeud) || trouve ) {
				vecteur[0].setX( (*itO)->getX() );
				vecteur[0].setY( (*itO)->getY() );
				vecteur[1].setX( (*itO)->getX()+(*itO)->getLargeur() );
				vecteur[1].setY( (*itO)->getY()+(*itO)->getHauteur() );
				return TRUE;
		}
		++itO;
	}
	return FALSE;
}

QSize ZoneDessin::getTaille( )
{
	QSize s =QSize(0,0);
	int w,h;

	std::vector<ObjetAffichable*> vctO = vue->getvctObjetAffichable();
	std::vector<ObjetAffichable*>::iterator itO = vctO.begin();
	while ( itO != vctO.end() ) {
		w = (*itO)->getX() + (*itO)->getLargeur() ;
		if ( w > s.width() ) s.setWidth(w);
		h = (*itO)->getY() + (*itO)->getHauteur() ;
		if ( h > s.height() ) s.setHeight(h);
		++itO;
	}
	return s;
}

void ZoneDessin::enregistrerVue()
{
	QString stringNom = QString(vue->getNom().c_str()) + ".jpg";
	QString fileName = QFileDialog::getSaveFileName(stringNom, "JPEG (*.jpg)", this );
	if ( !fileName.isNull() ) {
		QPixmap vu = QPixmap(getTaille());
		pinceau = new QPainter(&vu);
		vue->accepter(this);
		pinceau->end();
		vu.save(fileName,"JPEG");
	}
	
}
