/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyattribut.h                            */
/************************************************/

#ifndef NOYATTRIBUT_H
#define NOYATTRIBUT_H
#include <iostream>
#include <noyelementdemodelisation.h>

/**
 * Cette classe a pour but de modliser un attribut d'une classe au sens UML du terme.
 * @author clucas - ndouay
 */
class Attribut:public Noeud{

private:
	//! le type de l'attribut
	string _type;
	//! la visibilit de l'attribut
	string _visible;
public:
	
	/**Constructeur 
	* \param Noeud* pere : pointeur sur un noeud reprsentant le pre de l'attribut
	* \param const string &nom : chane de caractres reprsentant le nom de l'attribut
	* \param const string &visible : chane de caractres reprsentant la visibilit de l'attribut
	* \param const string &type : chane de caractres reprsentant le type de l'attribut
	*/
	Attribut(Noeud *pere,const string &nom,const string &visible,const string &type);
	
	/**Destructeur
	*/
	virtual ~Attribut();
	
	/**Cette fonction permet rcuprer le prototype d'un attribut en format court,
	* c'est  dire <+|-|#> <nom> (+ :public, - :private, # :protected).
	* Cette fonction est utilise par l'IHM.
	* \return le prototype est contenu dans dans une chane de caractres
	*/
	string petiteChaine();	//retourne le nom de l'attribut en format court
	
	/**Cette fonction fait comme la prcdente sauf que le format de retour est long,
	* c'est  dire <visibilit> <type> <nom de l'attribut>.
	* Cette fonction est surtout utile  l'IHM.
	* \return le prototype est contenu dans une chane de caractres
	*/
	string grandeChaine();	//retourne le nom de l'attribut en format long
	
	/**Cette fonction fixe la visibilit d'un attribut dfini par l'utilisateur
	* \param const string &visible : chane de caractres repsentant la visibilit 
	* de l'attribut dfini par l'utilisateur 
	*/
	void setVisible(const string &visible);
	
	/**Cette fonction fixe le type d'un attribut dfini par l'utilisateur
	* \param string Type : chane de caractres repsentant le type
	* de l'attribut dfini par l'utilisateur 
	*/
	void setType(const string &type);
	
	/**Cette fonction permet de connatre la visibilit d'un attribut:
	* 	-public
	*	 -protected
	* 	-private
	* \return le retour se fait dans une chane de caractres
	*/
	string getVisible();
	
	/**Cette mthode permet de rcuprer le type d'un attribut
	* \return le type est renvoy dans une chane de caractres
	*/
	string getType();
	
	/** Cette fonction permet d'accepter un visiteur
	* \param VisiteurNoeud *v : visiteur  accepter
	*/
	void accepter(VisiteurNoeud *v);
};
#endif
