/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noycharger.h                            */
/************************************************/


#include <qxml.h>
#include <string>
#include <vector>

class QString;
class Noyau ;
class Objetuml;
class Noeud ;
class ElementDeModelisation ;
class Relation ;


/**
 * Cette classe a pour but de stocker une rfrence sur un objet cr
 * au fur et  mesure qu'il est instanci lors du parcours du fichier XML.
 * @author n.douay - c.lucas
 */
class Objet{
public:
	//! contient l'identifiant de l'objet se trouvant dans le fichier, c'est  dire lors
	// de la sauvegarde du projet.
	string			_id ;
	//! contient une rfrence sur l"objet qui doit tre stock.
	Noeud			*_e ;

	//! constructeur
	Objet( string id  , Noeud *e ) { _id =  id.c_str() ; _e=e; }
	//! destructeur
	virtual ~Objet( ) { }
	
	//! permet de rcuprer l'identifiant.
	string			getID(){ return _id ; }
	//! permet de rcuprer l'instance sur l'objet.
	Noeud*			getEDM(){ return _e ; }
};

/**
 * Cette mthode a pour but de stocker les relations afin de les traiter 
 * aprs avoir ajouter tous les objets du noyau
 * @author n.douay - c.lucas
 *
 */
class ObjetRelation{
public:
	//! contructeur
	ObjetRelation( string id , Relation *r , string source , string dest ) 
	{
		_id = id ;
		_r = r ;
		_source = source ;
		_dest = dest ;
	}
	
	//! destructeur
	virtual ~ObjetRelation() { }
	// ATTRIBUTS
	//! La relation que l'on doit stocker
	Relation	*_r;
	//! l'identifiant de la classe source et destination
	string		_source, _dest ;
	//! l'identifiant
	string		_id ;

	// METHODES
	//! mthode permettant de rcuprer l'identifiant de la relation
	string		getID(){ return _id ; }
	//! mthode permettant de rcuprer la relation stocke
	Relation*	getRelation() { return _r ; }
	//! mthode permettant de rcuprer l'identifiant sur la destination
	string		getDEST() { return _dest ; }
};

/**
 * La classe charger est la classe qui permet de parcourir le fichier XML
 * stockant un projet.
 * Cette classe hrite de QXmlDefaultHandler qui est un parseur XML fournit
 * par la librairie Qt.
 * @author n.douay - c.lucas
 *
 */
class Charger : public QXmlDefaultHandler
{
public:
	//! Constructeur
	Charger( Noyau *n ) ;
	//! Destructeur
 	virtual ~Charger( ) ;
	//! Cette mthode est appele lorsque le parseur rencontre le dbut du document.
	bool startDocument();
	//! Cette mthode est appele lorsque le parseur rencontre un tag de dbut de section.
	bool startElement( const QString&, const QString&, const QString& , 
                       const QXmlAttributes& );
	//! Cette mthode est appele lorsque le parseur rencontre un tag de fin de section.
	bool endElement( const QString&, const QString&, const QString& );
	//! Cette mthode est appele afin de rcuprer les caractres qui se trouvent entre deux
	// tag de dbut et de fin.
	bool characters ( const QString & ch ) ;
	//! Cette mthode est appele lorsque le parseur rencontre des blancs.
	bool ignorableWhitespace ( const QString & ch );
	//! Cette mthode est appele lorsque l'on rencontre les instructions de dbut de fichier
	// comme <?xml...>
	bool processingInstruction ( const QString & target, const QString & data );
	//! Cette mthode est appele lorsque le parseur rencontre une erreur.
	QString errorString ();

	//!Fonctions permettant d'initialis le noyau ...
	//! Cette mthode est appele lorsque l'on rencontre le tag <projet...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerProjet( const string &nom , const QXmlAttributes& a );
	//! Cette mthode est appele lorsque l'on rencontre le tag <paquetage...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerPaquetage( const string &nom , const QXmlAttributes& a );
	//! Cette mthode est appele lorsque l'on rencontre le tag <classe...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerClasse( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <methode...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerMethode( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <attribut...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerAttribut( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <parametre...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerParametre( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <vue...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
//void	creerRelation( const string &nom , const QXmlAttributes& a);
	void	creerVue( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <objetaffichable...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerObjetAffichable( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <heritage...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerHeritage( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <association...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerAssociation( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <utilisation...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerUtilisation( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <agregation...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerAgregation( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <commentaire...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerCommentaire( const string &nom , const QXmlAttributes& a);
	//! Cette mthode est appele lorsque l'on rencontre le tag <rc...> en
	// donnant en paramtre le nom du tag rencontr et ses attributs 
	void	creerRelationCommentaire( const string &nom , const QXmlAttributes& a);

	//! Cette mthode est appele une fois que le parcours du fichier est complet.	
	void	majRelation( );
	//! Cette mthode est prsente uniquement pour le debug.
	void	verif( );
	//! Vecteur d'objet
	std::vector<Objet *> vctObjet ;

	 //! Vecteur de relation a trait ultrieurement
	std::vector<ObjetRelation *> vctObjetRelation ;

	/*
	 * VARIABLE SUREMENT A VIRER
	 */
	int		nb_elem ;
private:
	//! Cette attribut sert  l'indentation dans le fichier
	QString 	indent;
	//! ce string  sert  garder le tag courant
	string 		tag_courant ;
	//! ce string sert  garder le prcdent tag
	string		tag_precedent ;
	//! ce string sert  garder l'identifiant de la classe courante
	string		id_classe_courante ;
	//! Cet objet est un pointeur sur une instance du noyau
	Noyau		*_n ;

	//! ce pointeur de noeud sert  garder le noeud courant
	Noeud		*n_courant;
	//! ce pointeur de noeud sert  garder le noeud prcdent
	Noeud		*n_prec ;
	//! ce pointeur de noeud sert  garder une rfrence sur la mthode courante
	Noeud		*n_meth ; 
	//! ce pointeur de noeud sert  garder une rfrence sur le commentaire courant
	Noeud		*n_comm ;
};                   

/**
 * Cette classe a pour but de grer les erreurs qui peuvent survenir
 * lors du parcours du fichier.
 * @author n.douay - c.lucas
 */
class ErrorHandler : public QXmlErrorHandler
{
public:
	//! Constructeur
	ErrorHandler( ) ;
	//! Destructeur
	virtual ~ErrorHandler( ) { }

	//! est appele lorsque une erreur survient.
	bool error( const QXmlParseException & exception ) ;	
	//! est appele lorsque une erreur critique rcuprable survient.
	bool warning(const QXmlParseException &) ; 
	//! est appele lorsque une erreur fatale au parseur XML survient.
        bool fatalError(const QXmlParseException &) ;
	//! mthode qui est appele pour renvoye une chaine.
        QString errorString() {return "PB!!! ";  }

};

