/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyclasse.cpp                           */
/************************************************/

#include <noyclasse.h>
#include <noyobjetaffichable.h>
#include <noydiagrammestatique.h>
#include <noymethode.h>
#include <noyrelation.h>

Classe::Classe(Noeud* pere, const string &nom, const string &visibilite, bool type):Objetuml(pere,nom) 
{
	_visibilite = visibilite;
	_type = type ;
}

Classe::~Classe() {
	DiagrammeStatique	*d ;

	cout << "destructeur de classe" << endl;
	// delete des relations
	std::vector<Relation *>::iterator itRel;
	std::vector<Relation *> vctRelationCopie ;
	vctRelationCopie = vctRelation ;
	itRel = vctRelationCopie.begin();

	while( itRel != vctRelationCopie.end() ) {
		// Suppression effective DES vecteurs
		if( (*itRel)->getClasseSource()->supprimerRelationDestructeur( *itRel ) != true ) {
			cout << "Oulala je me suis fait aggress par un vecteur dans la classe source, je me casse !!" << endl ;
		}
		if( (*itRel)->getClasseDestination()->supprimerRelationDestructeur( *itRel ) != true ) {
			cout << "Oulala je me suis fait aggress par un vecteur dans le classe dest, je me casse !!" << endl ;
		}
		
		// et je dtruis l'objet !! bye bye !!
		delete *itRel ;
		
		++itRel ;
	}

	// delete des methodes
	std::vector<Methode*>::iterator it_meth;
	it_meth = vctMethode.begin();
	while( (it_meth != vctMethode.end()) ){
		delete *it_meth;
		++it_meth;
	}
	
	cout << "entre dans les attributs" << endl;
	// delete des attrbuts
	std::vector<Attribut*>::iterator it_attr;
	it_attr = vctAttribut.begin();
	while( (it_attr != vctAttribut.end()) ){
		delete *it_attr;
		++it_attr;
	}

	// Supprimer dans toutes les vues.
	d = getDiagrammeStatique();
	if( d== NULL ) { cout << "PB !!! d = NULL " << endl ; exit(0); }
	cout << "apres avoir recuperer le diagramme statique - " << d->getNom() << endl ;
	// Pour chaque vue, je regarde si j'existe dans celle-ci !
	std::vector<Vue*>::iterator it;
	std::vector<Vue*> v = d->getVctVue();
	it = v.begin();
	cout << "debut de l'iteration" << endl ;
	while((it != v.end())){
		cout << "Vue:" << (*it)->getNom() << endl ;
		// Dans chaque vue, je regarde si j'apparais !
		(*it)->supprimerClasse( this );
		++it;
	}

	cout << "je sors du destructeur !!" << endl ;
}

void Classe::accepter(VisiteurNoeud* v)
{
	v->traiterClasse(this);
}

bool	Classe::ajouterMethode(const string &nom, const string &type, const string &visibilite,std::vector<Parametre*> vctParametre)
{
	Methode *m = new Methode(this,nom,visibilite,type);
	if (verifierExistenceMethode(nom,visibilite,type,vctParametre) != NULL){
		return false;
	}
	std::vector<Parametre*>::iterator it;
	it = vctParametre.begin();
	while(it != vctParametre.end()){
		m->ajouterParametre((*it));
		++it;
	}
	vctMethode.push_back(m);

return true ;
}	

Methode*	Classe::ajouterMethode2(const string &nom, const string &type, const string &visibilite,std::vector<Parametre*> vctParametre)
{
	Methode *m = new Methode(this,nom,visibilite,type);
	if (verifierExistenceMethode(nom,visibilite,type,vctParametre) != NULL){
		return NULL;
	}
	std::vector<Parametre*>::iterator it;
	it = vctParametre.begin();
	while(it != vctParametre.end()){
		m->ajouterParametre((*it));
		++it;
	}
	vctMethode.push_back(m);

return m ;
}

Methode * Classe::verifierExistenceMethode(const string &nom, const string &visibilite, const string &type, std::vector<Parametre*> vctParametre){
	std::vector<Methode*>::iterator it;
	it = vctMethode.begin();
	while (it != vctMethode.end()){
		if ((*it)->getNom() == nom){
					std::vector<Parametre*>::iterator it2;
					std::vector<Parametre*>::iterator it3;
					std::vector<Parametre*> vctParametreTemp;
					(*it)->cloneVctParametre( vctParametreTemp);
					it2 = vctParametre.begin();
					it3 = vctParametreTemp.begin();

					while ((((it2 != vctParametre.end()) && (it3 != vctParametreTemp.end())) 
							&& ((*it2)->getNom() == (*it3)->getNom())) 
							&& ((*it2)->getType() == (*it3)->getType()) ){
						++it2;
						++it3;
						
					}
					if ((it2 == vctParametre.end()) && (it3 == vctParametreTemp.end())){
						return (*it);
					}
				}
		++it;
	}
	return NULL;
}

bool	Classe::ajouterAttribut(const string &type, const string &nom, const string &visible)
{
	Attribut *a = new Attribut(this,nom,visible,type);
	if (verifierExistenceAttribut(nom,visible,type) != NULL){
		return false;
	}
	vctAttribut.push_back(a);
	return true;
}

Attribut*	Classe::ajouterAttribut2(const string &type, const string &nom, const string &visible)
{
	Attribut *a = new Attribut(this,nom,visible,type);
	if (verifierExistenceAttribut(nom,visible,type) != NULL){
		return NULL;
	}
	vctAttribut.push_back(a);
	return a;
}

Attribut* Classe::verifierExistenceAttribut(const string &nom, const string &visible, const string &type)
{
	std::vector<Attribut*>::iterator it;
	it = vctAttribut.begin();
	while (it != vctAttribut.end()){
		if ((*it)->getNom() == nom)
			if ((*it)->getVisible() == visible)
				if ((*it)->getType() == type)
					return (*it);
		++it;
	}
	return NULL;
}
 
Relation*	Classe::ajouterRelation(const string &nom, int r, Classe *c1, Classe *c2, const string &multipliciteSource, const string &multipliciteDestination)
{
	std::vector<Relation*> vctDest ;
	Relation *rel;
	switch(r){
		case REL_AGREGATION: rel = new Agregation(this, nom, this, c2, multipliciteSource, multipliciteDestination);
				break;
		case REL_UTILISATION: rel = new Utilisation(this, nom, this, c2,multipliciteSource,multipliciteDestination);
				break;
		case REL_ASSOCIATION: rel = new Association(this, nom, this, c2,multipliciteSource,multipliciteDestination);
				break;
		case REL_HERITAGE: rel = new Heritage(this, nom, this ,c2);
				break;
	}

	// On vrifie si la relation existe dj
	if (verifierExistenceRelation(rel, r) == true)
		return NULL;
	else
		vctRelation.push_back(rel);

	

	// Puis on ajoute la relation dans la classe destination
	c2->ajouterRelationExterieure(c2,rel);
	return rel;
}

// METHODE UTILE LORS DU CHARGEMENT
Relation*	Classe::ajouterRelation( Relation *r )
{
	vctRelation.push_back(r);
return r ;
}

class VisiteurRelation : public VisiteurNoeud {

	public:
		int	type;
		VisiteurRelation() {}
		virtual ~VisiteurRelation() {}
		void traiterHeritage(Heritage *h){
			type = REL_HERITAGE ;
		}
		void traiterAssociation(Association *a){
			type = REL_ASSOCIATION;
		}	
		void traiterAgregation(Agregation *a){
			type = REL_AGREGATION;
		}
		void traiterUtilisation(Utilisation *u){
			type = REL_UTILISATION;
		}
};

bool Classe::verifierExistenceRelation(Relation *rel, int type)
{
	VisiteurRelation 	*vr = new VisiteurRelation();
	VisiteurRelation 	*vr2 = new VisiteurRelation();
	
	std::vector<Relation *>  vctTemp ;
	vctTemp = getVctRelation();
	
	std::vector<Relation*>::iterator it;
	it = vctTemp.begin();
	while(it != vctTemp.end()){
		(*it)->accepter( vr );
		rel->accepter( vr2 );
		if( vr->type == vr2->type ) {
			if( (*it)->getClasseDestination() == rel->getClasseDestination() ){
				if( (*it)->getClasseSource() == rel->getClasseSource() ) {
					return true;
				}
			}
		}
		++it;
	}
	return false;
}

bool Classe::supprimerMethode(Methode *m)
{
	std::vector<Methode*>::iterator it;
	it=vctMethode.begin();
	while((it != vctMethode.end()) ){
		if( *it == m ) {
			vctMethode.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}

bool Classe::supprimerAttribut(Attribut *a)
{
	std::vector<Attribut*>::iterator it;
	it=vctAttribut.begin();
	while((it != vctAttribut.end()) ){
		if( *it == a ) {
			vctAttribut.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}

bool Classe::supprimerRelationDestructeur(Relation *r)
{
	std::vector<Relation*>::iterator it;
	it=vctRelation.begin();
	while((it != vctRelation.end()) ){
		if( *it == r ) {
			vctRelation.erase( it );
			return true ;
		}
		++it;
	}
return false ;
}

bool Classe::supprimerRelation(Relation *r)
{
	// Suppression effective DES vecteurs
	if( supprimerRelationDestructeur( r ) != true ) {
		cout << "Oulala je me suis fait aggress par un vecteur dans la classe source, je me casse !!" << endl ;
	}
	if( (r)->getClasseDestination()->supprimerRelationDestructeur( r ) != true ) {
		cout << "Oulala je me suis fait aggress par un vecteur dans le classe dest, je me casse !!" << endl ;
	}
	
	// et je dtruis l'objet !! bye bye !!
	delete r ;
	return true;
}

void Classe::visiterRelation(VisiteurNoeud *v)
{
	std::vector<Relation*>::iterator it;
	it=vctRelation.begin();
	while(it != vctRelation.end()){
		((Relation *)*it)->accepter(v);
		++it;
	}
}

void Classe::visiterFils(VisiteurNoeud* v)
{
	visiterRelation(v);
}

Methode* Classe::possedeMethode( Methode *m )
{
	std::vector<Methode*>::iterator it;
	it=vctMethode.begin();
	while((it != vctMethode.end()) ) {
		if( *it == m ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

Attribut* Classe::possedeAttribut( Attribut *a )
{
	std::vector<Attribut*>::iterator it;
	it=vctAttribut.begin();
	while((it != vctAttribut.end()) ) {
		if( *it == a ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

Relation* Classe::possedeRelation( Relation *r )
{
	std::vector<Relation*>::iterator it;
	it=vctRelation.begin();
	while((it != vctRelation.end()) ) {
		if( *it == r ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

std::vector<Relation*> Classe::getVctRelation(){
	return vctRelation;
}

std::vector<Methode *> Classe::getVctMethode(){
	return vctMethode;
}
	
std::vector<Attribut *> Classe::getVctAttribut(){
	return vctAttribut;
}

void	Classe::ajouterRelationExterieure( Classe *dest, Relation *r )
{
	std::vector<Relation*> vctDest ;

	vctDest = dest->getVctRelation( );
	vctDest.push_back( r );
	dest->setVctRelation( vctDest );
}

void	Classe::setVctRelation( std::vector<Relation*> r )
{
	vctRelation = r ;
}

string Classe::getVisibilite()
{
	return _visibilite;
}

void Classe::setVisibilite(const string &visibilite)
{
	_visibilite = visibilite;
}

void Classe::setTypeDeClasse( bool b )
{
	std::vector<Methode *> vct = getVctMethode();
	std::vector<Methode *>::iterator it ;

	_type = b ;

	if( b == false ) {
		/* on veut qu'elle soit une interface */
		it = vct.begin();	
		while( it != vct.end() ) {
			/* On vide sont code */
			(*it)->setCode( "" );
		++ it ;
		}

	}
}

bool Classe::getTypeDeClasse( )
{
	return _type ;
}
