/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyclasse.h                             */
/************************************************/

#ifndef NOYCLASSE_H
#define NOYCLASSE_H

#include <iostream>
#include <vector>

#include <noyobjetuml.h>
#include <noymethode.h>
#include <noyattribut.h>
#include <noyrelation.h>
#include <noycommun.h>
#include <noyagregation.h>
#include <noyheritage.h>
#include <noyutilisation.h>
#include <noyassociation.h>

/**
 * Cette classe a pour but de modliser une classe au sens UML du terme.
 * @author clucas - ndouay
 */
class Classe:public Objetuml{

private:

	//! Vecteur de relations
	std::vector<Relation*> vctRelation;
	//! Vecteur de mthodes
	std::vector<Methode*> vctMethode;
	//! Vecteur d'attributs
	std::vector<Attribut*> vctAttribut;
	//! Visibilit de la classe
	string _visibilite;
	//! indentifie la classe gnrique: classe(true) ou interface(false)
	bool	_type ;	
	//*! cette mthode permet de supprimer une occurence d'une relation dans un vecteur
	bool supprimerRelationDestructeur(Relation *r);



public:
	//! Constructeur
	Classe(Noeud* pere, const string &nom, const string &visibilite, bool type);
	//! destructeur de la classe
	virtual ~Classe();

	/** Cette mthode permet d'ajouter une mthode  cette classe.
	 * \param const string &nom : le nom de la mthode  ajouter
	 * \param const string &type : type de retour de la fonction
	 * \param const string &visibilite : visibilite de la fonction (public, private, protected)
	 * \param std::vector<Parametre*> : liste des paramtre de la fonction
	 * \return "true" si une mthode est bien ajoute ou "false" si il y a problme
	 */
	bool		ajouterMethode(const string &nom, const string &type, const string &visibilite,std::vector<Parametre*> vctParametre);

	/** Cette mthode permet d'ajouter une mthode  cette classe.
	 * \param const string &nom : le nom de la mthode  ajouter
	 * \param const string &type : type de retour de la fonction
	 * \param const string &visibilite : visibilite de la fonction (public, private, protected)
	 * \param std::vector<Parametre*> : liste des paramtre de la fonction
	 * \return "true" si une mthode est bien ajoute ou "false" si il y a problme
	 */
	Methode*	ajouterMethode2(const string &nom, const string &type, const string &visibilite,std::vector<Parametre*> vctParametre);

	/** Cette mthode permet de supprimer une mthode  cette classe.
	 * \param Methode *m : La mthode  supprimer
	 * \return "true" si une mthode est bien supprime ou "false" si il y a problme
	 */
	bool		supprimerMethode(Methode *m);
	
	/** Cette mthode permet d'ajouter un attribut  cette classe.
	 * \param const string &type : type de l'attribut  ajouter
	 * \param const string &nom : nom de l'attribut  ajouter
	 * \param const string &visible : dcrit si 'attribut est public, private ou protected
	 * \return "true" si un attribut est bien ajout ou "false" si il y a problme
	 */
	bool		ajouterAttribut(const string &type, const string &nom, const string &visible);

	/** Cette mthode permet d'ajouter un attribut  cette classe.
	 * \param const string &type : type de l'attribut  ajouter
	 * \param const string &nom : nom de l'attribut  ajouter
	 * \param const string &visible : dcrit si 'attribut est public, private ou protected
	 * \return un pointeur sur l'attribut ajout  cette classe
	 */
	Attribut*		ajouterAttribut2(const string &type, const string &nom, const string &visible);


	/** Cette mthode permet de supprimer une mthode  cette classe.
	 * \param Attribut *a : L'attribut  supprimer
	 * \return "true" si un attribut est bien supprime ou "false" si il y a problme
	 */
	bool		supprimerAttribut(Attribut *a);
 
	/** Cette mthode permet d'ajouter une relation  cette classe.
	 * \param const string &nom =0 : Le nom de la relation  ajouter (elle peut ne pas en avoir)
	 * \param int r : entier reprsentant le type de relation (agregation, utilisation, ...)
	 * \param Classe *c1 : pointeur sur la classe source
	 * \param Classe *c2 : pointeur sur la classe destination
	 * \param const string &multipliciteSource : chane reprsentant la multiplicit  la source
	 * \param const string &multiplicite : chane reprsentant la multiplicit  la destination
	 * \return "true" si une relation est bien ajoute ou "false" si il y a problme
	 */
	Relation*	ajouterRelation(const string &nom, int r, Classe *c1, Classe *c2, const string &multipliciteSource, const string &multiplicite);

	/**
	 * Cette mthode est utilie pour ajouter une relation dans une classe. Elle sera surtout utilis 
	 * pour le chargement
	 * \param Relation *r : tout type de relation
	 */
	Relation*	ajouterRelation( Relation *r ) ;

	/** Cette mthode permet de supprimer une relation  cette classe.
	 * \param Relation *r : La relation  supprimer
	 * \return "true" si une relation est bien supprime ou "false" si il y a problme
	 */
	bool		supprimerRelation(Relation *r);

	/** Cette mthode permet d'accepter un visiteur implment et \b DOIT tre
	 * redfini par l'utilisateur.
	 * \param VisiteurNoeud *v : visiteur utilisateur
	 */
	virtual void	accepter(VisiteurNoeud *v);

	/** Cette mthode permet de vrifier l'existence d'une mthode.
	 * \param const string &nom : Le nom donn par l'utilisateur pour cette mthode
	 * \param const string &visibilite : visibilit donne  la fonction
	 * \param const string &type : type de retour de cette mthode
	 * \param std::vector<Parametre*> vctParametre : liste des paramtres de la mthode
	 * \return retourne la reference de la mthode si elle existe et "NULL" sinon
	 */
	Methode * verifierExistenceMethode(const string &nom, const string &visibilite, const string &type, std::vector<Parametre*> vctParametre);

	/** Cette mthode permet de vrifier si une mthode existe dans cette classe.
	 * \param Methode *m : La mthode  vrifier
	 * \return un pointeur sur la mthode ou "NULL" si la mthode n'existe pas
	 */
	Methode*	possedeMethode( Methode *m );

	/** Cette mthode permet de vrifier si un attribut existe dans cette classe.
	 * \param Attribut *a : La mthode  vrifier
	 * \return un pointeur sur l'attribut ou "NULL" si la mthode n'existe pas
	 */
	Attribut*	possedeAttribut( Attribut *a );

	/** Cette mthode permet de vrifier l'existenced'un attribut d'une classe.
	 * \param const string &nom : nom de l'attribut qui doit tre compar
	 * \param const string &visible : visibilit de l'attribut (public, private, protected)
	 * \param const string &type : type de l'attribut dclar
	 * \return retourne la reference de l'attribut s'il existe et "NULL" sinon
	 */
	Attribut * verifierExistenceAttribut(const string &nom, const string &visible, const string &type);

	/** Cette mthode permet de visiter les relations de cette classe.
	 * \param VisiteurNoeud *v : Le visiteur implment par l'utilisateur de cette classe
	 */
	void 		visiterRelation(VisiteurNoeud *v);

	/** Cette mthode permet de vrifier si un attribut existe dans cette classe.
	 * \param Relation *r : La relation  vrifier
	 * \return un pointeur sur l'attribut ou "NULL" si la relation n'existe pas
	 */
	Relation*	possedeRelation( Relation *r );
	
	/** Cette mthode permet de vrifier l'existence d'une mthode.
	 * \param Classe *source : Le nom de la classe d'origine de la relation
	 * \param Classe *destination : Le nom de la classe d'arriv de la relation
	 * \param int r : entier dfinissant le type de relation
	 * \return retourne "true" si la relation existe "false" sinon
	 */
	bool		verifierExistenceRelation(Relation *rel, int r);

	/** Cette mthode permet de visiter les fils du noeud classe.
	 * \param VisiteurNoeud *v : Le visiteur implment par l'utilisateur de cette classe
	 */
	void 		visiterFils(VisiteurNoeud* v);
	
	/**Cette mthode permet de rcuprer le vecteur de relation d'une classe
	* \return le vecteur des relations de la classe
	*/
	std::vector<Relation *> getVctRelation();
	
	/**Cette mthode permet de rcuprer le vecteur de mthode d'une classe
	* \return le vecteur des mthodes de la classe
	*/
	std::vector<Methode *> getVctMethode();
	
	/**Cette mthode permet de rcuprer le vecteur d'attribut d'une classe
	* \return le vecteur des attributs de la classe
	*/
	std::vector<Attribut *> getVctAttribut();
	
	/**
	 * Ajouter une relation  la classe destination  partir de la classe source.
	 * \param Classe *dest : classe cible de la relation  ajouter
	 * \param relation *r : la relation  ajouter. 
	 */
	void	ajouterRelationExterieure( Classe *dest, Relation *r );

	/**
	 * Cette fonction met  jour le vecteur de relation. Ceci lors l'ajout d'une relation
	 *  la classe destination  partir d'une classe source.
	 * \param std::vector<Relation*> r : vector de relation remplaant l'ancien
	 */
	void	setVctRelation( std::vector<Relation*> r );
	
	/** Cette fonction permet de connatre la visibilit de la classe
	* \return elle retourne un chane de caractres contenant la visibilit
	*/
	string getVisibilite();

	/** Cette mthode permet de fixer la visibilit de la classe
	* \param string visibilite : cahne contenant la visibilite
	*/
	void setVisibilite(const string &visibilite);

	/**
	 * Cette mthode permet de changer le type d'une classe.
	 * \param bool b : true si c'est une classe et false si c'est une interface
	 */
	void setTypeDeClasse( bool b );

	/**
	 * Cette mthode permet de savoir si une classe est une interface ou 
	 * une classe.
	 * \return elle retourne un boolen qui vaut "true" si c'est une classe et "false" sinon
	 */
	bool getTypeDeClasse( );
};
#endif
