/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:34 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:34 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noycommentaire.h                            */
/************************************************/

#ifndef NOYCOMMENTAIRE_H
#define NOYCOMMENTAIRE_H

#include <iostream>
#include <string>

#include <noyelementdemodelisation.h>

/** Cette classe reprsente un commentaire purement graphique
* @author clucas-ndouay
*/

class Commentaire:public ElementDeModelisation {

	private:
		//! chane contenant le texte du commnetaire
		string	_commentaire ;
		//! vecteur de relation commentaire 
		std::vector<RelationCommentaire *> vctRelCom;

	public:
		/** Constructeur
		* \param constr string & c : texte du commentaire
		*/
		Commentaire( const string & c );
		//! Destructeur
		virtual ~Commentaire();

		/**
		 * accepter un visiteur
		 */
		void accepter( VisiteurNoeud *v );		

		/** Cette mthode permet de fixer le contenu du commentaire
		* \param constr string & c : texte du commentaire
		*/
		void setCommentaire( const string & c );
		
		/** Cette fonction permet de rcuprer le contenu du commentaire
		* \return Elle retourne une chane de caractres contenant le texte
		*/
		string getCommentaire( ) ;

		/**Cette mthode permet d'ajouter une nouvelle relation commentaire au commentaire
		* \param const string &nom : nom de la relation
		* \param Noeud * noeud : cible de la relation
		* \return le retour est "true"  si la relation a bien t ajout et "false" sinon
		*/
		bool ajouterRelationCommentaire( const string &nom, Noeud * noeud );

		/** Cette fonction permet de supprimer une relation commentaire
		* \param RelationCommentaire *r : pointeur sur la relation  supprimer
		*/
		void supprimerRelationCommentaire(RelationCommentaire *r);
		
		/** Cette mthode permet de rcuprer le vecteur de relation commentaire
		* \return Elle retourne un vecteur de type "RelationCommentaire *"
		*/
		std::vector<RelationCommentaire *> getvctRelCom();
		
		/** Cette mthode permet de fixer le contenu du vecteur de relation commentaire
		* \param std::vector<RelationCommentaire *> v : vecteur de relation commentaire
		*/
		void setvctRelCom(std::vector<RelationCommentaire *> v);
};
#endif
