/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noydiagrammestatique.cpp                            */
/************************************************/

#include <noydiagrammestatique.h>
#include <noypaquetage.h>
#include <noyclasse.h>

DiagrammeStatique::DiagrammeStatique(Noeud* pere,const string &nom):Noeud(pere,nom) {}

DiagrammeStatique::~DiagrammeStatique() {}

void DiagrammeStatique::accepter(VisiteurNoeud* v)
{
	v->traiterDiagrammeStatique(this);
}

bool DiagrammeStatique::ajouterVue( const string & v)
{
	return ajouterVue( new Vue( getPere() , v ) );
}

bool DiagrammeStatique::ajouterVue(Vue *v)
{
	std::vector<Vue*>::iterator it;
	it=vctVue.begin();
	while((it != vctVue.end()) ){
		if( (*it)->getNom() == v->getNom() ) {
			return false ;
		}
		++it;
	}
	vctVue.push_back(v);
return true;
}
bool DiagrammeStatique::supprimerVue(Vue *v)
{
	std::vector<Vue*>::iterator it;
	it=vctVue.begin();
	while((it != vctVue.end()) ){
		if( *it == v ) {
			vctVue.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}

void DiagrammeStatique::visiterVue(VisiteurNoeud *v)
{
	std::vector<Vue*>::iterator it;
	it=vctVue.begin();
	while(it != vctVue.end()){
		((Vue *)*it)->accepter(v);
		++it;
	}
}
	
bool DiagrammeStatique::ajouterPaquetage( const string & nom )
{
	bool		retval ;
	Paquetage 	*p = new Paquetage( this , nom );
	
	retval = ajouterObjetuml((Objetuml *) p );

return retval ;
}

bool DiagrammeStatique::supprimerPaquetage(Paquetage *p)
{
	bool		retval ;
	
	retval = supprimerObjetuml( p );

return retval ;
}

bool DiagrammeStatique::ajouterClasse( const string & nom ,const string &visibilite)
{
	bool		retval ;
	Classe 		*c = new Classe( this , nom ,visibilite, true );
	
	retval = ajouterObjetuml( (Objetuml *)c );

return retval ;
}

bool DiagrammeStatique::supprimerClasse( Classe *c )
{
	bool		retval ;
	
	retval = supprimerObjetuml( c );

return retval ;
}
/*
void DiagrammeStatique::visiterPaquetage(VisiteurNoeud *v)
{
	std::vector<Objetuml*>::iterator it;
	it=vctObjetuml.begin();
	while(it != vctObjetuml.end() ){
		((Paquetage *)*it)->accepter(v);
		++it;
	}

}

void		visiterClasse(VisiteurNoeud *v)
{
	
}
*/
void DiagrammeStatique::visiterObjetuml(VisiteurNoeud *v)
{
	std::vector<Objetuml*> vctOb;
	std::vector<Objetuml*>::iterator it;
	vctOb = getVctObjetuml();
	it = vctOb.begin();
	while (it != vctOb.end())
	{
		(*it)->accepter(v);
		++it;
	}
		
}

void DiagrammeStatique::visiterFils(VisiteurNoeud *v)
{
	visiterObjetuml(v);
	visiterVue(v);
}

int DiagrammeStatique::NbVue()
{
	return vctVue.size();
}

int DiagrammeStatique::NbObjetuml()
{
	return vctObjetuml.size();
}


Vue* DiagrammeStatique::possedeVue( const string & v )
{
	std::vector<Vue*>::iterator it;
	it=vctVue.begin();
	while((it != vctVue.end()) ) {
		if( (*it)->getNom() == v ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

Vue* DiagrammeStatique::possedeVue( Vue *v )
{
	std::vector<Vue*>::iterator it;
	it=vctVue.begin();
	while((it != vctVue.end()) ) {
		if( (*it)->getNom() == v->getNom() ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

bool DiagrammeStatique::ajouterObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			return false ;
		}
	++it;
	}
vctObjetuml.push_back(ob);
return true;
}

bool DiagrammeStatique::supprimerObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			// On vire l'objet du vecteur de paquetages
			vctObjetuml.erase(it); 
			// tuer sa descendance...
			delete ob;

			return true ;
		}
		++it;
	}
return false ;
}

bool DiagrammeStatique::enleverObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			// On vire l'objet du vecteur de paquetages
			vctObjetuml.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}


std::vector<Objetuml *> DiagrammeStatique::getVctObjetuml()
{

	return vctObjetuml;
}


std::vector<Vue *> DiagrammeStatique::getVctVue()
{
	return vctVue;
}


/*
Paquetage* DiagrammeStatique::possedePaquetage( const string & v )
{
	std::vector<Paquetage*>::iterator it;
	it=vctPaquetage.begin();
	while((it != vctPaquetage.end()) && ((*it)->getNom() != v ))
	{
		++it;
	}
	if (it == vctPaquetage.end()){
		return NULL;
	} else return *it;

}

Paquetage* DiagrammeStatique::possedePaquetage( Paquetage *p )
{
	std::vector<Paquetage*>::iterator it;
	it=vctPaquetage.begin();
	while((it != vctPaquetage.end()) && ((*it)->getNom() != p->getNom() ))
	{
		++it;
	}
	if (it == vctPaquetage.end()){
		return NULL;
	} else return *it;
}
*/

bool	DiagrammeStatique::ajouterInterface( const string & nom, const string &visibilite)
{
	bool		retval ;
	Classe 		*c = new Classe( this , nom ,visibilite, false );
	
	retval = ajouterObjetuml( (Objetuml *)c );
return retval ;
}
	
bool	DiagrammeStatique::supprimerInterface( Classe *c )
{
	bool		retval ;
	
	retval = supprimerObjetuml( c );
return retval ;
}
