/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noymethode.h                            */
/************************************************/

#ifndef NOYMETHODE_H
#define NOYMETHODE_H
#include <iostream>
#include <noyelementdemodelisation.h>
#include <noyparametre.h>
#include <vector.h>

/**
 * Cette classe a pour but de reprsenter une mthode d'une classe.
 * @author clucas - ndouay
 */
class Methode:public Noeud{

private:
	//! la liste des paramtres de la mthode
	std::vector<Parametre*> vctParametre;
	//! la visibilit de la mthode
	string _visible;
	//! le type de retour de la mthode
	string _typeRetour;
	//! code
	string _code ;

public:
	
	/**constructeur
	* \param Noeud* pere : pointeur sur le noeud pre de la mthode
	* \param const string &nom : chane de caractres donne par l'utilisateur pour le nom de la mthode
	* \param const string &visible : chane de caractres repsantant la visibilit
	* \param const string &typeRetour : chane de caractres reprsentant le type de retour
	*/
	Methode(Noeud *pere,const string &nom,const string &visible,const string &typeRetour);
	
	/**Destructeur d'une mthode.
	*/
	virtual ~Methode();
	
	/**Cette mthode ajoute un paramtre dans la liste des paramtres d'une mthode.
	* \param Parametre* p : pointeur sur le parametre  ajouter
	* \return Elle retourne "true" si le paramtre est correctement ajout et "false" sinon
	*/
	bool ajouterParametre(Parametre* p); 	//true = OK; false = parametre existant
	
	/**Cette mthode fait l'inverse de la prcdente.
	* \param Paramtre *p : pointeur sur le paramtre  supprimer
	* \return le retour est "true" si le paramtre est supprim et "false" sinon
	*/
	bool supprimerParametre(Parametre *p);	//true = OK; false = parametre inexistant

	/**Cette fonction permet rcuprer le prototype d'une fonction en format court,
	* c'est  dire <+|-|#> <nom> (+ :public, - :private, # :protected).
	* Cette fonction est utilise par l'IHM.
	* \return le prototype est contenu dans dans une chane de caractres
	*/
	string petiteChaine();	//retourne le nom de la fonction en format court
	
	/**Cette fonction fait comme la prcdente sauf que le format de retour est long,
	* c'est  dire <visibilit> <type de retour> <nom de la mthode> <liste de paramtre> .
	* Cette fonction est surtout utile  l'IHM.
	* \return le prototype est contenu dans une chane de caractres
	*/
	string grandeChaine();	//retourne le nom de la fonction en format long

	/**Cette fonction fixe la visibilit d'une fonction dfinie par l'utilisateur
	* \param string visible : chane de caractres repsentant la visibilit 
	* de la mthode dfinie par l'utilisateur 
	*/
	void setVisible(const string &visible);
	
	/**Cette fonction fixe le type de retour d'une fonction dfinie par l'utilisateur
	* \param string TypeRetour : chane de caractres repsentant le type de retour 
	* de la mthode dfinie par l'utilisateur 
	*/
	void setTypeRetour(const string &typeRetour);
	
	/**Cette fonction permet de connatre la visibilit d'une mthode:
	* 	-public
	*	 -protected
	* 	-private
	* \return le retour se fait dans une chane de caractres
	*/
	string getVisible();
	
	/**Cette mthode permet de rcuprer le type de retour d'une mthode
	* \return le type est renvoy dans une chane de caractres
	*/
	string getTypeRetour();

	/**Cette fonction permet de faire une copie du vecteur de paramtres
	* \param std::vector<Parametre*> & v : clone du vecteur de paramtres
	*/
	void cloneVctParametre( std::vector<Parametre*> & v ); 
	
	/** Cette fonction permet d'accepter un visiteur
	* \param VisiteurNoeud *v : visiteur  accepter
	*/
	void accepter(VisiteurNoeud *v);
	
	/**
	 * Cette mthode permet de stocker et de fixer le code de cette mthode.
	 * \param chaine de caractre reprsentant le code
	 */
	void	setCode( const string& code );

	/** Cette mthode permet de rcuprer le code d'une mthode
	* \return une de chane de caractre reprsentant le code
	*/
	string getCode();
};
#endif
