/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:37 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:37 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noynoeud.h                            */
/************************************************/

#ifndef NOYNOEUD_H
#define NOYNOEUD_H
#include <iostream>
#include <string>
#include <noyvisiteurnoeud.h>
#include <noycommun.h>
#include <noynoyau.h>

/**
 * Noeud de l'arbre dcrivant le projet.
 * @author clucas - ndouay
 * @brief Cette classe reprsente un noeud de l'arbre que le noyau compose pour hirarchis et contenir les donnes
 */
class Noeud {
private:
	//! le pre de ce noeud
	Noeud* _pere;
	//! le nom de ce noeud
	string _nom;
	//! identifiant statique de classe "noeud".
	static long	suivantID ;
	//! identifiant de l'objet noeud
	long ID ;
	//! description de l'objet
	string _description;
	
public:
	//! Constructeur
	Noeud(Noeud* pere,const string &nom);
	//! Desctructeur
	virtual ~Noeud();
	/**
	 * Cette mthode permet de recevoir un visiteur implment par 
	 * l'utilisateur de cette classe.
	 * @param VisiteurNoeud *v : instance de classe implment par l'utilisateur de cette classe
	 */
	virtual void accepter(VisiteurNoeud *v) = 0;

	//! Cette mthode permet de retourner le nom de cette classe
	virtual string getNom();
	//! Cette mthode permet de donner le nom d'un noeud
	virtual bool setNom(const string &nom);
	//! Cette classe permet de retourner le pre de ce noeud.
	virtual Noeud* getPere() ;
	//! Cette mthode permet de rcuprer le noyau afin de faire des notifier n'importe o dans l'arbre
	virtual Noyau* getNoyau();
	//! Cette mthode permet de changer le permet d'un objet
	virtual void setPere( Noeud *n );
	//! Cette mthode permet de rcuprer un identifiant
	virtual long	getId();
	//! Cette mthode permet de stocker une description
	virtual void setDescription(const string & desc);
	//! Cette mthode permet de rcuprer la description d'un objet
	virtual string getDescription();

};

#endif
