/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 12:17:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:48:30 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/*	  0.2 	Implmentation des mthodes :   */
/*				o sauvegarde()	*/
/*				o chargement()	*/
/************************************************/
/*      noynoyau.cpp                            */
/************************************************/

#include <iostream>

#include <noynoyau.h>
#include <noyclasse.h>
#include <noyprojet.h>
#include <vector>
#include "expexport.h"
#include "parparser.h"

Noyau::Noyau() 
{
	p = NULL ;	
}

Noyau::~Noyau() {}

void Noyau::abonner(Observateur* obs)
{
	vctObservateur.push_back(obs);
}

void Noyau::desabonner(Observateur* obs)
{
	std::vector<Observateur*>::iterator it; //iterateur sur la structure vecteur
	it=vctObservateur.begin();	//placement au dbut du vecteur
	while((it != vctObservateur.end()) ){//tant que non fin de vecteur
		if( *it == obs ) {
			vctObservateur.erase(it); 
		}
	++it;	//incrmentation de l'itrateur
	}
}

void Noyau::notifier()
{
	std::vector<Observateur*>::iterator it; //iterateur sur la structure vecteur
	Observateur *o;
	it=vctObservateur.begin();	//placement au dbut du vecteur
	while(it != vctObservateur.end()){//tant que non fin de vecteur
		o = *it;
		o->avertir();
		++it;	//incrmentation de l'itrateur
	}
}

Projet * Noyau::getProjet() {
	return p ;
}

void	Noyau::creerProjet( string nom, string auteur , string version, string commentaire)
{
	p = new Projet( nom , this );
	p->setAuteur( auteur );
	p->setVersion( version );
	p->setCommentaire( commentaire );
}

bool Noyau::sauvegarde(const string &path){
	
	bool b;
	s = new Stockage(this);
	//s->VisiterSauver(this);
	b = s->sauver(path);
	delete(s);
	return b;
}

bool Noyau::chargement(const string &path){
        bool b;
	s = new Stockage(this);
	b = s->charger(path);
	delete(s);	
        return b;
}

void Noyau::exporter( int type , const string &nom , const string &auteur , const string &chemin )
{
	ExpExport e( getProjet()->getDiagrammeStatique() , chemin );
	e.setCartouche( nom , auteur );
	e.remplir();
	if( type == EXP_CPP ) {
		e.getCpp( );
	} else {
		e.getJava( );
	}

}


void Noyau::importerCpp(vector<string> vctFichierSource)
{
  ParserCpp pcpp(this);
  pcpp.setFichierSource(vctFichierSource);
  pcpp.lancer();
}



void Noyau::importerJava(vector<string> vctFichierSource,vector<string> listeClassPath )
{
  
  vector<string>::iterator itClassPath;
  vector<string>::iterator itFichierSource = vctFichierSource.begin();
  string sFichierSource;
  
  ParserJava pjava(this);

  while(vctFichierSource.end() != itFichierSource) {
  	sFichierSource = "";
	itClassPath = listeClassPath.begin();
  	while((itClassPath != listeClassPath.end()) && (sFichierSource != ((string)*itClassPath))) {
		sFichierSource = string(((string)*itFichierSource).c_str(),((string)*itClassPath).size());
		cout << "debug:" << sFichierSource << endl;
		if(sFichierSource != ((string)*itClassPath))
			++itClassPath;
		}
		
	if(itClassPath == listeClassPath.end()) {
		cerr << "Le fichier " << *itFichierSource << " ne se trouve pas dans les sous repertoire de ClassPath. Il ne sera pas analys !" << endl;	
		vctFichierSource.erase(itFichierSource);
		}
	else {
		sFichierSource.assign((string)*itFichierSource,((string)*itClassPath).size(),((string)*itFichierSource).size());
		cout << "importerJava: le fichier " << sFichierSource << endl;
		*itFichierSource = sFichierSource;
		}
  	++itFichierSource;
  	}
  
  if(vctFichierSource.size() != 0) {
  	pjava.listeClassPath = listeClassPath;
  	pjava.setFichierSource(vctFichierSource);
  	pjava.lancer();
	}
 else cerr << "importerJava: Il n'y a pas de fichier a analyser" << endl;

  
}
