/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 12:18:03 CET 2002             */
/************************************************/
/*     mer fv 13 12:37:00 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration			*/
/*      0.2	Ajout d'une instance de stockage*/
/************************************************/
/*      noynoyau.h                              */
/************************************************/

#ifndef NOYNOYAU_H
#define NOYNOYAU_H
#include <iostream>
#include <string>
#include <vector.h>

#include <noyobservateur.h>
#include <noystockage.h>
class Projet ;

/** Cette classe est le coeur de cette partie. C'est elle qui cr le projet
* @author clucas-ndouay
*/
class Noyau{

private:
	//! pointeur sur le projet en cours
	Projet *p;
	//! vecteur d'observateur
	std::vector<Observateur*> vctObservateur;
	//! pointeur sur l'instance de stockage
	Stockage *s;

public:
	//! Constructeur
	Noyau();
	//! Destructeur
	virtual ~Noyau();
	
	/**Cette mthode permet d'abonner un lment au noyau
	* \param Observateur* obs : pointeur sur l'objet  abonner
	*/
	void abonner(Observateur* obs);
	
	//! Cette mthode fait l'inverse de la prcdente avec le mme type de paramtre
	void desabonner(Observateur* obs);
	
	/** Cette mthode permet de rafraichir les parties de l'IHM lorsq'un changement est survenu
	* Elle est implmente dans le noyau, mais utilise dans l'IHM
	*/
	void notifier();

	/** Cette mthode permet de crer un nouveau projet
	* \param string nom : nom du projet
	* \param string auteur : auteur(s) du projet
	* \param string version : version du projet
	* \param string commentaire : commentaire(s) dur le projet
	*/
	void	creerProjet( string nom, string auteur , string version, string commentaire);
	
	/** Cette fonction permet de retourner un pointeur sur le projet en cours
	* \return elle retourne un pointeur sur un bojet de type "Projet"
	*/
	Projet *getProjet();
	
	/** Cette fonction permet de retourner un pointeur sur le projet en cours
	* \return elle retourne un pointeur sur un bojet de type "Projet"
	*/
	void setProjet(Projet *pro){p = pro;}

	/** Cette mthode permet de lancer la sauvegarde
	* \param const string &path : nom du fichier de sauvegarde
	*/
	bool sauvegarde( const string &path);

	/** Cette mthode permet de lancer le chargement
	* \param const string &path : nom du fichier de sauvegarde
	* \return si le chargement s'est bien droul
	*/
	bool chargement( const string &path);

	/**
	 * Cette mthode permet d'appeler l'exportateur en lui donnant les paramtres dont il a besoin.
	 * 
	 */
	void exporter( int type , const string &nom , const string &auteur , const string &chemin  );
	
	/**
	 * Cette mthode permet d'appeler l'importateur Cpp en lui donnant les paramtres dont il a besoin.
	 * 
	 */
	void importerCpp(vector<string> vctFichierSource );

	/**
	 * Cette mthode permet d'appeler l'importateur Java en lui donnant les paramtres dont il a besoin.
	 * 
	 */
	void importerJava(vector<string> vctFichierSource, vector<string> listeClassPath);
};
#endif
