/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/*	  0.2	 Mise  jour de doxygen		  */
/************************************************/
/*      noyobjetaffichable.h                    */
/************************************************/

#ifndef NOYOBJETAFFICHABLE_H
#define NOYOBJETAFFICHABLE_H
#include <iostream>
#include <noyobjetuml.h>
#include <noyelementdemodelisation.h>

/** Cette classe reprsente des objets affichables au sens graphique du terme
* @author clucas-ndouay
*/
class ObjetAffichable:public Noeud{

private:
	//! pointeur sur l'objet affichable
	ElementDeModelisation	*_edm ;
	//! position de l'objet en abscisse
	int			_x ;
	//! position de 'objet en ordonne
	int			_y ;
	//! largeur de l'objet
	int			_largeur ;
	//! auteur de l'objet
	int			_hauteur ;
	//! visibilit de l'objet au sens graphisue du terme
	bool			_visible ;

public:
	//! Constructeur par dfaut
	ObjetAffichable(ElementDeModelisation	*edm);
	
	/** Constructeur d'un objet affichable
	* \param ElementDeModelisation	*edm : pointeur sur l'objet  afficher
	* \param int x : abscisse de l'objet
	* \param int y : ordonne de l'objet
	* \param int largeur : largeur de l'objet
	* \param int hauteur : hauteur de l'objet
	* \param bool visible : l'objet est-il visible ou non
	*/
	ObjetAffichable(ElementDeModelisation	*edm, int x, int y, int largeur, int hauteur, bool visible ,Noeud *n);
	
	/**
	 *
	 */
	void 	accepter(VisiteurNoeud* v); 

	/** Cette fonction permet de modifier les coordonnes d'un objet
	* \param int x : nouvelle abscisse
	* \param int y : nouvelle ordonne
	*/
	void modifierCoordonnees( int x , int y );
	
	/** Cette fonction permet de modifier la taille d'un objet
	* \param int x : nouvelle largeur
	* \param int y : nouvelle hauteur
	*/
	void modifierDimension( int x , int y );
	
	/** Cette fonction permet de modifier la visibilit d'un objet
	* \param bool v : nouvelle visibilit
	*/
	void modifierVisibilite( bool v );	
	
	//! Destructeur d'un objet affichable
	virtual ~ObjetAffichable();

	/** Cette fonction permet de retourner un pointeur sur l'objet affich
	* \return elle retourne un pointeur de type "ElementDeModelisation"
	*/
	ElementDeModelisation*	getedm();	

	/** Cette mthode permet connatre l'abscisse de l'objet
	* \return elle retourne un entier reprsentant l'abscisse
	*/
	int	getX();
	
	/** Cette mthode permet connatre l'ordonne de l'objet
	* \return elle retourne un entier reprsentant l'ordonne
	*/
	int	getY();
	
	/** Cette mthode permet connatre la largeur de l'objet
	* \return elle retourne un entier reprsentant la largeur
	*/
	int	getLargeur();
	
	/** Cette mthode permet connatre la hauteur de l'objet
	* \return elle retourne un entier reprsentant la hauteur
	*/
	int	getHauteur();
	
	/** Cette mthode permet connatre la visibilit de l'objet
	* \return elle retourne un booleen qui vaut "true" si l'objet est visible
	*/
	bool	getVisible();
};
#endif
