/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyobjetuml.h                           */
/************************************************/

#ifndef NOYOBJETUML_H
#define NOYOBJETUML_H
#include <iostream>

#include <noyelementdemodelisation.h>
#include <noyobjetuml.h>

/** Cette classe dcrit un objet UML au sens large
* un objet UML pouvant tre un paquetage ou une classe
* @author clucas-ndouay
*/
class Objetuml:public ElementDeModelisation{

public:
	
	/** Constructeur
	* \param Noeud* pere : pointeur sur le noeud pre
	* \param const string &nom : nom don  l'objet UML
	*/
	Objetuml(Noeud* pere,const string &nom);
	//!: Destructeur
	virtual ~Objetuml();
	
	/** Cette mthode permet d'accepter un visiteur
	* \param VisiteurNoeud* v : visiteur  accepter
	*/
	virtual void accepter(VisiteurNoeud* v);

	/** Cette mthode permet de rcuprer le nom complet d'un objet UML.
	* C'est  dire pour un paquetage B contenu dans un paquetage A on aura:
	* 		A::B 
	* \return elle retourne une chane de carctre comme dfinie ci-dessus
	*/
	string getNomComplet();

	/**
	 * Cette mthode permet de mettre  jour le nom d'un Objetuml
	 * Une vrification est effectue.
	 * \param nom : le nom que l'on veut donner  cet objet.
	 * \return true si c'est ok sinon il existe dj un objet de mme nom
	 */
	virtual bool setNom( const string & nom );	

	/**
	 * Cette mthode permet de dplacer un objetuml directement
	 * dans un diagramme statique
	 * \param le noeud du diagramme statique, bien que je pourrais me dbrouiller autrement
	 */
	void	deplacerVersDiagrammeStatique( Noeud *n );

	/**
	 * Cette mthode permet de dplacer un objetuml vers un paquetage
	 * \param Le paquetage dans lequel on veut dplacer l'objet
	 */
	void	deplacerVersPaquetage( Paquetage *p );

};
#endif
