/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noypaquetage.h                          */
/************************************************/

#ifndef NOYPAQUETAGE_H
#define NOYPAQUETAGE_H
#include <iostream>
#include <vector.h>

#include <noyobjetuml.h>

/**Cette classe a pour but de modliser un paquetage au sens UML du terme
* @author clucas - ndouay
*/
class Paquetage:public Objetuml{

private:
	//! vecteur d'objet uml
	std::vector<Objetuml*> vctObjetuml;

public:

	/**Constructeur
	*/
	Paquetage(Noeud* pere,const string &nom);
	
	/**Destructeur
	*/
	virtual ~Paquetage();
	
	/**Mthode permettant d'accepter un visiteur afin de parcourir le contenu du paquetage
	* \param VisiteurNoeud* v : pointeur sur le visiteur  accepter
	*/
	virtual void 	accepter(VisiteurNoeud* v);
	
	/**Cette mthode permet d'ajouter un objet UML au paquetage, c'est  dire une classe ou un paquetage
	* \param Objetuml* ob : pointeur sur l'objet  ajouter au paquetage
	* \return la fonction retourne "true" si l'objet est bien ajout et "false" sinon
	*/
	bool	 	ajouterObjetuml(Objetuml* ob);
	
	/**Cette mthode fait le contraire de la prcdente
	* \param Objetuml* ob : pointeur sur l'objet  supprimer du paquetage
	* \return la fonction retourne "true " si l'objet est supprim et "false" sinon
	*/
	bool 		supprimerObjetuml(Objetuml* ob);

	/**
	 * Cette mthode permet d'enlever un objetuml du vecteur d'objet
	 * \param l'objet que l'on souhaite supprimer.
	 */
	bool	 	enleverObjetuml(Objetuml* ob);

	/**Cette mthode permet de visiter un vecteur d'Objetuml afin de pouvoir les parcourir
	* \param VisiteurNoeud* v : pointeur sur le visiteur qui parcourt l'arborescence
	*/
	void 		visiterObjetuml(VisiteurNoeud* v);
	
	/**Cette mthode permet de vrifier l'appartenance d'un objet au paquetage
	* \param Objetuml *o : pointeur sur l'objet recherch
	* \return la fonction retourne un pointeur sur l'objet cherch
	*/
	Objetuml*	possedeObjetuml( Objetuml *o );	 

	/** Cette mthode permet de rcuprer le vecteur d' objets UML
	 * \return elle retourne le vecteur d' objets UML du diagramme statique
	 */
	std::vector<Objetuml *> getVctObjetuml();
};
#endif
