/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:41 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:41 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyrelation.h                           */
/************************************************/

#ifndef NOYRELATION_H
#define NOYRELATION_H
#include <iostream>

#include <noyelementdemodelisation.h>

class Classe;

/** Cette classe dfinie une relation au sens uml et large du terme
* @author clucas-ndouay
*/
class Relation:public ElementDeModelisation{
	// une relation est definie dans la classe source
private:
	//! pointeur sur la classe source
	Classe	*_clSource ;
	//! pointeur sur la classe de destination
	Classe	*_clDestination ;
	//! chane de caractres reprsentant la multiplicit de la source de la relation (ex 0..n)
	string	_multipliciteSource;
	//! chane de caractres reprsentant la multiplicit de la destination de la relation (ex 0..n)
	string	_multipliciteDestination;

	bool _doubleFleche;

public:
	//!Constructeur 
	Relation(Noeud *pere , const string &nom);

	/**Cette mthode est le constructeur d'une relation
	* \param Noeud *pere : pointeur sur un objet de type noeud representant l'objet pre de l'agregation
	* \param const string &nom : nom donn  la relation (elle peut ne pas en avoir)
	* \param Classe *source : pointeur sur un objet de type classe designant l'origine de la relation
	* \param Classe *destination : pointeur sur un objet de type classe designant la classe pointe par la relation
	* \param const string &multipliciteSource : chane de caractres reprsentant la multiplicit de la source de la relation
	* \param const string &multipliciteDestination : chane de caractres reprsentant la multiplicit de la destination de la relation
	*/
	Relation(Noeud *pere , const string &nom , Classe *source, Classe *destination, const string &multipliciteSource, const string &multipliciteDestination, bool doubleFleche = true );
	


	//!Destructeur
	virtual ~Relation();
	
	/** Cette mthode permet d'accepter un visiteur
	* \param VisiteurNoeud* v : pointeur sur le visiteur  accepter
	*/
	virtual void accepter(VisiteurNoeud* v);
	
	/** Cette mthode permet de fixer la classe de destination d'une relation 
	* \param Classe *destination : pointeur sur la classe cible de la relation
	*/
	void setClasseDestination( Classe *destination );
	
	/** Cette mthode permet de connatre la classe destination de la relation
	* \return elle retourne un pointeur sur la classe pointe par la relation
	*/
	Classe* getClasseDestination( );
	
	/** Cette mthode permet de fixer la classe source d'une relation 
	* \param Classe *destination : pointeur sur la classe source de la relation
	*/
	void setClasseSource(Classe *source);
	
	/** Cette mthode permet de connatre la classe source de la relation
	* \return elle retourne un pointeur sur la classe d'origine de la relation
	*/
	Classe* getClasseSource();
	
	/** Cette mthode permet de fixer la multiplicit d'une relation  la source de celle-ci
	* \param string multipliciteSource : chane de caractres contenant la multiplicit (ex: 0..n)
	*/
	void	setMultipliciteSource( string multipliciteSource );
	
	/** Cette mthode permet de fixer la multiplicit du cot de la classe de destination d'une relation 
	* \param string multipliciteSource : chane de caractres contenant la multiplicit (ex: 0..n)
	*/
	void	setMultipliciteDestination( string multipliciteDestination ); 
	
	/** Cette mthode permet de rcuprer la multiplicit  la source d'une relation
	* \return une chane contenant la multiplicit
	*/
	string	getMultipliciteSource( );
	
	/** Cette mthode permet de rcuprer la multiplicit de la destination d'une relation
	* \return une chane contenant la multiplicit
	*/
	string	getMultipliciteDestination( );

        void setDoubleFleche( bool doubleFleche );

	bool getDoubleFleche( );
};
#endif
