/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:42 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:42 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyrelationcommentaire.h                            */
/************************************************/

#ifndef NOYRELATIONCOMMENTAIRE_H
#define NOYRELATIONCOMMENTAIRE_H
#include <iostream>
#include <string>

#include <noynoeud.h>
#include <noyvisiteurnoeud.h>
#include <noycommentaire.h>
#include <noyelementdemodelisation.h>
#include <noymethode.h>
#include <noyattribut.h>

/** Cette classe dfinit le lien entre un commentaire et sa cible
* on parle donc de relation de type commentaire
* @author clucas-ndouay
*/

class RelationCommentaire:public Noeud{

private:
	
	//! pointeur de type Commentaire sur la source de la relation
	Commentaire * _commentaire;

	//! pointeur sur le noeud destination de la relation
	Noeud * _noeud ;

public:
	
	/** Constructeur pour le lments de modlisation
	* \param Noeud *pere : pointeur sur le pre de la relation
	* \param Commentaire *c : pointeur sur le commentaire source de la relation
	* \param Noeud * n : pointeur sur l'lment destination de la relation
	*/
	RelationCommentaire(Noeud *pere, const string &nom,Commentaire *c, Noeud * n);
	//! Destructeur
	virtual ~RelationCommentaire();
	
	/** Cette mthode permet d'accepter un visiteur
	* \param VisiteurNoeud *v : pointeur sur le visiteur  accepter
	*/
	virtual void accepter(VisiteurNoeud *v);
	
	/** Cette mthode permet de rcuprer le commentaire source de la relation
	* \return elle retourne un pointeur sur le commentaire
	*/
	Commentaire * getCommentaire();
	
	/** Cette mthode permet de rcuprer l'lment de destination de la relation
	* \return elle retourne un pointeur sur l'lment pointe par la relation
	*/
	Noeud * getNoeud();
};
#endif
