/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 12:17:47 CET 2002             */
/************************************************/
/*     mer fv 13 12:17:47 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noystockage.cpp                         */
/************************************************/

#include <noystockage.h>
#include <noyvisiteurnoeud.h>
#include <noyprojet.h>
#include <noyusecase.h>
#include <noycollaboration.h>
#include <noydiagrammestatique.h>
#include <noyvue.h>
#include <noyclasse.h>
#include <noypaquetage.h>
#include <noyobjetuml.h>
#include <noyattribut.h>
#include <noymethode.h>
#include <noyrelation.h>
#include <noyheritage.h>
#include <noyassociation.h>
#include <noyagregation.h>
#include <noyutilisation.h>
#include <noyrelationcommentaire.h>
#include <noycommentaire.h>
#include <noycharger.h>

#include <qfile.h>
#include <qxml.h>

Stockage::Stockage(Noyau *n){
	noy = n;
}

Stockage::~Stockage() {}

/** Cette classe va servir  recoder les fonctions traiterXXX()
*/
class VisiteurSauver:public VisiteurNoeud{
	
public:
	//! Instance du noyau
	Noyau *noy;
	//! flux de sauvegarde
	ofstream f;
	//! nom du fichier de sauvegarde
	string path;
	//! variable qui permet l'indentation de la sauvegarde
	string indent;
	
	bool	reussite ;
	
	/** Constructeur du visiteur
	* \param Noyau *n : pointeur sur le noyau en mmoire
	* \param const string & nom : nom du fichier de sauvegarde
	*/
	VisiteurSauver(Noyau *n,const string & nom){
		noy = n;
		path = nom;
		indent = "" ;
		reussite = true  ;
	}

	virtual ~VisiteurSauver(){}
	
	/** fonction qui lance le dbut de la sauvegarde
	* \param Stockage *s : pointeur de stockage
	*/
	void traiterStockage(Stockage *s){
		Projet *pro;
		
		pro = noy->getProjet();
		f.open (path.c_str(),ios::out); 
		if ( !f.is_open() ) { reussite = false ; return ; }
			
		f << "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" << endl;
		f << "<!DOCTYPE gnumlDTD SYSTEM \"gnuml.dtd\">" << endl;
		pro->accepter(this);
		f.close();
	}
	
	void traiterProjet(Projet *p){
		
		UseCase *use;
		Collaboration *col;
		DiagrammeStatique *diag;
		
		use = p->getUseCase();
		col = p->getCollaboration();
		diag = p->getDiagrammeStatique();
		
		f << "<projet nom=\"" << p->getNom() << "\" auteur=\"" << p->getAuteur() << "\" version=\"" << p->getVersion() << "\" commentaire=\"" << p->getCommentaire() << "\">" << endl;
		indent += "    " ;
		use->accepter(this);
		col->accepter(this);
		diag->accepter(this);
		indent.erase(indent.size()-4,4);
		f << "</projet>" << endl;
	}
	
	void traiterUseCase(UseCase *u){
		
		f << indent + "<usecase nom=\"" << u->getNom() << "\"></usecase>" << endl;
	}
	
	void traiterCollaboration(Collaboration *c){
		f << indent + "<collaboration nom=\"" << c->getNom() << "\"></collaboration>" << endl;
	}
	
	void traiterDiagrammeStatique(DiagrammeStatique *d){
		


		std::vector<Vue *> vctvue;
		std::vector<Objetuml *> vctobj;
		std::vector<Vue *>::iterator itvue;
		std::vector<Objetuml *>::iterator itobj;
		
		vctvue = d->getVctVue();
		vctobj = d->getVctObjetuml();
		itvue = vctvue.begin();
		itobj = vctobj.begin();
		
		f << indent + "<diagrammestatique nom=\"" << d->getNom() << "\">" << endl;
		indent += "    " ;
		while (itobj != vctobj.end()){
			(*itobj)->accepter(this);
			++itobj;
		}

		while (itvue != vctvue.end()){
			(*itvue)->accepter(this);
			++itvue;
		}

		indent.erase(indent.size()-4,4);
		f << indent << "</diagrammestatique>" << endl;
	}
	
	void traiterVue(Vue *v){
		
		std::vector<ObjetAffichable *> vctobjaff;
		std::vector<ObjetAffichable *>::iterator itobjaff;
		f << indent << "<vue nom=\"" << v->getNom() << "\">" << endl;
		vctobjaff = v->getvctObjetAffichable();
		itobjaff = vctobjaff.begin();
		indent += string("    ");
		while (itobjaff != vctobjaff.end()){
			if((*itobjaff)->getedm()->getPere() != (Noeud *)v ) { 
				f << indent << "<objetaffichable id=\"" << (*itobjaff)->getedm()->getId() << 
					"\" x=\"" << (*itobjaff)->getX() << "\" y=\""<< (*itobjaff)->getY()<<
					"\" w=\"" << (*itobjaff)->getLargeur() << "\" h=\""<< (*itobjaff)->getHauteur()<<
					"\" visible=\"" << (*itobjaff)->getVisible() << "\"/>" <<endl;
			} else {
				std::vector<RelationCommentaire *> vctRelCom ;
				std::vector<RelationCommentaire *>::iterator it ;
				Commentaire *com = (Commentaire *)(*itobjaff)->getedm(); 
				vctRelCom = com->getvctRelCom( );
				it = vctRelCom.begin();

				f << indent << "<commentaire id=\"" << (*itobjaff)->getedm()->getId() << 
					"\" x=\"" << (*itobjaff)->getX() << "\" y=\""<< (*itobjaff)->getY()<<
					"\" w=\"" << (*itobjaff)->getLargeur() << "\" h=\""<< (*itobjaff)->getHauteur()<<
					"\" visible=\"" << (*itobjaff)->getVisible() << 
					"\" nom=\"" << (*itobjaff)->getedm()->getNom() <<
					"\" commentaire=\"" <<  ((Commentaire *)((*itobjaff)->getedm()))->getCommentaire() <<
					"\">" <<endl;

				indent += "    " ;
				while( it != vctRelCom.end() ) {
					(*it)->accepter( this );
				++ it ;
				}
				indent.erase(indent.size()-4,4);		
				f << indent << "</commentaire>" << endl;
				

			}
			++itobjaff;
		}	
		indent.erase(indent.size()-4,4);
		f << indent << "</vue>" << endl;
	}

	void traiterClasse(Classe *cl){
		
		std::vector<Attribut *> vcta;
		std::vector<Methode *> vctm;
		std::vector<Relation *> vctr;
		
		std::vector<Attribut *>::iterator ita;;
		std::vector<Methode *>::iterator itm;
		std::vector<Relation *>::iterator itr;
		
		vcta = cl->getVctAttribut();
		vctm = cl->getVctMethode();
		vctr = cl->getVctRelation();
		ita = vcta.begin();
		itm = vctm.begin();
		itr = vctr.begin();

		f << indent + "<classe nom=\"" << cl->getNom() << "\" id=\"" << cl->getId()
			<< "\" visibilite=\"" <<  cl->getVisibilite() 
			<<  "\" type=\"" << cl->getTypeDeClasse() 
			<<  "\" description=\"" << cl->getDescription() 
			<< "\">" << endl;
		indent += string("    ");
		while(ita != vcta.end()){
			(*ita)->accepter(this);
			++ita;
		}
		while(itm != vctm.end()){
			(*itm)->accepter(this);
			++itm;
		}
		while(itr != vctr.end()){
			(*itr)->accepter(this);
			++itr;
		}
		indent.erase(indent.size()-4,4);
		f << indent << "</classe>" << endl;
	}
	
	void traiterPaquetage(Paquetage *pa){
		
		std::vector<Objetuml*> vcto;
		std::vector<Objetuml*>::iterator ito;
		
		vcto = pa->getVctObjetuml();
		ito = vcto.begin();

		f << indent << "<paquetage nom=\"" << pa->getNom() << "\" id=\"" << pa->getId() << "\">" << endl;
		indent += string("    ");
		while (ito != vcto.end()){
			(*ito)->accepter(this);
			++ito;
		}
		indent.erase(indent.size()-4,4);
		f << indent << "</paquetage>" << endl;
	}

	void traiterAttribut(Attribut *a){
		f << indent << "<attribut nom=\"" << a->getNom() << "\" id=\"" << a->getId() 
		<< "\" visibilite=\"" 
		<< a->getVisible() << "\" type=\""  << a->getType()
		<< "\" description=\"" << a->getDescription()
		<< "\"/>" << endl;
		indent += string("    ");
		indent.erase(indent.size()-4,4);
	
	}
	
	void traiterMethode(Methode *m){
		
		std::vector<Parametre *> vctp;
		std::vector<Parametre *>::iterator itp;
		
		m->cloneVctParametre(vctp);
		itp = vctp.begin();
		f << indent << "<methode nom=\"" << m->getNom() <<  "\" id=\"" << m->getId() 
			<< "\" visibilite=\""
			<< m->getVisible() << "\" type=\"" << m->getTypeRetour() 
			<< "\" code=\"" <<  m->getCode() << "\" description=\"" << m->getDescription()
			<< "\">" << endl;
		indent += string("    ");
		while (itp != vctp.end()){
			f << indent << "<parametre type=\"" << (*itp)->getType() 
				<< "\" nom=\"" << (*itp)->getNom()<< "\"/>" << endl;
			++itp;
		}
		indent.erase(indent.size()-4,4);
		f << indent << "</methode>" << endl;
	}


	void traiterHeritage(Heritage *h ){
		f << indent << "<heritage nom=\"" << h->getNom() << "\" id=\"" << h->getId() 
			<< "\" source=\"" << h->getClasseSource()->getId()  
			<< "\" destination=\"" << h->getClasseDestination()->getId() 
			<< "\" multiplicitesource=\"" << h->getMultipliciteSource() 
			<< "\" multiplicitedestination=\"" << h->getMultipliciteSource() 
			<< "\" description=\"" << h->getDescription() 
			<< "\"/>" << endl ;
	}

	void traiterUtilisation(Utilisation *u){
		f << indent << "<utilisation nom=\"" << u->getNom() << "\" id=\"" << u->getId() 
			<< "\" source=\"" << u->getClasseSource()->getId()
			<< "\" destination=\"" << u->getClasseDestination()->getId() 
			<< "\" multiplicitesource=\"" << u->getMultipliciteSource() 
			<< "\" multiplicitedestination=\"" << u->getMultipliciteSource()
			<< "\" description=\"" << u->getDescription() 
			<< "\"/>" << endl ;
	}
	
	void traiterAssociation(Association *a){
		f << indent << "<association nom=\"" << a->getNom()  << "\" id=\"" << a->getId()
			<< "\" source=\"" << a->getClasseSource()->getId()
			<< "\" destination=\"" << a->getClasseDestination()->getId() 
			<< "\" multiplicitesource=\"" << a->getMultipliciteSource() 
			<< "\" multiplicitedestination=\"" << a->getMultipliciteSource()
			<< "\" description=\"" << a->getDescription() 
			<< "\"/>" << endl ;

	}
	
	void traiterAgregation(Agregation *a){
		f << indent << "<agregation nom=\"" << a->getNom() << "\" id=\"" << a->getId()
			<< "\" source=\"" << a->getClasseSource()->getId()
			<< "\" destination=\"" << a->getClasseDestination()->getId() 
			<< "\" multiplicitesource=\"" << a->getMultipliciteSource() 
			<< "\" multiplicitedestination=\"" << a->getMultipliciteSource()
			<< "\" description=\"" << a->getDescription() 
			<< "\"/>" << endl ;

	}

	void traiterRelationCommentaire( RelationCommentaire *r )
	{
		f << indent << "<rc nom=\"" << r->getNom() << "\" id=\"" << r->getId()
			<< "\" destination=\"" << r->getNoeud()->getId() 
			<< "\"/>" << endl ;

	}
};

void Stockage::accepter(VisiteurNoeud *v)
{
	v->traiterStockage(this);
}

bool Stockage::sauver(const string & path)
{
	bool b ;
	VisiteurSauver *vs = new VisiteurSauver(noy,path);
	accepter(vs);
	b = vs->reussite ;
	delete vs ;
	return b ;
}

bool Stockage::charger(const string & path)
{
        Charger		*handler = new Charger( noy );
	ErrorHandler	*errhandler = new ErrorHandler( );
        QFile xmlFile( path.c_str() );
        QXmlInputSource source( xmlFile );
        QXmlSimpleReader reader;
        reader.setContentHandler( handler );
	reader.setErrorHandler( errhandler );
	if( reader.parse( source ) == false ) {
		return false ;
	} else {
		cout << "avant majRelation " << endl;
		handler->majRelation( );
		handler->verif( );
	}
return true; 
}
