/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 12:18:06 CET 2002             */
/************************************************/
/*     mer fv 13 12:18:06 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/*	  0.2	 Ajout de traiterParametre	   */
/************************************************/
/*      noyvisiteurnoeud.h                      */
/************************************************/

#ifndef NOYVISITEURNOEUD_H
#define NOYVISITEURNOEUD_H
#include <iostream>

class Projet;
class UseCase;
class Collaboration;
class DiagrammeStatique;
class Vue;
class Classe;
class Paquetage;
class Objetuml;
class Attribut;
class Methode;
class Relation;
class Heritage ;
class Association;
class Agregation;
class Utilisation;
class RelationCommentaire;
class Commentaire;
class Stockage;
class Parametre;
class ObjetAffichable;

/**
 * Cette classe a pour but de permettre aux applications externes au noyau de
 * visiter simplement son arborescence.<br>
 * Pour l'utiliser, il suffit de rimplementer les fonctions qui vous
 * interesse, par exemple:<br>
 * Vous voulez affich toutes les classes et les sous paquetages d'un paquetage.
 * class MonVisiteur : public VisiteurNoeud {<br>
 * 	string s;
 * 	public:<br>
 * 		virtual void traiterPaquetage(Paquetage *p) {<br>
 * 			if(s == "") {<br>
 * 				s = p->getNom();<br>
 * 				}<br>
 * 			else<br>
 * 				{<br>
 * 				s+= "::" + " p->getNom();<br>
 * 				}<br>
 * 			p->visiterFils(this);<br>
 * 			}<br>
 * 		virtual void traiterClasse(Classe *c) { <br>
 * 			cout << s << c->getName();<br>
 * 			}<br>
 * 	}<br>
 *
 * Un autre exemple utilis dans l'obtention de getNomComplet:
 *class lVisiteur : public VisiteurNoeud {<br>
 *		public:<br>
 *			string nc;<br>
 *			void traiterPaquetage(Paquetage *p) {<br>
 *				nc = p->getNomComplet();<br>
 *				}<br>
 *			void traiterClasse(Classe *c) {<br>
 *				nc = c->getNomComplet();<br>
 *				}<br>
 *			void traiterDiagrammeStatique(DiagrammeStatique *dg) {<br>
 *				nc = "";<br>
 *				}<br>
 *			};<br>
 *<br>
 *string Objetuml::getNomComplet()<br>
 *{<br>
 *	lVisiteur lv;<br>
 *	getPere()->accepter(&lv);<br>
 *	if(lv.nc == string("")) {<br>
 *		return getNom();<br>
 *		}<br>
 *	else	{<br>
 *		string s;<br>
 *		s = lv.nc;<br>
 *		s += string("::");<br>
 *		s += getNom();<br>
 *		return s;<br>
 *		}<br>
 *}<br>
 */

class VisiteurNoeud{
public:
	//! Appel si le noeud visit est un Projet.
	virtual void traiterProjet(Projet *p) {}
	//! Appel si le noeud visit est un UseCase 
	virtual void traiterUseCase(UseCase *u) {}
	//! Appel si le noeud visit est un Collaboration.
	virtual void traiterCollaboration(Collaboration *c) {}
	//! Appel si le noeud visit est un DiagrammeStatique.
	virtual void traiterDiagrammeStatique(DiagrammeStatique *d) {}
	//! Appel si le noeud visit est un Vue.
	virtual void traiterVue(Vue *v) {}
	//! Appel si le noeud visit est un commentaire.
	virtual void traiterCommentaire(Commentaire *co) {}
	//! Appel si le noeud visit est une instance de Classe.
	virtual void traiterClasse(Classe *cl) {}
	//! Appel si le noeud visit est un Paquetage.
	virtual void traiterPaquetage(Paquetage *pa) {}
	//! Appel si le noeud visit est un Objetuml. 
	virtual void traiterObjetuml(Objetuml *o) {}
	//! Appel si le noeud visit est un attribut.	
	virtual void traiterAttribut(Attribut *a) {}
	//! Appel si le noeud visit est une methode. 
	virtual void traiterMethode(Methode *m) {}
	//! Appel si le noeud visit est une relation.
	virtual void traiterRelation(Relation *r) {}
	//! Appel si le noeud visit est un heritage.
	virtual void traiterHeritage(Heritage *h ){}
	//! Appel si le noeud visit est une utilisation.
	virtual void traiterUtilisation(Utilisation *u) {}
	//! Appel si le noeud visit est une association.
	virtual void traiterAssociation(Association *a) {}
	//! Appel si le noeud visit est une agrgation.
	virtual void traiterAgregation(Agregation *a) {}
	//! Appel si le noeud visit est un commentaire.
	virtual void traiterRelationCommentaire(RelationCommentaire *rc) {}
	//! Appel quand la sauvegarde commence.
	virtual void traiterStockage(Stockage *s) {}
	//! Appel si le noeud visit est un objet affichable.
	virtual void traiterObjetAffichable(ObjetAffichable *o){}
	
};

#endif
