/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:44 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:44 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyvue.cpp                              */
/************************************************/

#include <iostream>
#include <string>

#include <noyvue.h>
#include <noyclasse.h>
#include <noypaquetage.h>
#include <noycommentaire.h>

Vue::Vue(Noeud* pere,const string &nom):Noeud(pere,nom) {}

Vue::~Vue() {}

void 	Vue::accepter(VisiteurNoeud* v) 
{
	v->traiterVue(this);
}

bool	Vue::ajouterObjetAffichable( ObjetAffichable *o )
{
	
	if( possedeObjet( o->getedm() ) == true ) {
		return false ;
	} else {
		o->setPere( this );
		vctObjetAffichable.push_back(o);
		return true ;
	}
/*	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) && ((*it)->getedm() != o->getedm() ) ) {
		++it;
	}
	
	if (it == vctObjetAffichable.end() ) {
	
		return true;
	}
	else return false ;
*/
return true ;

}

bool	Vue::supprimerObjetAffichable( ObjetAffichable *o )
{
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end())) {
		if( *it == o ) { 
			vctObjetAffichable.erase(it);
			return true;
		}
		++it;
	}
return false ;
}

bool 	Vue::possedeObjet( void *o )
{
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while( (it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == o ) {
			return true ;
		}
		++it;
	}

return false;
}

std::vector<ObjetAffichable*> Vue::getvctObjetAffichable()
{
	return vctObjetAffichable ;
}

bool	Vue::ajouterClasse( Classe *c )
{
	ObjetAffichable	*o = new ObjetAffichable( c , 0 , 0 , 0 , 0 , false , this);
	return  ajouterObjetAffichable( o );	

}

bool	Vue::ajouterPaquetage( Paquetage *p )
{
	ObjetAffichable	*o = new ObjetAffichable( p , 0 , 0 , 0 , 0 , false , this);
	return  ajouterObjetAffichable( o );	

}

bool	Vue::ajouterRelation( Relation *r )
{
	ObjetAffichable	*o = new ObjetAffichable( r , 0 , 0 , 0 , 0 , false , this);
	return  ajouterObjetAffichable( o );	
}


bool	Vue::ajouterCommentaire( const string & c )
{
	bool		b;
	Commentaire *ca = new Commentaire( c ) ;	
	ObjetAffichable	*o = new ObjetAffichable( ca , 0 , 0 , 0 , 0 , false , this);
	b = ajouterObjetAffichable( o );	
	ca->setPere( this );
return b;
}

/**
 * Cette classe locale sert  supprimer une relation si
 * dans celle-ci apparait une classe qui est en train d'tre
 * supprime.
 */
class supprClasseVisiteur : public VisiteurNoeud{
	public:
		//! vecteur d'objet affichable
		std::vector<ObjetAffichable*> 	vctO ;
		//! pointeur sur la classe qui doit tre supprime
		Classe	*_classeAVirer ;
		//! pointeur sur vue permettant de connatre la vue courante
		Vue	*_vueCourante ;

		//! Constructeur qui initialise le paramtre  virer
		supprClasseVisiteur( Classe *c){ _classeAVirer = c; }

		//! Destructeur
		virtual ~supprClasseVisiteur(){}
		
		//! implmentation de la mthode dfinie dans le fichier noyvisiteurnoeud.h
		void traiterVue( Vue *v ) {
			_vueCourante = v ;
			std::vector<ObjetAffichable*>::iterator it;
			vctO = v->getvctObjetAffichable();

			it = vctO.begin();
			while( it != vctO.end() ) {
				( (*it)->getedm() )->accepter( this );
				++it ;
			}
		}
		
		//! implmentation de la mthode dfinie dans le fichier noyvisiteurnoeud.h
		void traiterRelation( Relation *r ) {
			if( r->getClasseSource() == _classeAVirer ) {
				_vueCourante->supprimerRelation( r );
			}

			if( r->getClasseDestination() == _classeAVirer ) {
				_vueCourante->supprimerRelation( r );
			}
		}

		void traiterClasse( Classe *c) { }
		void traiterPaquetage( Paquetage *p ) { }
};

bool	Vue::supprimerClasse( Classe *c )
{	
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == c ) {
			// on supprime la classe du vecteur d'objet affichable
			vctObjetAffichable.erase( it );
			// puis on supprime les relations ou se trouve cette classe
			accepter( new supprClasseVisiteur( c ) );
			return true;
		}
		++it;
	}
return false ;
}

bool	Vue::supprimerPaquetage( Paquetage *p )
{
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == p ) {
			vctObjetAffichable.erase( it );
			return true;
		}

		++it;
	}
return false ;
}

bool	Vue::supprimerRelation( Relation *r )
{
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == r ) {
			vctObjetAffichable.erase( it );
			return true;
		}
		++it;
	}
return false ;
}


bool	Vue::supprimerCommentaire( Commentaire *c )
{
	std::vector<ObjetAffichable*>::iterator it;
	it=vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == c ) {
			vctObjetAffichable.erase( it );
			return true;
		}	
		++it;
	}
return false ;
}

bool	Vue::ajouterRelationCommentaire( Relation *r )
{
	ObjetAffichable	*o = new ObjetAffichable( r , 0 , 0 , 0 , 0 , false , this);
	return  ajouterObjetAffichable( o );	
}

bool Vue::supprimerRelationCommentaire(Relation *r)
{
	std::vector<ObjetAffichable*>::iterator it;
	it = vctObjetAffichable.begin();
	while((it != vctObjetAffichable.end()) ) {
		if( (*it)->getedm() == r ) {
			vctObjetAffichable.erase( it );
			return true;
		}
		++it;
	}
return false ;
}

bool 	Vue::ajouterElementDeModelisation( ElementDeModelisation *e , int x , int y, int w, int h , bool visible )
{
	ObjetAffichable *o = new ObjetAffichable( e , x , y , w, h , visible , this);
	//	e->setPere( this );
	return ajouterObjetAffichable( o );
}
