#include<parparser.h>

ContexteSemantique::ContexteSemantique(ContexteSemantique *csPere,const string &nom,int type) 
	: NoeudSyntaxique(csPere,nom,type)
	{
	}

ContexteSemantique::~ContexteSemantique() {}

void ContexteSemantique::ajouterVctNS(NoeudSyntaxique *ns) {
	vctNs.push_back(ns);
	}
	
void ContexteSemantique::visiterVctNS(VisiteurNoeudSyntaxique *vns) {
	visiterVectorNoeudSyntaxique(vctNs,vns);	
	}
	
NoeudSyntaxique *ContexteSemantique::possedeVctNS(const string &s) {
	nomAppartientAuVector(vctNs,s);
	}

NoeudSyntaxique *ContexteSemantique::possedeVctNS(NoeudSyntaxique *ns) {
	nsAppartientAuVector(vctNs,ns);
	}

void ContexteSemantique::remplacerVctNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
	remplacerDansLeVector(vctNs,ns,ns2);
	}

void ContexteSemantique::supprimerVctNS(NoeudSyntaxique *ns) {
	supprimerDansLeVector(vctNs,ns);
	/*
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vctNs.begin();
	while(it != vctNs.end()) {
		if(((NoeudSyntaxique *)*it) == ns) {
			vctNs.erase(it);
			it = vctNs.begin();
			printf("Taille %d",vctNs.size());
			}
		else ++it;
		}
	*/
	}

void ContexteSemantique::ajouterNS(NoeudSyntaxique *ns) {
	ajouterVctNS(ns);
	}
	
	
void ContexteSemantique::supprimerNS(NoeudSyntaxique *ns) {
	supprimerVctNS(ns);
	}


NoeudSyntaxique *ContexteSemantique::possedeNS(const string &n) {
	return possedeVctNS(n);
	}

NoeudSyntaxique *ContexteSemantique::rechercherNS(const string &s) {
	NoeudSyntaxique *ns;
	ContexteSemantique *cs;

	cs = this;
	do
		{
		ns = cs->possedeNS(s);
		}
	while(( (cs = cs->getCsPere()) != NULL) && (ns == NULL));
	return ns;
	}

		
void ContexteSemantique::visiterNS(VisiteurNoeudSyntaxique *vns) {
	visiterVctNS(vns);
	}	

void ContexteSemantique::accepterVNS(VisiteurNoeudSyntaxique *v) {
	v->traiterContexteSemantique(this);
	}

class VnsFusion : public VisiteurNoeudSyntaxique {
		ContexteSemantique *_origine ,*_dest;
	public:
		VnsFusion(ContexteSemantique *origine,ContexteSemantique *dest) {
			_origine = origine;
			_dest = dest;
			}
			
		virtual void traiterContexteSemantique(ContexteSemantique *cs) {
			}
						
		virtual void traiterNsClasse(NsClasse *nsc) {
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsc) {
			}
			
		virtual void traiterNsMethode(NsMethode *nsm) {
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa) {
			}		
		
	};


class VnsRemplacerNoeudSyntaxique : public VisiteurNoeudSyntaxique {
		NoeudSyntaxique *_ns,*_ns2;
	public:
		VnsRemplacerNoeudSyntaxique(NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
			_ns = ns;
			_ns2 = ns2;
			}
			
		virtual void traiterContexteSemantique(ContexteSemantique *cs) {
			cs->remplacerNS(_ns,_ns2);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc) {
			nsc->remplacerNS(_ns,_ns2);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsp) {
			nsp->remplacerNS(_ns,_ns2);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm) {
			nsm->remplacerNS(_ns,_ns2);
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa) {
			nsa->remplacerNS(_ns,_ns2);
			}
	};

void ContexteSemantique::remplacerNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
	VnsRemplacerNoeudSyntaxique vns(ns,ns2);
	remplacerVctNS(ns,ns2);
	visiterNS(&vns);
	}
