#ifndef CONTEXTESEMANTIQUE_H
#define CONTEXTESEMANTIQUE_H

/**
 *Un contexte correspond  une noeud qui peut contenir 
 *des noeuds syntaxiques.
 *@author syj
 */

class ContexteSemantique : public NoeudSyntaxique {
protected:
	std::vector<NoeudSyntaxique *> vctNs;

	/**
	 *Ajoute un noeud  vctFils.
	 *@param ns le noeud  ajouter.
	 */	 
	void ajouterVctNS(NoeudSyntaxique *ns);
	
	/**
	 *Supprime un noeud syntaxique de vctFils.
	 *@param le noeud syntaxique  supprimer.
	 */
	void supprimerVctNS(NoeudSyntaxique *ns);
	
	//! Appeller accepter pour chaque NoeudSyntaxique de vctNs.
	void visiterVctNS(VisiteurNoeudSyntaxique *vns);
	
	/**
	 *Recherche d'un NoeudSyntaxique 
	 *@param s le nom du NoeudSyntaxique.
	 *@return Le NoeudSyntaxique recherch ou NULL.
	 */
	NoeudSyntaxique *possedeVctNS(const string &s);
	
	/**
	 *Recherche d'un NoeudSyntaxique 
	 *@param ns le NoeudSyntaxique.
	 *@return Le NoeudSyntaxique recherch ou NULL.
	 */
	NoeudSyntaxique *possedeVctNS(NoeudSyntaxique *ns);
	
	
	/**
	 * Remplace un noeud syntaxique par un autre.
	 * @param ns l'ancien noeud syntaxique
	 * @param ns2 le remplaant.
	 */
	void remplacerVctNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2);

public:

	ContexteSemantique(ContexteSemantique *pere,const string &nom,int type);
	virtual ~ContexteSemantique();
	
	/**
	 *Ajoute un noeud syntaxique.
	 *@param ns le noeud a ajouter.
	 */
	virtual void ajouterNS(NoeudSyntaxique *ns);
	
	/**
	 *Supprime le noeud du contexte semantique
	 *@return renvoie un booleen indiquant le reussite ou non de l'operation.
	 */
	virtual void supprimerNS(NoeudSyntaxique *ns);
	
	/**
	 *Recherche d'un NoeudSyntaxique 
	 *@param s le nom du NoeudSyntaxique.
	 *@return Le NoeudSyntaxique recherch ou NULL.
	 */
	virtual NoeudSyntaxique *possedeNS(const string &s);
	
	
	/**
	 *Recherche d'un NoeudSyntaxique recursivement.
	 *@param s le nom du NoeudSyntaxique.
	 *@return Reference du NoeudSyntaxique recherch ou NULL.
	 */
	virtual NoeudSyntaxique *rechercherNS(const string &s);
	
	/**
	 *Effectuer accepterVNS(vns) pour chacun de ses fils.
	 *@param vns le visiteur utilis.
	 */
	virtual void visiterNS(VisiteurNoeudSyntaxique *vns);
	
	/**
	 *Visiter le noeud syntaxique.
	 *@param v le visiteur
	 */
	virtual void accepterVNS(VisiteurNoeudSyntaxique *vns);

	/**
	 * Remplace un noeud syntaxique par un autre.
	 * @param ns l'ancien noeud syntaxique
	 * @param ns2 le remplaant.
	 */
	virtual void remplacerNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2);

	void getVctNs(std::vector<NoeudSyntaxique *> &vct) {vct = vctNs;}

};

#endif

