#include <parparser.h>

CsType::CsType(ContexteSemantique *pere,const Type &type)
	:ContexteSemantique(pere,string(""),-1),_t(type)
	{	
	}
			
class LVnsAjouterType : public VisiteurNoeudSyntaxique {		
	public:
		CsType *_cst;
		Type _type;
		LVnsAjouterType(CsType *cst,const Type &type) {
			_cst = cst;
			_type = type;
			}
		
		
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{
			cs->setCsPere(_cst->getCsPere());
			cs->getCsPere()->ajouterNS(cs);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{
			nsc->setCsPere(_cst->getCsPere());
			nsc->getCsPere()->ajouterNS(nsc);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsc)
			{
			nsc->setCsPere(_cst->getCsPere());	
			nsc->getCsPere()->ajouterNS(nsc);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{
			nsm->setReturnType(_type);			
			nsm->setCsPere(_cst->getCsPere());
			nsm->getCsPere()->ajouterNS(nsm);
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{
			nsa->setVarType(_type);			
			nsa->setCsPere(_cst->getCsPere());
			nsa->getCsPere()->ajouterNS(nsa);
			}		
		};
		
void CsType::ajouterNS(NoeudSyntaxique *ns) {	
	LVnsAjouterType lvns(this,_t);
	ns->accepterVNS(&lvns);
	}
	
void CsType::supprimerNS(NoeudSyntaxique *ns) {
	getCsPere()->supprimerNS(ns);
	}
	
NoeudSyntaxique *CsType::possedeNS(const string &s) {
	return getCsPere()->possedeNS(s);
	}
	
NoeudSyntaxique *CsType::rechercherNS(const string &s) {
	return getCsPere()->rechercherNS(s);
	}
	
void CsType::visiterNS(VisiteurNoeudSyntaxique *vns) {
	getCsPere()->visiterNS(vns);
	}
	
void CsType::accepterVNS(VisiteurNoeudSyntaxique *vns) {
	getCsPere()->accepterVNS(vns);
	}
