#ifndef PARCSTYPE_H
#define PARCSTYPE_H


class CsType : public ContexteSemantique {
	Type _t;
	public:
		CsType(ContexteSemantique *pere,const Type &typevar);
		
		virtual ~CsType() {}
		void ajouterVariable(const string &s);
		void ajouterMethode(const string &s,std::vector<NsAttribut *> &vctParam);
		
		/**
		 *Ajoute un noeud syntaxique.
		 *@param ns le noeud a ajouter.
		 */
		virtual void ajouterNS(NoeudSyntaxique *ns);
	
		/**
		 *Supprime le noeud du contexte semantique
		 *@return renvoie un booleen indiquant le reussite ou non de l'operation.
		 */
		virtual void supprimerNS(NoeudSyntaxique *ns);
	
		/**
		 *Recherche d'un NoeudSyntaxique 
		 *@param s le nom du NoeudSyntaxique.
		 *@return Le NoeudSyntaxique recherch ou NULL.
		 */
		virtual NoeudSyntaxique *possedeNS(const string &s);
		
		/**
		 *Recherche d'un NoeudSyntaxique recursivement.
		 *@param s le nom du NoeudSyntaxique.
		 *@return Reference du NoeudSyntaxique recherch ou NULL.
		 */
		virtual NoeudSyntaxique *rechercherNS(const string &s);
	
		/**
		 *Effectuer accepterVNS(vns) pour chacun de ses fils.
		 *@param vns le visiteur utilis.
		 */
		virtual void visiterNS(VisiteurNoeudSyntaxique *vns);
	
		/**
		 *Visiter le noeud syntaxique.
		 *@param v le visiteur
		 */
		virtual void accepterVNS(VisiteurNoeudSyntaxique *vns);
		
		/**
		 *Obtenir le type ajout
		 *@return le nom du type
		 */
		string getNomType() {return _t.getNomType();}
	};

#endif
