#include<parparser.h>

NoeudSyntaxique::NoeudSyntaxique(const NoeudSyntaxique &ns) {
	_type = ns._type;
	_csPere = ns._csPere;
	_nom = ns._nom;
	}

NoeudSyntaxique::NoeudSyntaxique(ContexteSemantique *csPere,const string &nom,int type) {
	_type = type;
	_csPere = csPere;
	_nom = nom;
	}
		
NoeudSyntaxique::~NoeudSyntaxique() {
	}

NoeudSyntaxique *NoeudSyntaxique::possedeNS(const string &s) {	
	if(s == _nom) return this;
	
	std::vector<string>::iterator it=vctAlias.begin();
	while((it != vctAlias.end()) && (*it != s)) ++it;
	if(it != vctAlias.end()) {
		return this;
		}
			
	return NULL;
	}
	
void NoeudSyntaxique::ajouterAlias(const string &s) {
	if(NoeudSyntaxique::possedeNS(s) == NULL) {
		vctAlias.push_back(s);
		}	
	}
	

	
int NoeudSyntaxique::getType() {
	return _type;
	}
	
void NoeudSyntaxique::setType(int type) {
	_type = type;
	}
	

ContexteSemantique *NoeudSyntaxique::getCsPere() {
	return _csPere;
	}
	
void NoeudSyntaxique::setCsPere(ContexteSemantique *csPere) {
	_csPere = csPere;
	}


string NoeudSyntaxique::getNom() {
	return _nom;
	}

void NoeudSyntaxique::setNom(string &nom) {
	_nom = nom;
	}
	
string NoeudSyntaxique::getNomComplet() {

	if(getCsPere() == NULL) {
		return getNom();
		}
	if(getCsPere()->getNomComplet() != "") {
		return getCsPere()->getNomComplet() + "::" + getNom();
		}
	else {
		return getNom();
		}
	}
	
	
NoeudSyntaxique *NoeudSyntaxique::nsAppartientAuVector(
			std::vector<NoeudSyntaxique *> &vct,
			NoeudSyntaxique *ns) 
	{
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vct.begin();
	while((it != vct.end()) && (*it != ns)) {
		++it;
		}
	
	if(it != vct.end()) {
		return *it;
		}
	return NULL;
	}

NoeudSyntaxique *NoeudSyntaxique::nomAppartientAuVector(
			std::vector<NoeudSyntaxique *> &vct,
			const string &s) 
	{
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vct.begin();
	while((it != vct.end()) && (((NoeudSyntaxique *)*it)->getNom() != s)) {
		++it;
		}
	
	if(it != vct.end()) {
		return (NoeudSyntaxique *)*it;
		}
	return NULL;		
	}


void NoeudSyntaxique::visiterVectorNoeudSyntaxique(
		std::vector<NoeudSyntaxique *> &vct,
		VisiteurNoeudSyntaxique *vns) 
	{
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vct.begin();
	while(it != vct.end()) {
		((NoeudSyntaxique *)*it)->accepterVNS(vns);
		++it;
		}	
	}

void NoeudSyntaxique::remplacerDansLeVector(std::vector<NoeudSyntaxique *> &vct,NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vct.begin();
	while(it != vct.end()) {
		if(((NoeudSyntaxique *)*it) == ns) {
			vct.erase(it);
			vct.push_back(ns2);
			it = vct.begin();
			}
		else ++it;
		}
	}

void NoeudSyntaxique::supprimerDansLeVector(std::vector<NoeudSyntaxique *> &vct,NoeudSyntaxique *ns) {
	std::vector<NoeudSyntaxique *>::iterator it;
	it = vct.begin();
	while(it != vct.end()) {
		if(((NoeudSyntaxique *)*it) == ns) {
			vct.erase(it);
			it = vct.begin();
			}
		else ++it;
		}
	}

