#ifndef NSATTRIBUT_H
#define NSATTRIBUT_H

class Attribut;

/**
 * NsAttribut decrit un attribut au sens UML. Cette classe fortement <br>
 * li  la classe NOYAU::Attribut car NsAttribut correspond  un adapteur <br>
 * afin que la classe Attribut puisse repondre au exigence de fonctionnement du parser.<br>
 *@author syj
 */
 
class NsAttribut : public NoeudSyntaxique {
	Type _type;
	
	Attribut *_attr;
	
public:

	/**
	 *Constructeur de recopie.
	 */
	NsAttribut(const NsAttribut &nsa);
	
	/**
	 *Construit un noeud syntaxique correspondant  un attribut. (IDENTIFIANT_ATTRIBUT)
	 *@param csPere le contexte semantique pre.
	 *@param pere le noeud pere.
	 *@param nom le nom de l'attribut.
	 */
	NsAttribut(ContexteSemantique *csPere,const string &nom,int type);
	
	virtual ~NsAttribut();
	
	/**
	 *Visiter le noeud syntaxique.
	 *@param v le visiteur
	 */
	 virtual void accepterVNS(VisiteurNoeudSyntaxique *v);		
	
	
	/**
	 *Affiche le nom complet de l'attribut.
	 *@return Renvoie le nom de complet de la classe.
	 */
	virtual string getNomComplet();

	/**
	 * Remplace un noeud syntaxique par un autre.
	 * @param ns l'ancien noeud syntaxique
	 * @param ns2 le remplaant.
	 */
	virtual void remplacerNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2); 

	/** 
	 *Definit le type de cette attribut.
	 *@param t le nouveau type.
	 */
	void setVarType(const Type &t);
		
	/**
	 *Obtenir le type de cette attribut.
	 *@return le type.
	 */
	Type getVarType();
		
	//! Definir l'attribut associ.
	void setAttribut(Attribut *attr);
	
	//! Obtenir l'attribut associ.	
	Attribut *getAttribut();	
};

#endif

