#include<parparser.h>


NsMethode::NsMethode(ContexteSemantique *csPere ,const string &nom,int type) 
	: ContexteSemantique(csPere,nom,type)
	{
	_methode = NULL;
	_Abstract = false;
	}
	
NsMethode::~NsMethode() {
	}


void NsMethode::accepterVNS(VisiteurNoeudSyntaxique *v) {
	v->traiterNsMethode(this);
	}
	
class VnsAjouterNsAttribut : public VisiteurNoeudSyntaxique {
	ContexteSemantique *_cs;
	std::vector<NsAttribut *> *_vct;
	public:
		
	VnsAjouterNsAttribut(ContexteSemantique *cs,std::vector<NsAttribut *> *vct) {
		_cs = cs;
		_vct =vct;
		}
		
	void traiterNsAttribut(NsAttribut *nsa) {
		NsAttribut *copie;
		copie = new NsAttribut(*nsa);
		copie->setCsPere(NULL);
		_vct->push_back(copie);
		}
	};

void NsMethode::ajouterParametre(ContexteSemantique *cs) {
	vctParametre.erase(vctParametre.begin(),vctParametre.end());
	VnsAjouterNsAttribut vns(this,&vctParametre);
	cs->visiterNS(&vns);
	}


std::vector<NsAttribut *>::iterator NsMethode::itBeginParametre() {
	return vctParametre.begin();
	}
	
bool NsMethode::atEndParametre(const std::vector<NsAttribut *>::iterator &it) {
	return (it == vctParametre.end());
	}


void NsMethode::setReturnType(const Type &t) {	
	_type = t;
	}
	
Type NsMethode::getReturnType() {
	return _type;
	}
	
string NsMethode::getNomComplet() {
	std::vector<NsAttribut *>::iterator it; 
	string sParam("");
	it = vctParametre.begin();
	
	if(it != vctParametre.end()) {
		sParam += ((NsAttribut *)*it)->getNomComplet();
		++it;
		}
	while(it != vctParametre.end()) {
		sParam += string(",") + ((NsAttribut *)*it)->getNomComplet();
		++it;
		}
	
	sParam = string("(") + sParam + string(")");
	
	string nomComplet(NoeudSyntaxique::getNomComplet());	
	return _type.getNomType() + string(" ") + nomComplet + sParam;
	}

void NsMethode::setMethode(Methode *methode) {
	_methode = methode;
	}
		
Methode *NsMethode::getMethode() {
	return _methode;
	}

bool NsMethode::getAbstract() {
	return _Abstract;
	}

void NsMethode::setAbstract(bool bAbstract) {
	_Abstract = bAbstract;
	}

void NsMethode::remplacerNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
	Type t;
	if(_type.getNs() == ns) _type = Type(ns2);
	
	std::vector<NsAttribut *>::iterator it; 
	it = vctParametre.begin();
	if(it != vctParametre.end()) {
		((NsAttribut *)*it)->remplacerNS(ns,ns2);
		}
	}
