#include<parparser.h>
#include<noynoyau.h>
#include<noyprojet.h>
#include<noyvisiteurnoeud.h>
#include<parvnsexportnoyau.h>
#include<noyheritage.h>
#include<stdio.h>

ErreurParser erreur;

class MonVisiteur : public VisiteurNoeud {
		string indent;
		int i;

	public:
		MonVisiteur(){i=0;}
		virtual ~MonVisiteur(){}
		void traiterProjet(Projet *p) {
			cout << indent << p->getNom() +" --auteur: " +p->getAuteur() +" --version: " +p->getVersion() +" --commentaire: " +p->getCommentaire() << endl;
			indent+= string("  ");
			(p->getDiagrammeStatique())->accepter(this);
			string s = string(indent,indent.size()-1);
			indent = s;

			}

		void traiterDiagrammeStatique(DiagrammeStatique *dg) {
			cout << indent << "DG:" << indent << dg->getNom() << endl;
			indent+= string("  ");
			dg->visiterFils(this);
			string s = string(indent,indent.size()-1);
			indent = s;

			}

		void traiterVue(Vue *v){
		}
				
		void traiterPaquetage(Paquetage *p) {
			cout << indent << "P:" << p->getNom() << endl;
			indent+= string("  ");			
			p->visiterObjetuml(this);
			string s = string(indent,indent.size()-1);
			indent = s;

		}
		
		void traiterClasse(Classe *c) {
			cout << indent << "C:" <<  c->getNomComplet() << endl;
			indent+= string("  ");						
			c->visiterFils(this);
			string s = string(indent,indent.size()-1);
			indent = s;
		}
		
		void traiterAttribut(Attribut *a) {
			cout << indent << "A:" << a->grandeChaine() << endl;
		}
		
		void traiterMethode(Methode *m) {
			cout << indent << "M:" << m->grandeChaine() << endl;
		}
		
		void traiterHeritage(Heritage *h) {
			cout << indent << h->getNom() << endl;
		}
};

ParserCpp::ParserCpp(Noyau *n) {
	_noyau = n;
	_cs = new ContexteSemantique(NULL,"",-1);
	_sErreur = string("");
	}
	
ParserCpp::~ParserCpp() {
	cout << "Appelle du destructeur ParserCpp" << endl;
	}


void ParserCpp::setFichierSource(const std::vector<string> &vct) {
	vctFichierSource = vct;
	}

void ParserCpp::getFichierSource(std::vector<string> &vct) {
	vct = vctFichierSource;
	}


	
bool ParserCpp::lancer() {
	std::vector<string>::iterator it;
	string fileName;
	ContexteSemantique *csFinal;
	
	pileCS.push(_cs);
	
	it = vctFichierSource.begin();
	while(it != vctFichierSource.end()) {
		cppExecuterParser((string)*it); 
		++it;
		}
	/*
	if(vctFichierSource.size() > 1) {
		FILE *f = fopen("/tmp/gcc.in","w");
		if(f == NULL) {
			cerr << "ERREUR lors de l'ouverture de /tmp/gcc.in" << endl;
			return false;
			}
	
		it = vctFichierSource.begin();	
		while(it != vctFichierSource.end()) {		
			fileName = *it;
			fprintf(f,"#include<%s>\n",fileName.c_str());
			++it;
			}
		cppExecuterParser(string("/tmp/gcc.in"));
		}
	else if(vctFichierSource.size() == 1)  cppExecuterParser(fileName); 
	*/
	
	cout << "Je suis ici!" << endl;	
	VnsExportNoyau vnsen(_noyau,(_noyau->getProjet())->getDiagrammeStatique(),_cs);
	_cs->accepterVNS(&vnsen);
	
	
	cout << "...Affichage du contenu du noyau" << endl;
	MonVisiteur mvisiteur;
	(_noyau->getProjet())->accepter(&mvisiteur);
	
	
	return true;
	}
