#ifndef PARPARSERCPP_H
#define PARPARSERCPP_H

class Noyau;

/**
 * ParserCpp correspond  la classe qui doit tre instanci pour effectuer l'analyse
 * d'une liste de fichier source.
 * A la cration de l'instance, le parser doit avoir connaissance du noyau.
 *@author syj
 */
class ParserCpp {
	private:
		std::vector<string> vctFichierSource;
		Noyau *_noyau;
		ContexteSemantique *_cs;
		string _sErreur;		
	public:
		
		ParserCpp(Noyau *n);
		virtual ~ParserCpp();
		
		/**
		 *Definir une liste des fichiers sources qui doivent tre analys.
		 *@param vct contient la nouvelle liste des fichiers sources.
		 */
		void setFichierSource(const std::vector<string> &vct);
		
		/**
		 *Obtenir la liste des fichiers sources.
		 *@param vct est affecter avec la liste des fichiers que contient le programme.
		 */
		void getFichierSource(std::vector<string> &vct);
	
		/**
		 * Lancer l'operation de parsing.<br>
		 * Note: Dans l'implementation actuel on ne peut lancer qu'un seul parser
		 *        la fois.
		 */
		bool lancer();
	};
#endif

