#ifndef PARPARSERJAVA_H
#define PARPARSERJAVA_H

class Noyau;

/**
 * ParserJava correspond  la classe qui doit tre instanci pour effectuer l'analyse
 * d'une liste de fichier source java.
 *@author syj
 */
class ParserJava {
	private:
		std::vector<string> vctFichierSource;		
		Noyau *_noyau;
		ContexteSemantique *_cs;
		string _sErreur;		
	public:
		static std::vector<string> listeClassPath;
		
		ParserJava(Noyau *n);
		virtual ~ParserJava();
		
		/**
		 *Definir une liste des fichiers sources qui doivent tre analys.
		 *@param vct contient la nouvelle liste des fichiers sources.
		 */
		void setFichierSource(const std::vector<string> &vct);
		
		/**
		 *Obtenir la liste des fichiers sources.
		 *@param vct est affecter avec la liste des fichiers que contient le programme.
		 */
		void getFichierSource(std::vector<string> &vct);
	
		/**
		 * Lancer l'operation de parsing.<br>
		 * Note: Dans l'implementation actuel on ne peut lancer qu'un seul parser
		 *        la fois.
		 */
		bool lancer();
	};
#endif

