%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <parparser.h>
#include <parsersyncpp.tab.h>

extern int cppparse();

int ligne;
int brace;
int parenthese;


%}

%x ET_COMMENTAIRE

/* 
 * Cette etat est utilise lorsque l'on rencontre l'initialisation d'une variable
 * Dans ce cas, on ignore tout ce qui est compris entre le '{' jusqu' la prochaine
 * de meme niveau '}'.
 */
%x ET_METHODE

/* 
 * Cette etat est utilise lorsque l'on rencontre l'initialisation d'une variable
 * Dans ce cas, on ignore tout ce qui est compris entre le '=' jusqu' la prochaine
 * ',' ou ';'.
 */
%x ET_VAR_INIT

/* 
 * Cette etat est utilise lorsque l'on rencontre l'initialisation des parametres d'une methode
 * Dans ce cas, on ignore tout ce qui est compris entre le '=' jusqu' la prochaine ',' ou ';'.
 */
%x ET_PARAM_INIT
%%
"typedef struct _pthread_descr_struct *_pthread_descr;"	{/* Ignore */}
"__extension__"	{/* ignor */}

"#"[^\n]*\n	{cout << "Balise gcc" << endl;ligne++;}

"namespace"	{return KW_namespace;}

"class"	{return KW_class;}
"struct"	{return KW_struct;}
"union"	{return KW_union;}

"using"	{return KW_using;}

"::"	{return KW_22points;}
extern\ +\"C\"	{return KW_EXTERN_C;}

"typedef"	{return KW_typedef;}

"public"	{return KW_public;}

"private"	{return KW_private;}

"protected"	{return KW_protected;}

"=0;"		{return KW_AbstractMethode;}
"extern"	{/*ignore*/}
"static"	{/*ignore*/}
"virtual"	{/*ignore*/}

("unsigned"\ +|"signed"\ +)?"long"\ +"long"\ +"int"?	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
("unsigned"\ +|"signed"\ +)?"long"\ +"int"?	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
("unsigned"\ +|"signed"\ +)?"short"\ +"int"?	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
("unsigned"\ +|"signed"\ +)?"int"	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
("unsigned"\ +|"signed"\ +)?"char"	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
"float"	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
"long"{0,2}\ +"double"	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}
"void"	{cpplval.identifiant.text=cpptext;cpplval.identifiant.taille=strlen(cpptext);return KW_type;}

"while"	{return KW_while;}

"for"	{return KW_for;}

"if"	{return KW_if;}

"else"	{return KW_else;}

"return"	{return KW_return;}

"#include"\ *"<"	{return KW_include;}

"#ifndef"	{return KW_ifndef;}

"#ifdef"	{return KW_ifdef;}

"#define"	{return KW_define;}

"#endif"	{return KW_endif;}

"/*"	{
		BEGIN(ET_COMMENTAIRE);
		}

[_a-zA-Z][a-zA-Z0-9_]* {
	NoeudSyntaxique *ns;
	ns = (NoeudSyntaxique *)pileCS.top()->rechercherNS(string(cpptext));
	if(ns == NULL) {
		cpplval.identifiant.text = cpptext;
		cpplval.identifiant.taille = strlen(cpptext);
		return UNDEF_IDENTIFIANT;
		}
	else {
		cout << cpptext << " est du type " << ns->getType() << endl;		
		if(ns->getType() == KW_type) {
			cpplval.identifiant.text = (char*)(ns->getNom()).c_str();
			cpplval.identifiant.taille = (ns->getNom()).size();
			return KW_type;
			}
		else 
			{
			cpplval.ns = ns;
			return ns->getType();
			}
	     }
	}

"*"|"="|":"|"{"|"}"|";"|","|"("|")"	{
	return (char)cpptext[0];
	}

" "|"\t"	{}

"\n"	{ligne++;}

<ET_COMMENTAIRE>"\n"	{ligne++;}
<ET_COMMENTAIRE>[^*]	{}					
<ET_COMMENTAIRE>"*"[^/]	{}					
<ET_COMMENTAIRE>"*/"	{BEGIN(INITIAL);}


<ET_METHODE,ET_VAR_INIT,ET_PARAM_INIT>"\n"	{ligne++;}
<ET_METHODE,ET_VAR_INIT,ET_PARAM_INIT>"("	{++parenthese;}
<ET_METHODE,ET_VAR_INIT,ET_PARAM_INIT>")"	{--parenthese;}
<ET_METHODE,ET_VAR_INIT,ET_PARAM_INIT>"{"	{++brace;}
<ET_VAR_INIT,ET_PARAM_INIT>"}"	{--brace;}
<ET_VAR_INIT>";"|","	{
			if((parenthese == 0) && (brace == 0)) {
				cout << "fin ignorerInitVar" << endl;
				BEGIN(INITIAL);
				return cpptext[0];
				}
			}	
<ET_PARAM_INIT>","|")"	{
			if((parenthese == 0) && (brace == 0)) {
				cout << "fin ignorerInitParam" << endl;
				BEGIN(INITIAL);
				return cpptext[0];
				}
			}
<ET_METHODE>"}"	{
			--brace;
			if(brace == 0) {
				BEGIN(INITIAL);
				return '}';
				}
			}
					
<ET_METHODE,ET_VAR_INIT,ET_PARAM_INIT>.	{/* Ignor */}

%%

extern FILE *callGcc(char **lParam,const char *fileName);

bool cppExecuterParser(const string &s) {
	FILE *oldcppin;
	oldcppin = cppin;
	
	char *lParam[2];
	lParam[0] = (char *)"-I.";
	lParam[1] = (char *)NULL;
	
	cppin = callGcc((char **)lParam,s.c_str());
	
	if(cppin == NULL) {
		perror("ouverture d'un fichier source");		
		erreur.text = string(sys_errlist[sys_nerr]);
		return false;
		}

	cout << "On lance le parser pour le fichier " << s.c_str() << endl;
	ligne = 1;
	cppparse();
	cout << "Fin de l'analyse" << endl;
	fclose(cppin);
	cppin = oldcppin;
	return true;
	}

void cppIgnorerBrace() {
	brace = 1;
	BEGIN(ET_METHODE);	
	}
	
void cppIgnorerInitVar() {
	cout << "debut ingorerInitVar" << endl;
	parenthese=0;
	brace = 0;
	BEGIN(ET_VAR_INIT);
	}
	
void cppIgnorerInitParam() {
	cout << "debut ignorerInitParam" << endl;
	parenthese=0;
	brace=0;
	BEGIN(ET_PARAM_INIT);
	}

int yywrap ( void ) {
	cout << "---- YYWRAP CPP ----" << endl;
	return 1;	
	}
