%{
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include <parparser.h>

#define CONF_TEST

PileCS pileCS;

void cpperror (char *s)
	{
	string sLigne;
	char cpLigne[15];
	istream in;
	cerr << s << "  la ligne " << ligne << endl;
	snprintf(cpLigne,15,"%d",ligne);
	erreur.text = string(s) + string("  la ligne ") + string(cpLigne) ;
	}

extern int cpplex();
extern FILE *cppin;

class AfficheurArbreSyntaxique : public VisiteurNoeudSyntaxique {
	public:
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{
				cout << "cs:" << cs->getNomComplet() << endl;
				cs->visiterNS(this);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{
				cout << "nsc:" << nsc->getNomComplet() << endl;
				nsc->visiterNS(this);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsp)
			{
				cout << "nsp:" << nsp->getNomComplet() << endl;
				nsp->visiterNS(this);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{
				cout << "nsm:" << nsm->getNomComplet() << endl;		
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{
				cout << "nsa:" << nsa->getNomComplet() << endl;
			}
	};

%}

%union {
	ContexteSemantique *cs;
	NsClasse *nsc;
	NsPaquetage *nsp;
	NsMethode *nsm;
	NoeudSyntaxique *ns;
	Type *type;
	Chaine identifiant;
	void *contexte;
	unsigned int val;
	}

%token END_OF_FILE
%token UNDEF_IDENTIFIANT	/* Identifiant */
%token IDENTIFIANT_NAMESPACE    /* Identifiant correspondant  un espace de nommage */
%token IDENTIFIANT_CLASS	/* Identifiant correspondant  une classe */
%token IDENTIFIANT_METHODE      /* Identifiant correspondant  une methode */ 
%token IDENTIFIANT_ATTRIBUT     /* Identifiant correspondant  un attribut */

/* Mot cl C++ */
%token KW_namespace
%token KW_class
%token KW_struct
%token KW_union
%token KW_using
%token KW_22points

/* Mot cl indiquant la visibilit */
%token KW_public
%token KW_private
%token KW_protected

/* Identifiant de type */
%token KW_type
%token KW_typedef

%token KW_AbstractMethode	/* =0; aprs la l'en-tete d'un methode dans une classe. */


/* Instructions de controle */
%token KW_while
%token KW_for
%token KW_if
%token KW_else
%token KW_return

/* Instruction du macroprocessor */
%token KW_include
%token KW_ifndef
%token KW_define
%token KW_ifdef
%token KW_endif
%token KW_extern
%token KW_EXTERN_C

%type <type> TYPE
%type <type> NOM_TYPE
%type <identifiant> UNDEF_IDENTIFIANT,KW_type
%type <ns> IDENTIFIANT_METHODE,IDENTIFIANT_ATTRIBUT
%type<nsp> IDENTIFIANT_NAMESPACE,UNDEF_IDENTIFIANT_OU_NAMESPACE
%type<nsc> IDENTIFIANT_CLASS
%type<nsm> PATH_IDENTIFIANT_METHODE
%type<nsc> NOUVEL_IDENTIFIANT_CLASS,PATH_IDENTIFIANT_CLASS
%type <val> VISIBILITE_HERITAGE
%type <val> LIST_DEFERENCEMENT
%type <cs> CONTEXTE_SEMANTIQUE

%%

CPPFILE: END_OF_FILE {
					}
	| 	      {
			  cout << "CPPFILE -> CORP_DECLARATIF" << endl;
			}
			CORP_DECLARATIF 
				{
					AfficheurArbreSyntaxique vns;
					pileCS.top()->accepterVNS(&vns);
				}
	;


CORP_DECLARATIF: KW_namespace UNDEF_IDENTIFIANT_OU_NAMESPACE 
		{
		pileCS.push($2);
		}
	'{' CORP_DECLARATIF '}'
		{
		// Retour au pere.
		pileCS.pop();
		}
	APRES_CORP_DECLARATIF
	| DECLARATION APRES_CORP_DECLARATIF {}
	| KW_DECLARATION_CLASS ';' 
		{
		// Retour au pere.
		pileCS.pop();
		}
	APRES_CORP_DECLARATIF

	| DECLARATION APRES_CORP_DECLARATIF {}
	| KW_EXTERN_C '{' CORP_DECLARATIF '}' CORP_DECLARATIF
	| KW_typedef KW_type LIST_DEFERENCEMENT UNDEF_IDENTIFIANT ';'
		{
		NoeudSyntaxique *ns;
		ns = new NoeudSyntaxique(pileCS.top(),string($4.text,$4.taille),UNDEF_IDENTIFIANT);
		ns->setType(KW_type);
		pileCS.top()->ajouterNS(ns);
		}
	CORP_DECLARATIF
	| KW_typedef PATH_IDENTIFIANT_CLASS UNDEF_IDENTIFIANT ';'
		{
		$2->ajouterAlias(string($3.text,$3.taille));
		}
	| error ';'
			{
			printf("CORP_DECLARATIF -> error\n");
			}
	;

LIST_ALIAS_OPT: /* Epsilon */
	| UNDEF_IDENTIFIANT LIST_ALIAS
		{
		pileCS.top()->ajouterAlias(string($1.text,$1.taille));
		}
	;

LIST_ALIAS: /* Epsilon */
	| ',' UNDEF_IDENTIFIANT LIST_ALIAS
		{
		pileCS.top()->ajouterAlias(string($2.text,$2.taille));
		}
	;
	
KW_DECLARATION_CLASS: 
	KW_class NOUVEL_IDENTIFIANT_CLASS 
			{
			pileCS.push($2);
			}
	OPT_DESCRIPTION_CLASS
	| KW_typedef KW_struct OPT_NOUVEL_IDENTIFIANT_CLASS
		{
		((NsClasse *)pileCS.top())->setVisibilite(DF_PUBLIC);
		}
	OPT_DESCRIPTION_STRUCT LIST_ALIAS_OPT
	| KW_struct OPT_NOUVEL_IDENTIFIANT_CLASS
		{
		((NsClasse *)pileCS.top())->setVisibilite(DF_PUBLIC);
		}	
	OPT_DESCRIPTION_STRUCT LIST_ALIAS_OPT
	;


OPT_DESCRIPTION_CLASS:
	| HERITE_DE '{' APRES_CORP_DECLARATIF_CLASS '}' LIST_ALIAS_OPT
	;

OPT_DESCRIPTION_STRUCT: /* Epsylon */
	| '{' APRES_CORP_DECLARATIF_CLASS '}'
	;

OPT_NOUVEL_IDENTIFIANT_CLASS:
		{
		pileCS.push(new NsClasse(pileCS.top(),string(""),IDENTIFIANT_CLASS));
		}
	| NOUVEL_IDENTIFIANT_CLASS
		{
		pileCS.push($1);
		}
	HERITE_DE
	;


APRES_CORP_DECLARATIF:	
	| CORP_DECLARATIF	{/* Nouvelle entre dans le corp dclaratif */}
	;


CORP_DECLARATIF_CLASS: 
	KW_DECLARATION_CLASS ';' 
		{
		// Retour au pere.
		pileCS.pop();
		}
	APRES_CORP_DECLARATIF_CLASS
	| DECLARATION APRES_CORP_DECLARATIF_CLASS
	| KW_public ':' {
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PUBLIC);		
		}
		APRES_CORP_DECLARATIF_CLASS
	| KW_protected ':' {
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PROTECTED);				
		}
		APRES_CORP_DECLARATIF_CLASS		
	| KW_private ':' {
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PRIVATE);						
		}
		APRES_CORP_DECLARATIF_CLASS
	| error ';' APRES_CORP_DECLARATIF
		{
		printf("CORP_DECLARATIF_CLASS -> error\n");
		}
	;

APRES_CORP_DECLARATIF_CLASS:
	| CORP_DECLARATIF_CLASS
	;

HERITE_DE: {
		}
	| ':' DECLARE_HERITAGE HERITE_DE_V{
		}
	;


HERITE_DE_V: {
		}
	| ',' DECLARE_HERITAGE HERITE_DE_V {
		}
	;

DECLARE_HERITAGE: VISIBILITE_HERITAGE PATH_IDENTIFIANT_CLASS
		{
			((NsClasse *)pileCS.top())->ajouterClasseMere((NsClasse *)$2,$1);
		}
	;

VISIBILITE_HERITAGE: KW_public	{$$ = DF_PUBLIC;}
	| KW_protected	{$$ = DF_PROTECTED;}
	| KW_private	{$$ = DF_PRIVATE;}
	|	{$$ = DF_PRIVATE;}
	;


/*- Zone traitant de la declaration d'une variable -*/
DECLARATION:
	TYPE
		{
		cout << "Le type:" << $1->getNomType() << endl;
		pileCS.push(new CsType(pileCS.top(),*$1));
		}
	DECL_METHODE_OU_VARIABLE
		{
		pileCS.pop();
		}
	
DECL_METHODE_OU_VARIABLE:
	LIST_DECL_IDENTIFIANT ';'
	| PATH_IDENTIFIANT_METHODE '(' 
		{
		cout << "C'est une methode " << $1->getNom() << endl;
		pileCS.top()->ajouterNS($1);
		pileCS.push($1);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));
		}
	PARAM_LIST_OPT ')'
		{
		ContexteSemantique *cs;
		AfficheurArbreSyntaxique aas;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		}
	CORP_OU_POINT_VIRGULE
		{
		pileCS.pop();
		cout << "Fin de traitement de la methode" << endl;
		}
	;

PARAM_LIST_OPT:
	/* Epsylon */
	| PARAM_LIST
	;

PARAM_LIST_OPT_SUIVANT:
	/* Epsylon */
	| ',' PARAM_LIST
	;

PARAM_LIST: 
	TYPE 
		{
		pileCS.push(new CsType(pileCS.top(),*$1));
		}
	NOUVELLE_VARIABLE INIT_OPT_PARAM
		{
		pileCS.pop();
		}
	PARAM_LIST_OPT_SUIVANT
	;

INIT_OPT_PARAM:
	'='
		{
		cppIgnorerInitParam();
		}
	| /* Epsilon */
	;

CORP_OU_POINT_VIRGULE:
	'{'
		{
		cppIgnorerBrace();
		}
	'}'
	| ';'
	| KW_AbstractMethode
		{
		NsMethode *nsm = (NsMethode *)pileCS.top();
		nsm->setAbstract(true);
		}
	;
	
TYPE: NOM_TYPE LIST_DEFERENCEMENT
		{
		if($2 != 0) {
			cout << "nb def:" << $2 << endl;
			$1->setDeferencement($2);	
			}
		$$ = $1;
		}
	;

LIST_DEFERENCEMENT: '*' LIST_DEFERENCEMENT 
		{
		$$ = $2 + 1;
		}
	| /* Epsylon */	
		{
		$$ = 0;
		}
	;

NOM_TYPE: KW_type	
		{
		$$ = new Type(string($1.text,$1.taille));
		cout << "Le type est " << string($1.text,$1.taille) << endl;
		}
	| PATH_IDENTIFIANT_CLASS
		{
		$$ = new Type($1);
		cout << "Le type est une classe " << $1->getNomComplet() << endl; 
		}
	;

LIST_DECL_IDENTIFIANT:
	NOUVELLE_VARIABLE NOUVELLE_VARIABLE_INIT_OPT
	| LIST_DECL_IDENTIFIANT ',' LIST_DECL_IDENTIFIANT
	;

NOUVELLE_VARIABLE_INIT_OPT:
	'='
		{cppIgnorerInitVar();}
	| /* Epsilon */
	;

NOUVELLE_VARIABLE: 
	UNDEF_IDENTIFIANT 
		{
		/* On ajoute cette identifiant  la liste */
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_ATTRIBUT));
		cout << "Ajout d'une variable." << endl;
		}
	| IDENTIFIANT_ATTRIBUT	
		{
		cout << "Attention(l:" << ligne << "): " << $1->getNom() << " est dj utilis dans ce scope pour l'attribut " << $1->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_METHODE	
		{
		cout << "Attention(l:" << ligne << "): " << $1->getNom() << " est dj utilis dans ce scope pour la methode " << $1->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_CLASS
		{
		cout << "Attention(l:" << ligne << "): " << $1->getNom() << " est dj utilis dans ce scope pour la classe " << $1->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_NAMESPACE
		{
		cout << "Attention(l:" << ligne << "): " << $1->getNom() << " est dj utilis dans ce scope pour l'espace de nommage " << $1->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}				
	;			
/*----------------------------------*/

UNDEF_IDENTIFIANT_OU_NAMESPACE: 
	UNDEF_IDENTIFIANT
		{
		$$ = new NsPaquetage(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_NAMESPACE);
		pileCS.top()->ajouterNS($$);
		}
	| IDENTIFIANT_NAMESPACE
		{
		$$ = $1;
		}
	;

CONTEXTE_SEMANTIQUE:
	IDENTIFIANT_NAMESPACE
		{
		$$ = $1;
		}
	| IDENTIFIANT_CLASS
		{
		$$ = $1;
		}
	;

NOUVEL_IDENTIFIANT_CLASS: 
	UNDEF_IDENTIFIANT
		{
		$$ = new NsClasse(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_CLASS);
		pileCS.top()->ajouterNS($$);
		}
	| CONTEXTE_SEMANTIQUE KW_22points
		{
		pileCS.push($1);
		}
	NOUVEL_IDENTIFIANT_CLASS
		{
		pileCS.pop();
		$$ = $4;
		}
	;

PATH_IDENTIFIANT_CLASS:
	IDENTIFIANT_CLASS
		{
		$$ = (NsClasse *)$1;
		}
	| CONTEXTE_SEMANTIQUE KW_22points
		{
		pileCS.push($1);
		}
	PATH_IDENTIFIANT_CLASS
		{
		pileCS.pop();
		$$= $4;
		}
	;

PATH_IDENTIFIANT_METHODE:
	UNDEF_IDENTIFIANT
		{
		$$ = new NsMethode(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_METHODE);
		}
	| IDENTIFIANT_METHODE
		{
		$$ = (NsMethode *)$1;
		}
	| CONTEXTE_SEMANTIQUE KW_22points
		{
		pileCS.push($1);
		}
	PATH_IDENTIFIANT_METHODE
		{
		pileCS.pop();
		$$ = $4;
		}
	;
%%

