%{
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include <parparser.h>


//#define YYDEBUG 1

NsPaquetage *nspMisc;

ContexteSemantique *javaRacine;

void javaerror (char *s)
	{
	string sLigne;
	char cpLigne[15];
	istream in;
	cerr << "JAVAERROR:" << s << "  la ligne " << ligne << " dans le fichier " << pileImport.top().getFichierCourant() << endl;
	snprintf(cpLigne,15,"%d",ligne);
	erreur.text = string(s) + string("  la ligne ") + string(cpLigne) ;
	}

extern int javalex();
extern FILE *javain;

NoeudSyntaxique *trouverNoeudSyntaxique(string lieu,const string &sRecherche) {
			unsigned int id;
			NoeudSyntaxique *ns = pileCS.top();
			string s;
			id =0;
			while(id < lieu.size()) {
				while((id < lieu.size()) && (lieu[id] != '.')) id++;
				s = string(lieu.c_str(),id);
				ns = ns->possedeNS(s);
				
				if(ns == NULL) {
						return NULL;
						}
				if(id < lieu.size()) {
					s = string(lieu,id + 1);
					lieu = s;
					id = 0;	
					}
				}
			return ns->possedeNS(sRecherche);
			}



class AfficheurArbreSyntaxiqueJava : public VisiteurNoeudSyntaxique {
	private:
		NoeudSyntaxique *trouverNoeudSyntaxique(string lieu,const string &sRecherche) {
			unsigned int id;
			NoeudSyntaxique *ns = pileCS.top();
			string s;
			id =0;
			while(id < lieu.size()) {
				while((id < lieu.size()) && (lieu[id] != '.')) id++;
				s = string(lieu.c_str(),id);
				ns = ns->possedeNS(s);
				
				if(ns == NULL) {
						return NULL;
						}
				if(id < lieu.size()) {
					s = string(lieu,id + 1);
					lieu = s;
					id = 0;	
					}
				}
			return ns->possedeNS(sRecherche);
			}
	public:
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{
				cout << "cs:" << cs->getNomComplet() << endl;
				cs->visiterNS(this);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{
				cout << "nscjava:" << nsc->getNomComplet() << endl;
				nsc->visiterNS(this);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsp)
			{
				nsp->visiterNS(this);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{
			}
	};

%}

%union {
	ContexteSemantique *cs;
	NsClasse *nsc;
	NsPaquetage *nsp;
	NsMethode *nsm;
	NsAttribut *nsa;
	NoeudSyntaxique *ns;
	Type *type;
	Chaine identifiant;
	void *contexte;
	unsigned int val;
	}

%token END_OF_FILE
%token IDENTIFIANT_NONDEF	/* Identifiant */
%token IDENTIFIANT_PAQUETAGE    /* Identifiant correspondant  un espace de nommage */
%token IDENTIFIANT_CLASS	/* Identifiant correspondant  une classe */
%token IDENTIFIANT_METHODE      /* Identifiant correspondant  une methode */ 
%token IDENTIFIANT_ATTRIBUT     /* Identifiant correspondant  un attribut */

/* Mot cl Java */
%token KW_package
%token KW_import
%token KW_class
%token KW_abstract
%token KW_final
%token KW_implements
%token KW_extends
%token KW_interface
%token KW_tableau


/* Mot cl indiquant la visibilit */
%token KW_public
%token KW_private
%token KW_protected

/* Identifiant de type */
%token KW_type
%type<identifiant> IDENTIFIANT_NONDEF,KW_type
%type<nsp> IDENTIFIANT_PAQUETAGE,PATH_PAQUETAGE,PAQUETAGE
%type<nsc> IDENTIFIANT_CLASS,NOM_LONG_CLASSE_MERE,DEC_CLASS,IDENTIFIANT_CLASS
%type<val> VISIBILITE_OPT
%type <type> TYPE
%type<nsm> NOUVEL_IDENTIFIANT_METHODE,IDENTIFIANT_METHODE
%type<nsa> IDENTIFIANT_ATTRIBUT

%%

JAVAFILE: END_OF_FILE 
	|
		{
		cout << "CORP_DECLARATIF_OPT" << endl;
		nspMisc = new NsPaquetage(pileCS.top(),"_Inconnue",IDENTIFIANT_PAQUETAGE);
		pileCS.top()->ajouterNS(nspMisc);
		javaRacine = pileCS.top();
		//yydebug = 1;
		}
	CORP_DECLARATIF
		{
		AfficheurArbreSyntaxiqueJava vns;
		cout << "JAVAFILE -> FIN" << endl;
		cout << "pileCS=" << pileCS.size() << endl;
		while(pileCS.size() > 1) pileCS.pop();


		NoeudSyntaxique *ns = NULL;
		std::vector<NoeudSyntaxique *> vctNsc;
		nspMisc->getVctNs(vctNsc);
		std::vector<NoeudSyntaxique *>::iterator itc = vctNsc.begin();
		while(itc != vctNsc.end()) {
			NsClasse *nsc = ((NsClasse *)*itc);
			cout << "Non declare : " << nsc->nomCode << endl;
			std::vector<string>::iterator it=nsc->currentImport.begin();
			while((it != nsc->currentImport.end()) && (ns == NULL)) {
				ns = trouverNoeudSyntaxique((string)*it,nsc->nomCode);
				if(ns != NULL) {
					cout << "cool" << endl;
					}
				else
					{
					++it;
					}
				}
			if( ns != NULL) {
				nspMisc->supprimerNS(nsc);
				pileCS.top()->remplacerNS(nsc,ns);
				}
			++itc;
			}


		
		pileCS.top()->accepterVNS(&vns);
		}
	;


DEC_CLASS: IDENTIFIANT_CLASS	{
		$1->declare = true;
		$$ = $1;
		}
	| IDENTIFIANT_NONDEF {
		NsClasse *nsc;
		nsc = new NsClasse(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_CLASS);	
		nsc->declare = true;
		$$ = nsc;
		}
	;

OPT_PT_VIRGULE: /* Epsilon */
	| ';'
	;

CORP_DECLARATIF: VISIBILITE_OPT ABSTRACT_OPT KW_class DEC_CLASS 
		{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS($4);
		pileCS.push($4);
		}
	HERITE_DE IMPLEMENTE '{' CORP_DECLARATIF_CLASS '}' OPT_PT_VIRGULE
		{
		pileCS.pop();
		}
	CORP_DECLARATIF
	| VISIBILITE_OPT KW_interface DEC_CLASS 
		{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS($3);
		pileCS.push($3);
		}
	HERITE_DE_INTERFACE '{' CORP_DECLARATIF_CLASS '}' OPT_PT_VIRGULE
		{
		pileCS.pop();
		}
	CORP_DECLARATIF
	| KW_package PATH_PAQUETAGE ';'
		{
		// Ce placer dans ce contexte pour tous les ajouts.
		pileCS.pop();
		pileCS.push($2);
		
		int id=0;
		string s,d;
		s = $2->getNomComplet();
		d = "";
		while(id < s.size()) {
			if(s[id] == ':') {
				d += '.';
				id++;
				id++;
				}
			else {
				d += s[id];	
				id++;
				}
			}
		pileImport.top().ajouterImport(d);
		}
	CORP_DECLARATIF
	| /* Epsylon */
	;

CORP_DECLARATIF_CLASS: VISIBILITE_OPT ABSTRACT_OPT KW_class DEC_CLASS 
		{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS($4);
		pileCS.push($4);
		
		}
	HERITE_DE IMPLEMENTE '{' CORP_DECLARATIF_CLASS '}' OPT_PT_VIRGULE
		{
		pileCS.pop();
		}
	CORP_DECLARATIF_CLASS
	| VISIBILITE_OPT KW_interface DEC_CLASS 
		{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS($3);
		pileCS.push($3);
		}
	HERITE_DE_INTERFACE '{' CORP_DECLARATIF_CLASS '}' OPT_PT_VIRGULE
		{
		pileCS.pop();
		}
	CORP_DECLARATIF_CLASS
	| PREC_DECLARATION CORP_DECLARATIF_CLASS
	| /* Epsylon */
	;

PREC_DECLARATION: VISIBILITE_OPT TYPE 
		{
		NsClasse *nsc=(NsClasse *)pileCS.top();
		nsc->setVisibilite($1);
		pileCS.push(new CsType(pileCS.top(),*$2));	
		}
	DECL_METHODE_OU_VARIABLE
		{
		pileCS.pop();
		}
	;

DECL_METHODE_OU_VARIABLE: LIST_DECL_IDENTIFIANT ';'
	| NOUVEL_IDENTIFIANT_METHODE '('
		{
		pileCS.push($1);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));
		}
	PARAM_LIST_OPT ')' OPT_TABLEAU
		{
		ContexteSemantique *cs;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		}
	CORP_OU_POINT_VIRGULE
		{
		pileCS.top()->getCsPere()->ajouterNS(pileCS.top());
		pileCS.pop();
		}
	| '('
		{
		// Declaration d'un constructeur.
		NsMethode *nsm;
		CsType *cst = (CsType *)pileCS.top();
		nsm = new NsMethode(pileCS.top()->getCsPere(),cst->getNomType(),IDENTIFIANT_METHODE);
		pileCS.push(nsm);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));	
		}
	PARAM_LIST_OPT ')'
		{
		ContexteSemantique *cs;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		}
	CORP_OU_POINT_VIRGULE
		{
		// Struct pile : NsClasse,CsType,NsMethode
		// il faut appeller directement ajouterNS sur NsClasse pour eviter d'ajouter un type
		// de retour au constructeur.
		pileCS.top()->getCsPere()->getCsPere()->ajouterNS(pileCS.top());
		pileCS.pop();
		}
	;

/*------ Propre  la declaration d'une methode --------*/
PARAM_LIST_OPT:
	/* Epsylon */
	| PARAM_LIST
	;

PARAM_LIST_OPT_SUIVANT:
	/* Epsylon */
	| ',' PARAM_LIST
	;

PARAM_LIST: 
	TYPE 
		{
		pileCS.push(new CsType(pileCS.top(),*$1));
		}
	NOUVELLE_VARIABLE INIT_OPT_PARAM
		{
		pileCS.pop();
		}
	PARAM_LIST_OPT_SUIVANT
	;

INIT_OPT_PARAM:
	'='
		{
		javaIgnorerInitParam();
		}
	| /* Epsilon */
	;

CORP_OU_POINT_VIRGULE:
	'{'
		{
		javaIgnorerBrace();
		}
	'}'
	| ';'
		{
		NsMethode *nsm = (NsMethode *)pileCS.top();
		nsm->setAbstract(true);
		}
	;

NOUVEL_IDENTIFIANT_METHODE:
	IDENTIFIANT_NONDEF
		{
		$$ = new NsMethode(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_METHODE);
		}
	| IDENTIFIANT_METHODE
		{
		$$ = new NsMethode(pileCS.top(),$1->getNom(),IDENTIFIANT_METHODE);
		}
	| IDENTIFIANT_CLASS
		{
		$$ = new NsMethode(pileCS.top(),$1->getNom(),IDENTIFIANT_METHODE);
		}
	| IDENTIFIANT_PAQUETAGE
		{
		$$ = new NsMethode(pileCS.top(),$1->getNom(),IDENTIFIANT_METHODE);
		}
	| IDENTIFIANT_ATTRIBUT
		{
		$$ = new NsMethode(pileCS.top(),$1->getNom(),IDENTIFIANT_METHODE);
		}
	;

/*------ Fin Propre  la declaration d'une methode --------*/

/*------ Propre  la declaration d'un attribut --------*/
LIST_DECL_IDENTIFIANT:
	NOUVELLE_VARIABLE NOUVELLE_VARIABLE_INIT_OPT
	| LIST_DECL_IDENTIFIANT ',' LIST_DECL_IDENTIFIANT
	;

NOUVELLE_VARIABLE_INIT_OPT:
	'='
		{javaIgnorerInitVar();}
	| /* Epsilon */
	;
/*------ Fin Propre  la declaration d'un attribut --------*/


/*------ Partie communne  la declaration d'une methode et d'un attribut --------*/
NOUVELLE_VARIABLE: 
	IDENTIFIANT_NONDEF OPT_TABLEAU 
		{
		/* On ajoute cette identifiant  la liste */
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_ATTRIBUT OPT_TABLEAU
		{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_METHODE OPT_TABLEAU	
		{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_CLASS OPT_TABLEAU
		{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	| IDENTIFIANT_PAQUETAGE OPT_TABLEAU
		{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),$1->getNom(),IDENTIFIANT_ATTRIBUT));
		}
	;

TYPE: KW_type OPT_TABLEAU
		{
		$$ = new Type(string($1.text,$1.taille));
		}
	| NOM_LONG_CLASSE_MERE OPT_TABLEAU
		{
		$$ = new Type($1);
		}
	;

OPT_TABLEAU: KW_tableau OPT_TABLEAU
	| /* Epsylon */
	;
/*------ Fin Partie communne  la declaration d'une methode et d'un attribut --------*/

VISIBILITE_OPT: KW_public	{$$ = DF_PUBLIC;}
	| KW_protected		{$$ = DF_PROTECTED;}
	| KW_private		{$$ = DF_PRIVATE;}
	| /* Epsilon */		{$$ = DF_PRIVATE;}
	;


HERITE_DE_INTERFACE: KW_extends LISTE_NOM_LONG_CLASSE_MERE
	| /* Epsilon */
	;

HERITE_DE: KW_extends NOM_LONG_CLASSE_MERE
		{
		NsClasse *nsc;
		nsc = (NsClasse *)pileCS.top();
		nsc->ajouterClasseMere($2,DF_PUBLIC);	
		}
	|  /* Epsilon */
	;

IMPLEMENTE: KW_implements LISTE_NOM_LONG_CLASSE_MERE
	| /* Epsilon */
	;

LISTE_NOM_LONG_CLASSE_MERE: NOM_LONG_CLASSE_MERE
		{
		NsClasse *nsc;
		nsc = (NsClasse *)pileCS.top();
		nsc->ajouterClasseMere($1,DF_PUBLIC);	
		}
	| LISTE_NOM_LONG_CLASSE_MERE ',' LISTE_NOM_LONG_CLASSE_MERE
	;

NOM_LONG_CLASSE_MERE: IDENTIFIANT_CLASS
		{
		// Identifiant de classe.
		$$ = $1;
		}
	| IDENTIFIANT_NONDEF
		{
		NsClasse *nsc = new NsClasse(nspMisc,string($1.text,$1.taille),IDENTIFIANT_CLASS);
		nspMisc->ajouterNS(nsc);
		pileImport.top().getCurrentImport(nsc->currentImport);
		$$ = nsc;
		}
	| PAQUETAGE '.'
		{
		// Changer de contexte.
		pileCS.push($1);
		}
	NOM_LONG_CLASSE_MERE
		{
		// Remonter NOM_LONG_CLASSE_MERE.
		if($4->declare == false) {$4->nomCode = pileCS.top()->getNom() + string(".") + $4->nomCode;}
		pileCS.pop();
		$$ = $4;
		}
	| IDENTIFIANT_CLASS '.'
		{
		// Changer de contexte.
		pileCS.push($1);
		}
	NOM_LONG_CLASSE_MERE
		{
		// Remonter NOM_LONG_CLASSE_MERE.
		if($4->declare == false) {$4->nomCode = pileCS.top()->getNom() + string(".") + $4->nomCode;}
		pileCS.pop();
		$$ = $4;
		}
	;


PATH_PAQUETAGE: PAQUETAGE
		{
		$$=$1;
		}
	| PAQUETAGE
		{
		pileCS.push($1);	
		}
	'.' PATH_PAQUETAGE
		{
		pileCS.pop();
		$$ = $4;
		}
	;


PAQUETAGE: IDENTIFIANT_NONDEF
		{
		NsPaquetage *nsp;
		nsp = new NsPaquetage(pileCS.top(),string($1.text,$1.taille),IDENTIFIANT_PAQUETAGE);
		pileCS.top()->ajouterNS(nsp);
		$$ = nsp;
		}
	| IDENTIFIANT_PAQUETAGE
		{
		$$ = $1;
		}
	;

ABSTRACT_OPT: KW_abstract
	| /* Epsilon */
	;
%%



