#include<parparser.h>
#include<parvnsexportnoyau.h>
#include<noynoyau.h>
#include<noydiagrammestatique.h>
#include<noyclasse.h>
#include<noypaquetage.h>
#include<noyheritage.h>

class VnsAjoutHeritage : public VisiteurNoeudSyntaxique {
	private:
		NsClasse *_fille;
	public:
		VnsAjoutHeritage(NsClasse *fille) {
			_fille = fille;
			}
			
		void traiterNsClasse(NsClasse *nsc) {
			if(nsc->getClasse() == NULL) {
				cerr << "Attention: " << _fille->getNomComplet() << " herite de " << nsc->getNomComplet() << " mais elle ne possede pas de classe associ en UML." << endl;
				}
			else {
				((Classe *)_fille->getClasse())->ajouterRelation("Herite de " + nsc->getNomComplet(),
										REL_HERITAGE,
										_fille->getClasse(),
										nsc->getClasse(),
										string(""),
										string(""));
				}
			}
		
	};

VnsExportNoyau::VnsExportNoyau(Noyau *noyau,DiagrammeStatique *diagrammeStatique,ContexteSemantique *contextesemantique) {
	cout << "Appelle du constructeur de VnsExportNoyau." << endl;
	n = noyau;	
	dg = diagrammeStatique;
	cs = contextesemantique;
	cls = NULL;
	paq = NULL;
	}

void VnsExportNoyau::traiterContexteSemantique(ContexteSemantique *cs) {
	cout << "traiterContexteSemantique: " << cs->getNomComplet() << endl;
	// L'unique contexte semantique que l'on doit rencontr c'est celui du projet.	
	
	paq = new Paquetage(dg,string("Import"));
	dg->ajouterObjetuml(paq);
	cout << (int)paq << endl;
	cs->visiterNS(this);	
	
	}

void VnsExportNoyau::traiterNsClasse(NsClasse *nsc) {
	cout << "traiterNsClasse: " << nsc->getNomComplet() << endl;
	Classe *precCls;
	precCls = cls;
	paq->ajouterObjetuml((cls = new Classe(paq,nsc->getNom(),string(""),true)));
	nsc->setClasse(cls);
	
	VnsAjoutHeritage *vns = new VnsAjoutHeritage(nsc);
	nsc->visiterClasseMere(vns);
	delete vns;	
			
	nsc->visiterNS(this);
	cls = precCls;
	}

void VnsExportNoyau::traiterNsPaquetage(NsPaquetage *nsp) {
	cout << "traiterNsPaquetage: " << nsp->getNomComplet() << endl;
	Paquetage *ptmp;

	ptmp = new Paquetage(paq,nsp->getNom());	
	paq->ajouterObjetuml(ptmp);
	paq = ptmp;
	nsp->visiterNS(this);
	paq = (Paquetage *)paq->getPere();

	}

void VnsExportNoyau::traiterNsMethode(NsMethode *nsm) {
	cout << "traiterNsMethode: " << nsm->getNomComplet() << endl;	
	if(cls != NULL)
		{
		NsClasse *nsc = (NsClasse *)nsm->getCsPere();
		string visibilite;
		
		switch(nsc->getVisibilite()) {
			case DF_PUBLIC:
				visibilite = string("+");
				break;
			case DF_PROTECTED:
				visibilite = string("#");
				break;
			case DF_PRIVATE:
				visibilite = string("-");
				break;
			}
		std::vector<Parametre *> vctParametre;			
		
		
		std::vector<NsAttribut *>::iterator it;
		it = nsm->itBeginParametre();
		while(nsm->atEndParametre(it) == false) {
			Parametre *param = new Parametre();
			NsAttribut *nsa;
			nsa = ((NsAttribut *)*it);			
			param->setType(nsa->getVarType().getNomType());
			param->setNom(nsa->getNom());
			vctParametre.push_back(param);
			++it;
			}
		 
		Type t= nsm->getReturnType();
		string s = t.getNomType();
		string snom = nsm->getNom();
		cls->ajouterMethode(snom ,s,visibilite,vctParametre);
		}
	}

void VnsExportNoyau::traiterNsAttribut(NsAttribut *nsa) {
	cout << "traiterNsAttribut: " << nsa->getNomComplet() << endl;
	if(cls != NULL)
		{
		NsClasse *nsc = (NsClasse *)nsa->getCsPere();
		string visibilite;
		
		switch(nsc->getVisibilite()) {
			case DF_PUBLIC:
				visibilite = string("+");
				break;
			case DF_PROTECTED:
				visibilite = string("#");
				break;
			case DF_PRIVATE:
				visibilite = string("-");
				break;
			}
		cls->ajouterAttribut(nsa->getVarType().getNomType(),nsa->getNom(),visibilite);
		}	
	}

